
InitCubeCtrl proc hInst:HINSTANCE
	
	invoke	LoadCursor,NULL,IDC_ARROW
	movc	edx,0
	;we will alloc CUBE_WNDEXTRA bytes in WndExtra to save ptr to structure that will hold all the data of the control window
	RegClass CS_HREDRAW or CS_VREDRAW,offset RCubeWndProc,edx,CUBE_WNDEXTRA,hInst,edx,eax,\
			COLOR_BTNFACE+1,edx,offset CubeClass,edx
	ret

InitCubeCtrl endp

CreateCubeCtrl proc hParentWnd:HWND,hInst:HINSTANCE,lpWndRect:LPVOID
	
	mov		ecx,lpWndRect
	assume ecx:ptr RECT
	mov		eax,[ecx].right
	mov		edx,[ecx].bottom
	sub		eax,[ecx].left
	sub		edx,[ecx].top
	invoke	CreateWindowEx,NULL,offset CubeClass,NULL,WS_VISIBLE or WS_CHILD,\
				[ecx].left,[ecx].top,eax,edx,hParentWnd,NULL,hInst,NULL
	assume ecx:nothing
	ret

CreateCubeCtrl endp

RCubeWndProc proc hWin:HWND,iMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,iMsg
	.if eax==WM_PAINT
		invoke	RCubePaint,hWin
	.elseif eax==RCM_GETCOLORS
		invoke	GetWindowLong,hWin,GWL_LPCUBE
		invoke	GetCubeColors,lParam,eax
	.elseif eax==RCM_SETCOLORS
		invoke	GetWindowLong,hWin,GWL_LPCUBE
		invoke	SetCubeColors,eax,lParam
		.if wParam
			invoke	InvalidateRect,hWin,NULL,TRUE
			invoke	UpdateWindow,hWin
		.endif
	.elseif eax==RCM_GETSTATE
		invoke	GetWindowLong,hWin,GWL_LPCUBE
		invoke	GetCubeState,eax,lParam
	.elseif eax==RCM_SETSTATE
		invoke	GetWindowLong,hWin,GWL_LPCUBE
		invoke	SetCubeState,eax,lParam
		.if wParam
			invoke	InvalidateRect,hWin,NULL,TRUE
			invoke	UpdateWindow,hWin
		.endif
	;reaction of cube control to mouse actions:
	;Right Click - context menu for the current square/cubelet
	;Ctrl+Left Click - rotate counter clockwise
	;Ctrl+Right Click - rotate clockwise
	;
	.elseif eax==WM_LBUTTONDOWN
		invoke	GetWindowLong,hWin,GWL_LPCUBE
		mov		edx,lParam
		mov		(RCC_CUBE ptr [eax]).lBtnDown,edx
	.elseif eax==WM_RBUTTONDOWN
		invoke	GetWindowLong,hWin,GWL_LPCUBE
		mov		edx,lParam
		mov		(RCC_CUBE ptr [eax]).rBtnDown,edx
	.elseif eax==WM_LBUTTONUP
		invoke	GetWindowLong,hWin,GWL_LPCUBE
		mov		edx,lParam
		mov		(RCC_CUBE ptr [eax]).lBtnUp,edx
		invoke	RCubeMouseUp,hWin,eax,wParam,edx,FALSE
	.elseif eax==WM_RBUTTONUP
		invoke	GetWindowLong,hWin,GWL_LPCUBE
		mov		edx,lParam
		mov		(RCC_CUBE ptr [eax]).rBtnUp,edx
		invoke	RCubeMouseUp,hWin,eax,wParam,edx,TRUE
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		.if eax>=IDM_ROTCBCW && eax<=IDM_ADDR
			invoke	RCubeMenu,hWin,eax
		.endif
;the following code is for resizable control
;	.elseif eax==WM_SIZE
;		;make RECT struct in stack
;		sub		esp,sizeof RECT
;			invoke	GetClientRect,hWin,esp
;			invoke	GetWindowLong,hWin,GWL_LPCUBE
;			.if eax
;				mov		edx,esp
;				push	eax
;					push	eax
;						invoke	CalcRubicsCube,edx,eax
;					call	DestroyRegions
;				call	MakeRegions
;				;invoke	MakeRegions,eax
;			.endif
;		;release RECT struct from stack
;		add		esp,sizeof RECT
	.elseif eax==WM_CREATE
		invoke	RCubeCreate,hWin
		.if eax	;if no mem allocated in process heap or another error then return -1
			movc	eax,-1	;return -1 to abort window creation because can't continue w/o heap memory
			jmp		@ret
		.endif
	.elseif eax==WM_DESTROY
		invoke	RCubeDestroy,hWin
	.else
		mov		eax,dword ptr [DefWindowProc+2]
		mov		esp,ebp
		mov		eax,[eax]
		pop		ebp
		jmp		eax
		;invoke DefWindowProc,hWin,uMsg,wParam,lParam
		;ret
	.endif
	xor		eax,eax
@ret:
	ret

RCubeWndProc endp

RCubePaint proc uses ebx esi edi hWin:DWORD
	LOCAL	ps:PAINTSTRUCT
	LOCAL	nSideNum:DWORD
	LOCAL	nCubeletNum:DWORD
	LOCAL	nOldColor:DWORD
	LOCAL	nOldTextAlign:DWORD
	LOCAL	nOldMode:DWORD
	LOCAL	hOldFont:HANDLE
	LOCAL	szNum[4]:BYTE
	LOCAL	hSideBrush[6]:HBRUSH

	invoke	GetWindowLong,hWin,GWL_LPCUBE
	movc	ecx,NULL
	xchg	eax,edi
	mov		hOldFont,ecx	;NULL
	lea		edx,ps
	mov		dword ptr [szNum],ecx	;szNum=""
	invoke	BeginPaint,hWin,edx	;addr ps
	;create solid brushes for colors of all 6 sides of the cube
	push	edi
		lea		esi,hSideBrush
		movc	ebx,0
		lea		edi,(RCC_CUBE ptr [edi]).rgbSide
		add		bl,5
		.while !SIGN?
			invoke	CreateSolidBrush,dword ptr [edi+ebx*sizeof RGBQUAD]
			mov		[esi+ebx*sizeof HBRUSH],eax
			dec		ebx
		.endw
	;pop		edi
	;assume	edi:ptr RCC_CUBE
	mov		edi,[esp]
	;draw all squares on the control
	;push	edi
		.if Setts.bSets & fSHOWNUM
			mov		eax,(RCC_CUBE ptr [edi]).dwFontHeight
			movc	ecx,NULL
			invoke	CreateFont,eax,ecx,ecx,ecx,FW_NORMAL,ecx,ecx,ecx,ecx,ecx,ecx,ecx,ecx,offset szArial	;ANSI_CHARSET,ecx,ecx,DEFAULT_QUALITY,DEFAULT_PITCH or FF_DONTCARE,offset szArial
			invoke	SelectObject,ps.hdc,eax
			mov		hOldFont,eax
			invoke	SetBkMode,ps.hdc,TRANSPARENT
			mov		nOldMode,eax
			invoke	SetTextAlign,ps.hdc,TA_CENTER
			mov		nOldTextAlign,eax
			invoke	SetTextColor,ps.hdc,00000000h	;black
			mov		nOldColor,eax
		.endif
		movc	eax,0
		add		edi,offset RCC_CUBE.RccSide;[edi].RccSide
		assume	edi:ptr RCC_SQR
		mov		nCubeletNum,eax	;nCubeletNum=0
		lea		ebx,[edi+(9*6*sizeof RCC_SQR)]
		mov		nSideNum,eax	;nSideNum=0
		.repeat
			mov		edx,[edi].hRgn
			mov		eax,[edi].rgbSqr;.sqrInfo.rgbSqr
			invoke	FillRgn,ps.hdc,edx,dword ptr [esi+eax*sizeof HBRUSH]
			.if hOldFont
				;mov		szNum,"F"
				mov		eax,nCubeletNum
				.if al<8
					mov		dl,"0"
					add		dl,al
				.else
					mov		edx,nSideNum
					mov		ecx,offset cSideChars
					movc	eax,-1
					mov		dl,[edx+ecx]
					inc		nSideNum
				.endif
				lea		ecx,szNum
				inc		eax
				mov		[ecx],dl	;szNum,dl
				mov		nCubeletNum,eax
				invoke	TextOut,ps.hdc,[edi].ptText.x,[edi].ptText.y,ecx,1
			.endif
			add		edi,sizeof RCC_SQR
		.until edi>=ebx
		mov		eax,hOldFont
		.if eax
			invoke	SelectObject,ps.hdc,eax
			invoke	DeleteObject,eax
			invoke	SetBkMode,ps.hdc,nOldMode
			invoke	SetTextAlign,ps.hdc,nOldTextAlign
			invoke	SetTextColor,ps.hdc,nOldColor
		.endif
	;pop		edi
	;draw all black lines
	assume	edi:ptr RCC_CUBE
	mov		edi,[esp]
	;push	edi
		invoke	CreatePen,PS_SOLID,[edi].dwPenSize,00000000h	;black color
		invoke	SelectObject,ps.hdc,eax
		push	eax
			drawcube
		push	ps.hdc
		call	SelectObject
		invoke	DeleteObject,eax
	pop		edi
	invoke	EndPaint,hWin,addr ps
	;delete created brushes
	lea		esi,hSideBrush
	movc	ebx,0
	add		bl,5
	.while !SIGN?
		invoke	DeleteObject,dword ptr [esi+ebx*sizeof HBRUSH]
		dec		ebx
	.endw
	ret

	assume esi:nothing
	assume edi:nothing
RCubePaint endp

;if bRightButton==FALSE then left button was pressed else right button was pressed
RCubeMouseUp proc uses ebx esi edi hWin:HWND,lpCube:LPVOID,wParam,lParam,bRightButton:DWORD
	LOCAL	dwResult:DWORD
	LOCAL	ClickUp:DWORD
	LOCAL	ClickDown:DWORD

	mov		ebx,lpCube
	movc	ecx,0
	mov		eax,bRightButton
	assume ebx:ptr RCC_CUBE
	mov		dwResult,ecx	;dwResult=FALSE
	.if eax
		;if the click's coords are -1 or the click was not in one of the regions
		;then don't do anything 
		mov		eax,[ebx].rBtnDown
		cmp		eax,NOOFFSET
		je		@ret
			mov		edx,eax
			shr		edx,16
			and		eax,0000FFFFh
			invoke	CubeletFromPoint,ebx,eax,edx
			cmp		eax,NOOFFSET
			je		@ret
				mov		[ebx].rBtnDown,eax
				mov		ClickDown,eax
				mov		eax,lParam
				cmp		eax,NOOFFSET
				je		@ret
					mov		edx,eax
					shr		edx,16
					and		eax,0000FFFFh
					invoke	CubeletFromPoint,ebx,eax,edx
					cmp		eax,NOOFFSET
					je		@ret
						mov		[ebx].rBtnUp,eax
						mov		ClickUp,eax
	.else
		;if the click's coords are -1 or the click was not in one of the regions
		;then don't do anything 
		mov		eax,[ebx].lBtnDown
		cmp		eax,NOOFFSET
		je		@ret
			mov		edx,eax
			shr		edx,16
			and		eax,0000FFFFh
			invoke	CubeletFromPoint,ebx,eax,edx
			cmp		eax,NOOFFSET
			je		@ret
				mov		[ebx].lBtnDown,eax
				mov		ClickDown,eax
				mov		eax,lParam
				cmp		eax,NOOFFSET
				je		@ret
					mov		edx,eax
					shr		edx,16
					and		eax,0000FFFFh
					invoke	CubeletFromPoint,ebx,eax,edx
					cmp		eax,NOOFFSET
					je		@ret
						mov		[ebx].lBtnUp,eax
						mov		ClickUp,eax
	.endif
	;mov		eax,ClickUp
	;if ClickUp == ClickDown
	.if eax==ClickDown
		;if Ctrl+Click within one square
		.if wParam & MK_CONTROL
			call	StopRec
			invoke	RotateCubelet,ebx,eax,bRightButton
			mov		dwResult,eax
			test	eax,eax
			jnz		@Update
;			.if eax!=NOOFFSET
;				call	@Update
;			.endif
		.else
			;if Right Click within one square
			.if bRightButton
				;show the respective context menu
				invoke	RCubeContextMenu,hWin,ebx,ClickDown
			.endif
		.endif
	.else
		;if Ctrl+Drag then move/exchange cubelets
		.if wParam & MK_CONTROL
			call	StopRec
			invoke	MoveCubelet,ebx,ClickDown,eax;ClickUp
			mov		dwResult,eax
			test	eax,eax
			jnz		@Update
;			.if eax
;				call	@Update
;			.endif
		;else try to rotate side
		.else
			invoke	RotateSide,ebx,ClickDown,eax;ClickUp
			mov		dwResult,eax
			test	eax,eax
			jnz		@Update
;			.if eax
;				call	@Update
;			.endif
		.endif
	.endif
@ret:
	movc	eax,NOOFFSET
	;now reset all coords
	mov		[ebx].lBtnDown,eax
	mov		[ebx].lBtnUp,eax
	mov		[ebx].rBtnDown,eax
	mov		[ebx].rBtnUp,eax
	return	dwResult

@Update::
	mov		ecx,dword ptr [InvalidateRect+2]
	mov		edx,dword ptr [UpdateWindow+2]
	mov		eax,hWin
	mov		ecx,[ecx]
	mov		edx,[edx]
	push	eax		;hWin
	push	offset @ret
		push	TRUE
		push	NULL
		push	eax		;hWin
		push	edx
		jmp		ecx
;	invoke	InvalidateRect,hWin,NULL,TRUE
;	invoke	UpdateWindow,hWin
;	retn

	assume ebx:nothing
	assume esi:nothing
	assume edi:nothing
RCubeMouseUp endp

RCubeContextMenu proc uses ebx esi edi hWin:HWND,lpCube:LPVOID,ofsCube:DWORD
	LOCAL	szCubeAddr[64]:BYTE

	mov		ebx,lpCube
	assume ebx:ptr RCC_CUBE
	invoke	GetCursorPos,addr [ebx].ptCursPos
	invoke	SetForegroundWindow,hWin
	mov		eax,ofsCube
	movc	edx,0
	mov		ecx,sizeof RCC_SQR
	div		ecx
	movc	edx,0
	mov		ecx,9
	div		ecx
	push	eax
	push	edx
		cld
		movc	ecx,-1
		movc	edx,0
		test	eax,eax
		mov		edi,offset szSideNames
		xchg	edx,eax
		.while !ZERO?
			repne	scasb
			dec		edx
		.endw
	pop		edx
	pop		eax
	mov		ecx,offset cSideChars
	lea		esi,szCubeAddr
	mov		cl,[ecx+eax]
	.if edx!=8	;if not middle square then show normal menu
		invoke	wsprintf,esi,offset msAddr,eax,edi,ecx,edx
		invoke	ModifyMenu,[ebx].hCubeletMnu,IDM_ADDR,MF_BYCOMMAND or MF_STRING,IDM_ADDR,esi
		invoke	TrackPopupMenuEx,[ebx].hCubeletMnu,TPM_LEFTALIGN,[ebx].ptCursPos.x,[ebx].ptCursPos.y,hWin,NULL
	.else
		invoke	wsprintf,esi,offset msSideName,edi,ecx
		invoke	ModifyMenu,[ebx].hMiddleMenu,IDM_ADDR,MF_BYCOMMAND or MF_STRING,IDM_ADDR,esi
		invoke	TrackPopupMenuEx,[ebx].hMiddleMenu,TPM_LEFTALIGN,[ebx].ptCursPos.x,[ebx].ptCursPos.y,hWin,NULL
	.endif
	;invoke	PostMessage,hWin,WM_NULL,NULL,NULL
	ret

	assume ebx:nothing
	assume esi:nothing
	assume edi:nothing
RCubeContextMenu endp

RCubeMenu proc uses ebx esi edi hWin:HWND,wParam:DWORD
	LOCAL	ofsCube:DWORD
	LOCAL	dwResult:DWORD

	invoke	GetWindowLong,hWin,GWL_LPCUBE
	movc	dwResult,0
	xchg	eax,ebx
	assume ebx:ptr RCC_CUBE
	mov		edx,[ebx].ptCursPos.x
	mov		eax,[ebx].ptCursPos.y
	.if edx!=-1 && eax!=-1
		invoke	ScreenToClient,hWin,addr [ebx].ptCursPos
		invoke	CubeletFromPoint,ebx,[ebx].ptCursPos.x,[ebx].ptCursPos.y
		.if eax!=NOOFFSET
			mov		edx,wParam
			mov		ofsCube,eax
			.if edx==IDM_ROTCBCW
				invoke	RotateCubelet,ebx,eax,TRUE
				mov		dwResult,eax
			.elseif edx==IDM_ROTCBCCW
				invoke	RotateCubelet,ebx,eax,FALSE
				mov		dwResult,eax
			.elseif edx==IDM_MOVCB
				mov		edx,4
				call	@NextSqr
				invoke	MoveCubelet,ebx,ofsCube,eax
				mov		dwResult,eax
			.elseif edx==IDM_ROTCW
				movc	edx,1
				call	@NextSqr
				invoke	RotateSide,ebx,ofsCube,eax
			.elseif edx==IDM_ROTCCW
				movc	edx,-1
				call	@NextSqr
				invoke	RotateSide,ebx,ofsCube,eax
			.elseif edx==IDM_SIDCLR
				mov		ecx,sizeof RCC_SIDE
				movc	edx,0
				div		ecx
				invoke	GetColorDlg,hWin,addr [ebx].rgbSide[eax*sizeof RGBQUAD]
			.endif
			;clear coords from .ptCursPos
			.if eax
				invoke	InvalidateRect,hWin,NULL,TRUE
				invoke	UpdateWindow,hWin
			.endif
		.endif
		movc	ecx,-1
		mov		[ebx].ptCursPos.x,ecx
		mov		[ebx].ptCursPos.y,ecx
	.endif
	return dwResult

;EAX - ofsSrc
;EDX - squares to advance
				;nthSqr=ofsCube/sizeof RCC_SQR
				;nthSideSqr=nthSqr MOD 9
				;nthSide -= nthSideSqr
				;nthSideSqr = (nthSideSqr + 4) and 7
				;nthSqr += nthSideSqr
				;ofsCube = nthSqr * sizeof RCC_SQR
@NextSqr:
	push	edx
		mov		ecx,sizeof RCC_SQR
		movc	edx,0
		div		ecx
		mov		edi,sizeof RCC_SIDE / sizeof RCC_SQR
		push	eax
			movc	edx,0
			div		edi
		pop		eax
	pop		ecx
	lea		esi,[edx+ecx]
	sub		eax,edx
	and		esi,07h
	mov		ecx,sizeof RCC_SQR
	add		eax,esi
	mul		ecx
	retn

	assume ebx:nothing
	assume esi:nothing
	assume edi:nothing
RCubeMenu endp

;if -1 returned then error creating else return 0
RCubeCreate proc uses ebx esi edi hWin:DWORD
	LOCAL	rcClient:RECT
	LOCAL	clrSide:DWORD

	invoke	GetProcessHeap
	push	eax
		invoke	SetWindowLong,hWin,GWL_HEAP,eax
	pop		eax
	invoke	HeapAlloc,eax,HEAP_ZERO_MEMORY,sizeof RCC_CUBE+16	;+16 for memory alignment
	.if !eax	;if no mem allocated in process heap
		dec		eax	;movc	eax,-1	;return -1 to abort window creation because can't continue w/o heap memory
	.else
		xchg	eax,edi
		assume edi:ptr RCC_CUBE
		;store ptr to memory for future use with HeapFree
		invoke	SetWindowLong,hWin,GWL_MEM,edi
		alignValueMin edi,16	;align structure in memory to 16 byte address
		invoke	SetWindowLong,hWin,GWL_LPCUBE,edi
		lea		esi,rcClient
		invoke	GetClientRect,hWin,esi
		invoke	CalcRubicsCube,esi,edi
		;set up default Rubik's Cube coloring
		invoke	SetCubeColors,edi,offset DefColors
		;fill coords with -1
		movc	eax,-1
		mov		[edi].lBtnDown,eax
		mov		[edi].lBtnUp,eax
		mov		[edi].rBtnDown,eax
		mov		[edi].rBtnUp,eax
		;now we need to create real regions based on the coordinates
		invoke	MakeRegions,edi
		mov		esi,edi
		assume esi:ptr RCC_CUBE
		;create context menus
		invoke	CreatePopupMenu
		mov		[esi].hCubeletMnu,eax
		mov		edi,offset msRotCbCW
		mov		ebx,IDM_ROTCBCW
		.repeat
			invoke	AppendMenu,[esi].hCubeletMnu,MF_STRING,ebx,edi
			;point to next menu item string
			movc	ecx,-1
			movc	eax,0
			cld
			repne	scasb
			inc		ebx
		.until ebx>=IDM_ROTCBCW+6
		invoke	AppendMenu,[esi].hCubeletMnu,MF_SEPARATOR,NULL,NULL
		invoke	AppendMenu,[esi].hCubeletMnu,MF_STRING,IDM_ADDR,offset msEmpty
		;create menu for middle square
		invoke	CreatePopupMenu
		mov		[esi].hMiddleMenu,eax
		mov		edi,offset msRotCW
		mov		ebx,IDM_ROTCW
		.repeat
			invoke	AppendMenu,[esi].hMiddleMenu,MF_STRING,ebx,edi
			;point to next menu item string
			movc	ecx,-1
			movc	eax,0
			cld
			repne	scasb
			inc		ebx
		.until ebx>=IDM_ROTCW+3
		invoke	AppendMenu,[esi].hMiddleMenu,MF_SEPARATOR,NULL,NULL
		invoke	AppendMenu,[esi].hMiddleMenu,MF_STRING,IDM_ADDR,offset msEmpty
		movc	eax,0
	.endif
	ret

	assume esi:nothing
	assume edi:nothing
RCubeCreate endp

GetCubeColors	proc uses esi edi lpColors,lpCube:DWORD
	
	mov		edx,lpCube
	assume edx:ptr RCC_CUBE
	mov		edi,lpColors
	movc	ecx,0
	lea		esi,[edx].rgbSide
	mov		cl,6
	cld
	rep		movsd
	ret

	assume edx:nothing
GetCubeColors endp


SetCubeColors	proc uses esi edi lpCube,lpColors:DWORD
	
	mov		edx,lpCube
	assume edx:ptr RCC_CUBE
	mov		esi,lpColors
	movc	ecx,0
	lea		edi,[edx].rgbSide
	mov		cl,6
	cld
	rep		movsd
	ret

	assume edx:nothing
SetCubeColors endp

GetCubeState proc uses ebx esi edi lpCube,lpState:DWORD
	
	mov		esi,lpCube
	mov		edi,lpState
	assume esi:ptr RCC_CUBE
	lea		esi,[esi].RccSide
	assume esi:ptr RCC_SIDE
	assume edi:ptr CUBE
	movc	ecx,6
	.repeat
		movc	ebx,8/2	;8/2 because we do two squares in each loop iteration
		.repeat
			mov		eax,[esi].Sqr.rgbSqr
			mov		edx,[esi+sizeof RCC_SQR].Sqr.rgbSqr
			mov		[edi],al
			mov		[edi+1],dl
			add		esi,2*sizeof RCC_SQR	;lea		esi,[esi+2*sizeof RCC_SQR]
			lea		edi,[edi+2]				;add		edi,2
			dec		ebx
		.until ZERO?
		;skip middle square and continue
		add		esi,sizeof RCC_SQR
		dec		ecx
	.until ZERO?
	return TRUE

GetCubeState endp

SetCubeState proc uses ebx esi edi lpCube,lpState:DWORD
	
	mov		esi,lpState
	mov		edi,lpCube
	assume esi:ptr CUBE
	assume edi:ptr RCC_CUBE
	movc	eax,0
	lea		edi,[edi].RccSide
	assume edi:ptr RCC_SIDE
	movc	edx,0
	movc	ecx,6
	.repeat
		movc	ebx,4
		.repeat
			mov		al,[esi]
			mov		dl,[esi+1]
			mov		[edi].Sqr.rgbSqr,eax
			mov		[edi+sizeof RCC_SQR].Sqr.rgbSqr,edx
			add		esi,2
			lea		edi,[edi+2*sizeof RCC_SQR]
			dec		ebx
		.until ZERO?
		;make sure middle square is fine too and continue
		;mov		[edi].Sqr.rgbSqr,eax
		add		edi,sizeof RCC_SQR
		dec		ecx
	.until ZERO?
	return TRUE

SetCubeState endp

RCubeDestroy proc uses ebx esi edi hWin:DWORD
	
	invoke	GetWindowLong,hWin,GWL_MEM
	xchg	eax,edi
	assume edi:ptr RCC_CUBE
	invoke	DestroyMenu,[edi].hCubeletMnu
	invoke	DestroyMenu,[edi].hMiddleMenu
	invoke	DestroyRegions,edi
;	lea		esi,[edi].RccSide
;	assume	esi:ptr RCC_SQR
;	lea		ebx,[esi+(9*6*sizeof RCC_SQR)]
;	.repeat
;		invoke	DeleteObject,[esi].hRgn
;		add		esi,sizeof RCC_SQR
;	.until esi>=ebx
	invoke	GetWindowLong,hWin,GWL_HEAP
	invoke	HeapFree,eax,NULL,edi
	ret

	assume esi:nothing
	assume edi:nothing
RCubeDestroy endp

MakeRegions proc uses ebx esi edi lpCube:LPVOID
	LOCAL	clrSide:DWORD

	mov		eax,lpCube
	lea		esi,(RCC_CUBE ptr [eax]).RccSide
	assume	esi:ptr RCC_SQR
	movc	edi,NULL
	lea		ebx,[esi+(9*6*sizeof RCC_SQR)]
	mov		clrSide,edi
	.repeat
		lea		eax,[esi].ptVert
		invoke	CreatePolygonRgn,eax,4,WINDING
		;fill RCC_CUBE with assembled cube data
		mov		edx,clrSide
		mov		[esi].hRgn,eax
		mov		[esi].rgbSqr,edx
		.if edi>=8
			movc	edi,-1
			inc		clrSide
		.endif
		add		esi,sizeof RCC_SQR
		inc		edi
	.until esi>=ebx
	ret

		;the following rest of the loop paints squares all different colors
		;it is good for checking proper painting of the cube
;		mov		eax,[esp]
;		mov		[esi].rgbSqr,al
;		inc		eax
;		.if eax>=6
;			movc	eax,0
;		.endif
;		mov		[esp],eax
	assume esi:nothing
MakeRegions endp

DestroyRegions proc uses ebx esi lpCube:LPVOID
	
	mov		eax,lpCube
	lea		esi,(RCC_CUBE ptr [eax]).RccSide
	assume	esi:ptr RCC_SQR
	lea		ebx,[esi+(9*6*sizeof RCC_SQR)]
	.repeat
		invoke	DeleteObject,[esi].hRgn
		add		esi,sizeof RCC_SQR
	.until esi>=ebx
	ret

	assume esi:nothing
DestroyRegions endp

;make all calcs here in FPU!!!
CalcRubicsCube proc uses ebx esi edi lprcClient:LPVOID,lpCubeStruct:LPVOID
	LOCAL	flCubeVertStepY:REAL4
	LOCAL	flCubeStepY:REAL4
	LOCAL	flCubeStepX:REAL4
	LOCAL	flCubeQuartY:REAL4
	LOCAL	flCubeCenterY:REAL4
	LOCAL	flCubeCenterX:REAL4
	LOCAL	flCubeWidth:REAL4
	LOCAL	dwCubeHeight:DWORD
	LOCAL	flBorderY:REAL4
	LOCAL	flBorderX:REAL4
	LOCAL	dwPos1:DWORD
	LOCAL	dwPos0:DWORD
	LOCAL	rcCube:RECT

	mov		esi,lpCubeStruct
	mov		edi,lprcClient
	;make sure that the entire memory for the structure is in L1 cache
	push	esi
		mov		ecx,sizeof RCC_CUBE/32
		.repeat
			mov		eax,[esi]
			mov		edx,[esi+16]
			lea		esi,[esi+32]
			sub		ecx,1
		.until ZERO?
	pop		esi
	;now we can fill the structure
	assume esi:ptr RCC_CUBE
	assume edi:ptr RECT
	mov		ecx,[edi].left
	mov		ebx,[edi].top
	mov		eax,[edi].right
	mov		edx,[edi].bottom
	mov		rcCube.left,ecx
	mov		rcCube.top,ebx
	mov		rcCube.right,eax
	mov		rcCube.bottom,edx
	;dwClientWidth=Client.right-Client.left
	;dwClientHeight=Client.bottom-Client.top
	sub		eax,ecx	;[edi].left
	sub		edx,ebx	;[edi].top
	push	16
		;mov		dwClientWidth,eax
		;mov		dwClientHeight,edx
		push	eax
			push	edx
				push	2
					push	3
						finit
					;dwBorderX=ClientWidth/16 
					;dwBorderY=ClientHeight/16
					;divto1	eax,4
					;divto1	edx,4
					;mov		dwBorderX,eax
					;mov		dwBorderY,edx
						fild	dword ptr [esp]
					pop		ecx
					fild	dword ptr [esp]
				pop		ecx
				fild	dword ptr [esp]	;dwClientHeight
			pop		ecx
			fidiv	dword ptr [esp+4]	;ClientHeight/16
			fst		flBorderY
			fild	dword ptr [esp]	;dwClientWidth
		pop		ecx
		fidiv	dword ptr [esp]	;ClientWidth/16
		fst		flBorderX
	pop		ecx
	;[esi].dwPenSize = flBorderY / 3
	fld		st(1)	;flBorderY
		fist	[esi].dwFontHeight
		fdiv	st,st(4)	; / 3
		fdiv	st,st(3)	; / 2 ;if need to divide further
	fistp	[esi].dwPenSize
	;rcCube.left=Client.left+dwBorderX
	;rcCube.top=Client.top+dwBorderY
	fild	rcCube.left
		fild	rcCube.top
			fadd	st,st(3)
		fistp	rcCube.top
		fadd	st,st(1)
	fistp	rcCube.left
	mov		ecx,rcCube.left
	mov		ebx,rcCube.top
		;save x coord of most left corners and y coord of highest coords
			mov		[esi].RccSide[1*sizeof RCC_SIDE].Sqr[2*sizeof RCC_SQR].ptVert[0*sizeof POINT].y,ebx
			mov		[esi].RccSide[2*sizeof RCC_SIDE].Sqr[0*sizeof RCC_SQR].ptVert[0*sizeof POINT].y,ebx
		mov		[esi].RccSide[3*sizeof RCC_SIDE].Sqr[0*sizeof RCC_SQR].ptVert[0*sizeof POINT].x,ecx
		mov		[esi].RccSide[3*sizeof RCC_SIDE].Sqr[0*sizeof RCC_SQR].ptVert[3*sizeof POINT].x,ecx
		mov		[esi].RccSide[3*sizeof RCC_SIDE].Sqr[6*sizeof RCC_SQR].ptVert[0*sizeof POINT].x,ecx
		mov		[esi].RccSide[3*sizeof RCC_SIDE].Sqr[6*sizeof RCC_SQR].ptVert[3*sizeof POINT].x,ecx
		mov		[esi].RccSide[3*sizeof RCC_SIDE].Sqr[7*sizeof RCC_SQR].ptVert[0*sizeof POINT].x,ecx
		mov		[esi].RccSide[3*sizeof RCC_SIDE].Sqr[7*sizeof RCC_SQR].ptVert[3*sizeof POINT].x,ecx
		mov		[esi].RccSide[4*sizeof RCC_SIDE].Sqr[0*sizeof RCC_SQR].ptVert[3*sizeof POINT].x,ecx
			mov		[esi].RccSide[4*sizeof RCC_SIDE].Sqr[2*sizeof RCC_SQR].ptVert[0*sizeof POINT].y,ebx
	;rcCube.right=Client.right-dwBorderX
	;rcCube.bottom=Client.bottom-dwBorderY
	fild	rcCube.right
		fild	rcCube.bottom
			fsub	st,st(3)	;-dwBorderY
		fistp	rcCube.bottom
		fsub	st,st(1)		;-dwBorderX
		fist	rcCube.right
		lea		edi,[esi].RccSide
		mov		ecx,rcCube.right
		mov		ebx,rcCube.bottom
		assume edi:ptr RCC_SIDE
			;save x coord of most right corners and y coord of lowest corners
				storeY 0,6,2,ebx
			storeX 2,2,1,ecx
			storeX 2,2,2,ecx
			storeX 2,3,1,ecx
			storeX 2,3,2,ecx
			storeX 2,4,1,ecx
			storeX 2,4,2,ecx
				storeY 3,4,2,ebx
				storeY 5,0,2,ebx
			storeX 5,6,1,ecx
		;flCubeWidth=(rcCube.right-rcCube.left-dwBorderX)/2
		;dwCubeHeight=rcCube.bottom-rcCube.top
		fisub	rcCube.left
		sub		ebx,rcCube.top
		fsub	st,st(1)	;-flBorderX
		mov		dwCubeHeight,ebx
		fdiv	st,st(3)	;divide by 2 in FPU registers
		fst		flCubeWidth
		;flCubeCenterX=flCubeWidth/2
		;flCubeCenterY=dwCubeHeight/2
		fild	dwCubeHeight
			fdiv	st,st(4)	;/2
		fstp	flCubeCenterY
		fdiv	st,st(3)		;/2
		fst		flCubeCenterX
		;flCubeStepX=flCubeCenterX/3
		;flCubeVertStepY=flCubeCenterY/3
		;flCubeQuartY=flCubeCenterY/2
		;flCubeStepY=flCubeQuartY/3
		fdiv	st,st(4)	;/3
	fstp	flCubeStepX
	fld		flCubeCenterY
		fld		st(0)
			fdiv	st,st(5)	;/3
		fstp	flCubeVertStepY
		fdiv	st,st(3)	;/2
		fst		flCubeQuartY
		fdiv	st,st(4)	;/3
		fst		flCubeStepY
		ffree	st(4)	;we don't need 3
		ffree	st(3)	;and 2 in the FPU registers any more
		ffree	st(2)	;free flBorderY
		ffree	st(1)	;free flBorderX
		;rcCube.top + dwCubeStepY
		;rcCube.bottom - dwCubeStepY
		fild	rcCube.top
			fild	rcCube.bottom
				fsub	st,st(2)
				fist	dwPos1
				fxch
				fadd	st,st(2)
				fist	dwPos0
	mov		edx,dwPos0
	mov		eax,dwPos1
		;down from top
		storeY	1,1,0,edx
		storeY	1,2,3,edx
		storeY	2,0,1,edx
		storeY	2,1,0,edx
		storeY	4,1,0,edx
		storeY	4,2,1,edx
		storeY	4,2,3,edx
		storeY	4,3,0,edx
			;up from bottom
			storeY	0,5,2,eax
			storeY	0,6,1,eax
			storeY	3,4,3,eax
			storeY	3,5,2,eax
			storeY	5,0,1,eax
			storeY	5,0,3,eax
			storeY	5,1,2,eax
			storeY	5,7,2,eax
			;rcCube.top + dwCubeStepY + dwCubeStepY
			;rcCube.bottom - dwCubeStepY - dwCubeStepY
				fadd	st,st(2)	; + dwCubeStepY
				fist	dwPos0
				fxch
				fsub	st,st(2)
				fist	dwPos1
		mov		edx,dwPos0
		mov		eax,dwPos1
		;down from top
		storeY	1,0,0,edx
		storeY	1,1,3,edx
		storeY	2,1,1,edx
		storeY	2,2,0,edx
		storeY	4,0,0,edx
		storeY	4,1,3,edx
		storeY	4,1,1,edx
		storeY	4,2,2,edx
		storeY	4,3,1,edx
		storeY	4,3,3,edx
		storeY	4,4,0,edx
		mov		[edi+4*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].y,edx
			;up from bottom
			storeY	0,4,2,eax
			storeY	0,5,1,eax
			storeY	3,5,3,eax
			storeY	3,6,2,eax
			storeY	5,0,0,eax
			storeY	5,1,1,eax
			storeY	5,1,3,eax
			storeY	5,2,2,eax
			storeY	5,6,2,eax
			storeY	5,7,1,eax
			storeY	5,7,3,eax
			mov		[edi+5*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].y,eax
			;rcCube.top + dwCubeStepY + dwCubeStepY
			;rcCube.bottom - dwCubeStepY - dwCubeStepY
				fsub	st,st(2)	; + dwCubeStepY
				fist	dwPos1
				fxch
				fadd	st,st(2)
				fist	dwPos0
			mov		edx,dwPos0
			mov		eax,dwPos1
;				fld		flCubeQuartY
;				fild	rcCube.top
;				fild	rcCube.bottom
;				fsub	st,st(2)
;				fistp	dwPos1
;				fadd	st,st(1)
;				fistp	dwPos0
;	mov		ecx,flCubeQuartY
;	mov		edx,rcCube.top
;	mov		eax,rcCube.bottom
;	add		edx,ecx
;	sub		eax,ecx
		;down from top
		storeY	0,2,0,edx
		storeY	1,0,3,edx
		storeY	2,2,1,edx
		storeY	3,0,0,edx
		storeY	4,0,1,edx
		storeY	4,0,3,edx
		storeY	4,1,2,edx
		storeY	4,3,2,edx
		storeY	4,4,1,edx
		storeY	4,4,3,edx
		storeY	4,5,0,edx
		storeY	4,7,0,edx
		mov		[edi+4*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].y,edx
		mov		[edi+4*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].y,edx
			;up from bottom
			storeY	0,4,1,eax
			storeY	1,6,2,eax
			storeY	2,4,2,eax
			storeY	3,6,3,eax
			storeY	5,1,0,eax
			storeY	5,2,1,eax
			storeY	5,2,3,eax
			storeY	5,3,2,eax
			storeY	5,5,2,eax
			storeY	5,6,1,eax
			storeY	5,6,3,eax
			storeY	5,7,0,eax
			mov		[edi+5*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].y,eax
			mov		[edi+5*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].y,eax
			;rcCube.top + dwCubeStepY + dwCubeStepY
			;rcCube.bottom - dwCubeStepY - dwCubeStepY
				fadd	st,st(2)	; + dwCubeStepY
				fist	dwPos0
				fxch
				fsub	st,st(2)
				fist	dwPos1
				mov		edx,dwPos0
				mov		eax,dwPos1
;	add		edx,ebx	;edx=rcCube.top+dwCubeQuartY+dwCubeStepY
;	sub		eax,ebx	;eax=rcCube.bottom-dwCubeQuartY-dwCubeStepY
		;down from top
		storeY	0,1,0,edx
		storeY	0,2,3,edx
		storeY	3,0,1,edx
		storeY	3,1,0,edx
		storeY	4,0,2,edx
		storeY	4,4,2,edx
		storeY	4,5,3,edx
		storeY	4,6,0,edx
		storeY	4,7,1,edx
		storeY	4,7,3,edx
		storeY	4,5,1,edx
		mov		[edi+4*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].y,edx
			;up from bottom
			storeY	1,5,2,eax
			storeY	1,6,1,eax
			storeY	2,4,3,eax
			storeY	2,5,2,eax
			storeY	5,2,0,eax
			storeY	5,3,1,eax
			storeY	5,3,3,eax
			storeY	5,4,2,eax
			storeY	5,5,1,eax
			storeY	5,5,3,eax
			storeY	5,6,0,eax
			mov		[edi+5*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].y,eax
			;rcCube.top + dwCubeStepY + dwCubeStepY
			;rcCube.bottom - dwCubeStepY - dwCubeStepY
				fsub	st,st(2)	; + dwCubeStepY
				fist	dwPos1
				fxch
				fadd	st,st(2)
				fist	dwPos0
				mov		edx,dwPos0
				mov		eax,dwPos1
;	add		edx,ebx	;edx=rcCube.top+dwCubeQuartY+dwCubeStepY+dwCubeStepY
;	sub		eax,ebx	;eax=rcCube.bottom-dwCubeQuartY-dwCubeStepY-dwCubeStepY
		;down from top
		storeY	0,0,0,edx
		storeY	0,1,3,edx
		storeY	3,1,1,edx
		storeY	3,2,0,edx
		storeY	4,5,2,edx
		storeY	4,6,3,edx
		storeY	4,7,2,edx
		storeY	4,6,1,edx
			;up from bottom
			storeY	1,4,2,eax
			storeY	1,5,1,eax
			storeY	2,5,3,eax
			storeY	2,6,2,eax
			storeY	5,3,0,eax
			storeY	5,4,3,eax
			storeY	5,4,1,eax
			storeY	5,5,0,eax
				fadd	st,st(2)	; + dwCubeStepY
				fist	dwPos0
				fxch
				fsub	st,st(2)
	;			fist	dwPos1
	;			mov		edx,dwPos0
	;			mov		eax,dwPos1
	;mov		eax,rcCube.top
	;add		eax,flCubeCenterY	;here we get same value for centers in both cube's projections
	;fild	rcCube.top
	;fadd	flCubeCenterY
	;fistp	dwPos0
	mov		eax,dwPos0
		;down from top
			;up from bottom
		storeY	0,0,3,eax	;edx
			storeY	1,4,1,eax
			storeY	2,6,3,eax
		storeY	3,2,1,eax	;edx
		storeY	4,6,2,eax	;edx
			storeY	5,4,0,eax
	mov		edx,eax
	;mov		ecx,flCubeVertStepY
				fld		flCubeVertStepY
				fxch	st(2)
				fadd	st,st(2)
				fist	dwPos0
				fxch
				fsub	st,st(2)
				fist	dwPos1
	mov		edx,dwPos0
	mov		eax,dwPos1
;	add		edx,ecx	;+dwCubeVertStepY
;	sub		eax,ecx	;-dwCubeVertStepY
		;down from top
		storeY	0,0,2,edx
		storeY	0,7,3,edx
		storeY	3,2,2,edx
		storeY	3,3,1,edx
			;up from bottom
			storeY	1,3,1,eax
			storeY	1,4,0,eax
			storeY	2,6,0,eax
			storeY	2,7,3,eax
				fadd	st,st(3)
				fist	dwPos1
				fxch
				fsub	st,st(3)
				fist	dwPos0
		mov		edx,dwPos0
		mov		eax,dwPos1
		;sub		edx,ebx	;-dwCubeStepY
		;add		eax,ebx	;+dwCubeStepY
			;down from top
			storeY	0,0,1,edx
			storeY	0,1,2,edx
			storeY	0,7,0,edx
			mov		[edi+0*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].y,edx
			storeY	3,1,2,edx
			storeY	3,2,3,edx
			storeY	3,3,0,edx
			mov		[edi+3*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].y,edx
				;up from bottom
				storeY	1,3,2,eax
				storeY	1,4,3,eax
				storeY	1,5,0,eax
				mov		[edi+1*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].y,eax
				storeY	2,5,0,eax
				storeY	2,6,1,eax
				storeY	2,7,2,eax
				mov		[edi+2*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].y,eax
				fsub	st,st(3)	;-dwCubeStepY
				fist	dwPos0
				fxch
				fadd	st,st(3)		;+dwCubeStepY
				fist	dwPos1
			mov		edx,dwPos0
			mov		eax,dwPos1
;			sub		edx,ebx	;-dwCubeStepY
;			add		eax,ebx	;+dwCubeStepY
				;down from top
				storeY	0,1,1,edx
				storeY	0,2,2,edx
				storeY	0,3,3,edx
				mov		[edi+0*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].y,edx
				storeY	3,0,2,edx
				storeY	3,1,3,edx
				storeY	3,7,1,edx
				mov		[edi+3*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].y,edx
					;up from bottom
					storeY	1,5,3,eax
					storeY	1,6,0,eax
					storeY	1,7,1,eax
					mov		[edi+1*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].y,eax
					storeY	2,3,3,eax
					storeY	2,4,0,eax
					storeY	2,5,1,eax
					mov		[edi+2*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].y,eax
				fadd	st,st(3)
			fistp	dwPos1
			fsub	st,st(2)
		fistp	dwPos0
				mov		edx,dwPos0
				mov		eax,dwPos1
				;sub		edx,ebx	;-dwCubeStepY
				;add		eax,ebx	;+dwCubeStepY
					;down from top
					storeY	0,2,1,edx
					storeY	0,3,0,edx
					storeY	3,0,3,edx
					storeY	3,7,0,edx
						;up from bottom
						storeY	1,6,3,eax
						storeY	1,7,2,eax
						storeY	2,3,2,eax
						storeY	2,4,1,eax
		fild	rcCube.top
			fadd	st,st(1)		;+dwCubeVertStepY
			fist	dwPos1
			fild	rcCube.bottom
				fsub	st,st(2)	;-dwCubeVertStepY
				fist	dwPos0
	mov		edx,dwPos0
	mov		eax,dwPos1
;	mov		edx,rcCube.bottom
;	mov		eax,rcCube.top
;	sub		edx,ecx	;-dwCubeVertStepY
;	add		eax,ecx	;+dwCubeVertStepY
		;down from top
		storeY	0,6,3,edx
		storeY	0,7,2,edx
		storeY	3,3,2,edx
		storeY	3,4,1,edx
			;up from bottom
			storeY	1,2,1,eax
			storeY	1,3,0,eax
			storeY	2,0,3,eax
			storeY	2,7,0,eax
				fsub	st,st(3)	;-dwCubeStepY
				fist	dwPos0
				fxch
				fadd	st,st(3)	;+dwCubeStepY
				fist	dwPos1
		mov		edx,dwPos0
		mov		eax,dwPos1
		;sub		edx,ebx	;-dwCubeStepY
		;add		eax,ebx	;+dwCubeStepY
			;down from top
			storeY	0,5,3,edx
			storeY	0,6,0,edx
			storeY	0,7,1,edx
			mov		[edi+0*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].y,edx
			storeY	3,3,3,edx
			storeY	3,4,0,edx
			storeY	3,5,1,edx
			mov		[edi+3*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].y,edx
				;up from bottom
				storeY	1,1,1,eax
				storeY	1,2,2,eax
				storeY	1,3,3,eax
				mov		[edi+1*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].y,eax
				storeY	2,0,2,eax
				storeY	2,1,3,eax
				storeY	2,7,1,eax
				mov		[edi+2*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].y,eax
				fadd	st,st(3)
				fist	dwPos1
				fxch
				fsub	st,st(3)
				fist	dwPos0
			mov		edx,dwPos0
			mov		eax,dwPos1
			;sub		edx,ebx	;-dwCubeStepY
			;add		eax,ebx	;+dwCubeStepY
				;down from top
				storeY	0,3,2,edx
				storeY	0,4,3,edx
				storeY	0,5,0,edx
				mov		[edi+0*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].y,edx
				storeY	3,5,0,edx
				storeY	3,6,1,edx
				storeY	3,7,2,edx
				mov		[edi+3*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].y,edx
					;up from bottom
					storeY	1,0,1,eax
					storeY	1,1,2,eax
					storeY	1,7,0,eax
					mov		[edi+1*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].y,eax
					storeY	2,1,2,eax
					storeY	2,2,3,eax
					storeY	2,3,0,eax
					mov		[edi+2*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].y,eax
				fsub	st,st(3)
				fist	dwPos0
				fxch
				fadd	st,st(3)
				fist	dwPos1
				mov		edx,dwPos0
				mov		eax,dwPos1
				;sub		edx,ebx	;-dwCubeStepY
				;add		eax,ebx	;+dwCubeStepY
					;down from top
					storeY	0,3,1,edx
					storeY	0,4,0,edx
					storeY	3,6,0,edx
					storeY	3,7,3,edx
						;up from bottom
						storeY	1,0,2,eax
						storeY	1,7,3,eax
						storeY	2,2,2,eax
						storeY	2,3,1,eax
	;mov		ebx,flCubeStepX
	finit	;clear all FPU regs
	fld		flCubeStepX
		fild	rcCube.left
			fadd	st,st(1)
			fist	dwPos0
			fild	rcCube.right
				fsub	st,st(2)
				fist	dwPos1
	mov		eax,dwPos0
	mov		edx,dwPos1
;	mov		ebx,dwPos0
;	mov		eax,rcCube.left
;	mov		edx,rcCube.right
;	add		eax,ebx ;+dwCubeStepX
;	sub		edx,ebx ;-dwCubeStepX
		;left

		storeX	3,0,1,eax
		storeX	3,0,2,eax
		storeX	3,1,0,eax
		storeX	3,1,3,eax
		storeX	3,5,0,eax
		storeX	3,5,3,eax
		storeX	3,6,1,eax
		storeX	3,6,2,eax
		storeX	3,7,1,eax
		storeX	3,7,2,eax
		mov		[edi+3*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].x,eax
		mov		[edi+3*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].x,eax
		storeX	4,0,0,eax
		storeX	4,0,2,eax
		storeX	4,1,3,eax
		storeX	4,7,3,eax
			;right
			storeX	2,1,1,edx
			storeX	2,1,2,edx
			storeX	2,2,0,edx
			storeX	2,2,3,edx
			storeX	2,3,0,edx
			storeX	2,3,3,edx
			storeX	2,4,0,edx
			storeX	2,4,3,edx
			storeX	2,5,1,edx
			storeX	2,5,2,edx
			mov		[edi+2*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].x,edx
			mov		[edi+2*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].x,edx
			storeX	5,5,1,edx
			storeX	5,6,0,edx
			storeX	5,6,2,edx
			storeX	5,7,1,edx
				fsub	st,st(2)
				fist	dwPos1
				fxch
				fadd	st,st(2)
				fist	dwPos0
		mov		eax,dwPos0
		mov		edx,dwPos1
		;add		eax,ebx ;+dwCubeStepX
		;sub		edx,ebx ;-dwCubeStepX
			;left
			storeX	3,1,1,eax
			storeX	3,1,2,eax
			storeX	3,2,0,eax
			storeX	3,2,3,eax
			storeX	3,3,0,eax
			storeX	3,3,3,eax
			storeX	3,4,0,eax
			storeX	3,4,3,eax
			storeX	3,5,1,eax
			storeX	3,5,2,eax
			mov		[edi+3*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].x,eax
			mov		[edi+3*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].x,eax
			storeX	4,0,1,eax
			storeX	4,1,0,eax
			storeX	4,1,2,eax
			storeX	4,2,3,eax
			storeX	4,6,3,eax
			storeX	4,7,0,eax
			storeX	4,7,2,eax
			mov		[edi+4*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].x,eax
				;right
				storeX	2,0,1,edx
				storeX	2,0,2,edx
				storeX	2,1,0,edx
				storeX	2,1,3,edx
				storeX	2,5,0,edx
				storeX	2,5,3,edx
				storeX	2,6,1,edx
				storeX	2,6,2,edx
				storeX	2,7,1,edx
				storeX	2,7,2,edx
				mov		[edi+2*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].x,edx
				mov		[edi+2*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].x,edx
				storeX	5,0,1,edx
				storeX	5,4,1,edx
				storeX	5,5,0,edx
				storeX	5,5,2,edx
				storeX	5,6,3,edx
				storeX	5,7,0,edx
				storeX	5,7,2,edx
				mov		[edi+5*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].x,edx
				fadd	st,st(2)
				fist	dwPos0
				fxch
				fsub	st,st(2)
				fist	dwPos1
	mov		eax,dwPos0
	mov		edx,dwPos1
	;mov		ecx,flCubeCenterX
;	mov		ecx,dwPos0
;	mov		eax,rcCube.left
;	mov		edx,rcCube.right
;	add		eax,ecx	;+dwCubeCenterX
;	sub		edx,ecx	;-dwCubeCenterX
		;left
		storeX	0,0,2,eax
		storeX	0,0,3,eax
		storeX	0,6,2,eax
		storeX	0,6,3,eax
		storeX	0,7,2,eax
		storeX	0,7,3,eax
		storeX	3,2,1,eax
		storeX	3,2,2,eax
		storeX	3,3,1,eax
		storeX	3,3,2,eax
		storeX	3,4,1,eax
		storeX	3,4,2,eax
		storeX	4,1,1,eax
		storeX	4,2,0,eax
		storeX	4,2,2,eax
		storeX	4,3,3,eax
		storeX	4,5,3,eax
		storeX	4,6,0,eax
		storeX	4,6,2,eax
		storeX	4,7,1,eax
		mov		[edi+4*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].x,eax
		mov		[edi+4*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].x,eax
			;right
			storeX	1,2,0,edx
			storeX	1,2,1,edx
			storeX	1,3,0,edx
			storeX	1,3,1,edx
			storeX	1,4,0,edx
			storeX	1,4,1,edx
			storeX	2,0,0,edx
			storeX	2,0,3,edx
			storeX	2,6,0,edx
			storeX	2,6,3,edx
			storeX	2,7,0,edx
			storeX	2,7,3,edx
			storeX	5,0,0,edx
			storeX	5,0,2,edx
			storeX	5,1,1,edx
			storeX	5,3,1,edx
			storeX	5,4,0,edx
			storeX	5,4,2,edx
			storeX	5,5,3,edx
			storeX	5,7,3,edx
			mov		[edi+5*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].x,edx
			mov		[edi+5*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].x,edx
				fsub	st,st(2)
				fist	dwPos1
				fxch
				fadd	st,st(2)
				fist	dwPos0
		mov		eax,dwPos0
		mov		edx,dwPos1
		;add		eax,ebx ;-dwCubeStepX
		;sub		edx,ebx ;+dwCubeStepX
			;left
			storeX	0,0,0,eax
			storeX	0,0,1,eax
			storeX	0,1,2,eax
			storeX	0,1,3,eax
			storeX	0,5,2,eax
			storeX	0,5,3,eax
			storeX	0,6,0,eax
			storeX	0,6,1,eax
			storeX	0,7,0,eax
			storeX	0,7,1,eax
			mov		[edi+0*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].x,eax
			mov		[edi+0*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].x,eax
			storeX	4,2,1,eax
			storeX	4,3,0,eax
			storeX	4,3,2,eax
			storeX	4,4,3,eax
			storeX	4,5,0,eax
			storeX	4,5,2,eax
			storeX	4,6,1,eax
			mov		[edi+4*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].x,eax
				;right
				storeX	1,1,0,edx
				storeX	1,1,1,edx
				storeX	1,2,2,edx
				storeX	1,2,3,edx
				storeX	1,3,2,edx
				storeX	1,3,3,edx
				storeX	1,4,2,edx
				storeX	1,4,3,edx
				storeX	1,5,0,edx
				storeX	1,5,1,edx
				mov		[edi+1*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].x,edx
				mov		[edi+1*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].x,edx
				storeX	5,0,3,edx
				storeX	5,1,0,edx
				storeX	5,1,2,edx
				storeX	5,2,1,edx
				storeX	5,3,0,edx
				storeX	5,3,2,edx
				storeX	5,4,3,edx
				mov		[edi+5*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].x,edx
				fadd	st,st(2)
				fist	dwPos0
				fxch
				fsub	st,st(2)
				fist	dwPos1
			mov		eax,dwPos0
			mov		edx,dwPos1
;			add		eax,ebx ;-dwCubeStepX
;			sub		edx,ebx ;+dwCubeStepX
				;left
				storeX	0,1,0,eax
				storeX	0,1,1,eax
				storeX	0,2,2,eax
				storeX	0,2,3,eax
				storeX	0,3,2,eax
				storeX	0,3,3,eax
				storeX	0,4,2,eax
				storeX	0,4,3,eax
				storeX	0,5,0,eax
				storeX	0,5,1,eax
				mov		[edi+0*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].x,eax
				mov		[edi+0*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].x,eax
				storeX	4,3,1,eax
				storeX	4,4,0,eax
				storeX	4,4,2,eax
				storeX	4,5,1,eax
					;right
					storeX	1,0,0,edx
					storeX	1,0,1,edx
					storeX	1,1,2,edx
					storeX	1,1,3,edx
					storeX	1,5,2,edx
					storeX	1,5,3,edx
					storeX	1,6,0,edx

					storeX	1,6,1,edx
					storeX	1,7,0,edx
					storeX	1,7,1,edx
					mov		[edi+1*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].x,edx
					mov		[edi+1*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].x,edx
					storeX	5,1,3,edx
					storeX	5,2,0,edx
					storeX	5,2,2,edx
					storeX	5,3,3,edx
				fsub	st,st(2)
				fist	dwPos1
				fxch
				fadd	st,st(2)
				fist	dwPos0
		mov		eax,dwPos0
		mov		edx,dwPos1
	;mov		ecx,flCubeWidth
;	fld		flCubeWidth
;	fiadd	rcCube.left
;	fistp	dwPos0
;	mov		ecx,dwPos0
;	mov		eax,rcCube.left
;	mov		edx,rcCube.right
;	add		eax,ecx	;rcCube.left + dwCubeWidth
;	sub		edx,ecx	;rcCube.right - dwCubeWidth
		;left
		storeX	0,2,0,eax
		storeX	0,2,1,eax
		storeX	0,3,0,eax
		storeX	0,3,1,eax
		storeX	0,4,0,eax
		storeX	0,4,1,eax
		storeX	4,4,1,eax
			;right
			storeX	1,0,2,edx
			storeX	1,0,3,edx
			storeX	1,6,2,edx
			storeX	1,6,3,edx
			storeX	1,7,2,edx
			storeX	1,7,3,edx
			storeX	5,2,3,edx
	;at this point EDI is ptr to RCC_SIDE structrues in RCC_CUBE
	;now we need to calc coords for text to be in the middle of each square
	;start with side 0, i.e. Front
	mov		ecx,[esi].dwFontHeight
	push	9*2	;we will work with 2 sides, each contains 9 squares
	assume edi:ptr RCC_SQR
	;(([edi].ptVert[2*sizeof POINT].y + [edi].ptVert[0*sizeof POINT].y) / 2) - ([esi].dwFontHeight / 2)
	;c = ((a+b) /2) - (y /2)
	;c = ((a+b)-y)/2
	;([edi].ptVert[2*sizeof POINT].y + [edi].ptVert[0*sizeof POINT].y - [esi].dwFontHeight) / 2
		.repeat
			mov		eax,[edi].ptVert[1*sizeof POINT].x
			mov		edx,[edi].ptVert[0*sizeof POINT].y
			add		eax,[edi].ptVert[2*sizeof POINT].x
			add		edx,[edi].ptVert[2*sizeof POINT].y
			shr		eax,1
			sub		edx,ecx
			shr		edx,1
			mov		[edi].ptText.x,eax
			dec		dword ptr [esp]
			mov		[edi].ptText.y,edx
			lea		edi,[edi+sizeof RCC_SQR]
		.until ZERO?
		add		dword ptr [esp],9*2	;we will work with 2 sides, each contains 9 squares
		.repeat
			mov		eax,[edi].ptVert[0*sizeof POINT].x
			mov		edx,[edi].ptVert[0*sizeof POINT].y
			add		eax,[edi].ptVert[1*sizeof POINT].x
			add		edx,[edi].ptVert[2*sizeof POINT].y
			shr		eax,1
			sub		edx,ecx
			shr		edx,1
			mov		[edi].ptText.x,eax
			dec		dword ptr [esp]
			mov		[edi].ptText.y,edx
			lea		edi,[edi+sizeof RCC_SQR]
		.until ZERO?
		add		dword ptr [esp],9*2	;we will work with 2 sides, each contains 9 squares
		.repeat
			mov		eax,[edi].ptVert[1*sizeof POINT].x
			mov		edx,[edi].ptVert[0*sizeof POINT].y
			add		eax,[edi].ptVert[3*sizeof POINT].x
			add		edx,[edi].ptVert[2*sizeof POINT].y
			shr		eax,1
			sub		edx,ecx
			shr		edx,1
			mov		[edi].ptText.x,eax
			dec		dword ptr [esp]
			mov		[edi].ptText.y,edx
			lea		edi,[edi+sizeof RCC_SQR]
		.until ZERO?
	pop		edx
	ret

	assume esi:nothing
	assume edi:nothing
CalcRubicsCube endp


;This function calculates coordinates for all points
;Vertices for each cube/rombus/region are numbered clockwise starting with the highes vertex.
;CalcCubePoints proc uses ebx esi edi lpRect:LPVOID
;	LOCAL	nSideStep:DWORD
;	LOCAL	rcVcenter:DWORD
;	LOCAL	nSideDown:DWORD
;	LOCAL	nSideUp:DWORD
;	LOCAL	nVertStep:DWORD
;	LOCAL	nHorStep:DWORD
;	LOCAL	rcHeight:DWORD
;	LOCAL	rcWidth:DWORD

;	mov		esi,lpRect
;	mov		edi,offset SrcDrawCube
;	assume esi:ptr RECT
;	assume edi:ptr DRAW_CUBE
;	nop
;	mov		eax,[esi].right
;	mov		edx,[esi].bottom
;	sub		eax,[esi].left
;	sub		edx,[esi].top
;	movc	ecx,0
;	mov		rcWidth,eax
;	mov		rcHeight,edx
;	mov		cl,13
;	movc	edx,0
;	div		ecx
;	movc	ebx,0
;	mov		nHorStep,eax
;	mov		bl,3
;	mov		eax,rcHeight
;	shr		eax,1
;	mov		rcVcenter,eax
;	mov		ecx,eax
;	shr		eax,1
;	add		ecx,eax
;	movc	edx,0
;	mov		nSideUp,eax
;	mov		nSideDown,ecx
;	div		ebx
;	mov		nVertStep,eax
;	movc	edx,0
;	mov		eax,rcVcenter
;	div		ebx
;	mov		nSideStep,eax
;	;ECX will be curr value for horizontal offsets bwn points in cubes
;	;EBX will contain the value by which we will increment ECX for the next step
;	movc	ecx,0
;	mov		ebx,nHorStep
;	sub		eax,eax	;eax = 0
;	mov		edx,nVertStep
;	mov		[edi].Side1.Cube2.Corner0.y,eax
;	mov		[edi].Side2.Cube0.Corner0.y,ecx
;	mov		[edi].Side3.Cube0.Corner0.x,eax
;	mov		[edi].Side3.Cube0.Corner3.x,ecx
;	mov		[edi].Side3.Cube6.Corner0.x,eax
;	mov		[edi].Side3.Cube6.Corner3.x,ecx
;	mov		[edi].Side3.Cube7.Corner0.x,eax
;	mov		[edi].Side3.Cube7.Corner3.x,ecx
;	mov		[edi].Side4.Cube0.Corner3.x,eax
;	mov		[edi].Side4.Cube2.Corner0.y,ecx
;	add		eax,edx
;	add		ecx,ebx
;	mov		[edi].Side1.Cube1.Corner0.y,eax
;	mov		[edi].Side1.Cube2.Corner3.y,eax
;	mov		[edi].Side2.Cube0.Corner1.y,eax
;	mov		[edi].Side2.Cube1.Corner0.y,eax
;	mov		[edi].Side4.Cube1.Corner0.y,eax
;	mov		[edi].Side4.Cube2.Corner1.y,eax
;	mov		[edi].Side4.Cube2.Corner3.y,eax
;	mov		[edi].Side4.Cube3.Corner0.y,eax
;
;	mov		[edi].Side4.Cube0.Corner0.x,ecx
;	mov		[edi].Side4.Cube1.Corner3.x,ecx
;	
;	mov		[edi].Side3.Cube0.Corner1.x,ecx
;	mov		[edi].Side3.Cube1.Corner0.x,ecx
;	mov		[edi].Side4.Cube0.Corner2.x,ecx
;	mov		[edi].Side4.Cube7.Corner3.x,ecx
;	
;	mov		[edi].Side3.Cube0.Corner2.x,ecx
;	mov		[edi].Side3.Cube1.Corner3.x,ecx
;	mov		[edi].Side3.Cube7.Corner1.x,ecx
;	mov		[edi].Side3.Cube8.Corner0.x,ecx
;	
;	mov		[edi].Side3.Cube7.Corner2.x,ecx
;	mov		[edi].Side3.Cube8.Corner3.x,ecx
;	mov		[edi].Side3.Cube5.Corner0.x,ecx
;	mov		[edi].Side3.Cube6.Corner1.x,ecx
;	
;	mov		[edi].Side3.Cube5.Corner3.x,ecx
;	mov		[edi].Side3.Cube6.Corner2.x,ecx
;
;	add		eax,edx
;	add		ecx,ebx
;	mov		[edi].Side4.Cube0.Corner0.y,eax
;	mov		[edi].Side4.Cube1.Corner3.y,eax
;	
;	mov		[edi].Side4.Cube1.Corner1.y,eax
;	mov		[edi].Side4.Cube2.Corner2.y,eax
;	mov		[edi].Side4.Cube3.Corner3.y,eax
;	mov		[edi].Side4.Cube8.Corner0.y,eax
;	
;	mov		[edi].Side4.Cube3.Corner1.y,eax
;	mov		[edi].Side4.Cube4.Corner0.y,eax
;	
;	mov		[edi].Side1.Cube0.Corner0.y,eax
;	mov		[edi].Side1.Cube1.Corner3.y,eax
;	
;	mov		[edi].Side2.Cube1.Corner1.y,eax
;	mov		[edi].Side2.Cube2.Corner0.y,eax
;	
;
;	mov		[edi].Side4.Cube1.Corner0.x,ecx
;	mov		[edi].Side4.Cube2.Corner3.x,ecx
;
;	mov		[edi].Side4.Cube0.Corner1.x,ecx
;	mov		[edi].Side4.Cube1.Corner2.x,ecx
;	mov		[edi].Side4.Cube7.Corner0.x,ecx
;	mov		[edi].Side4.Cube8.Corner3.x,ecx
;	
;	mov		[edi].Side3.Cube1.Corner1.x,ecx
;	mov		[edi].Side3.Cube2.Corner0.x,ecx
;	mov		[edi].Side4.Cube6.Corner3.x,ecx
;	mov		[edi].Side4.Cube7.Corner2.x,ecx
;	
;	mov		[edi].Side3.Cube1.Corner2.x,ecx
;	mov		[edi].Side3.Cube2.Corner3.x,ecx
;	mov		[edi].Side3.Cube3.Corner0.x,ecx
;	mov		[edi].Side3.Cube8.Corner1.x,ecx
;	
;	mov		[edi].Side3.Cube3.Corner3.x,ecx
;	mov		[edi].Side3.Cube4.Corner0.x,ecx
;	mov		[edi].Side3.Cube5.Corner1.x,ecx
;	mov		[edi].Side3.Cube8.Corner2.x,ecx
;	
;	mov		[edi].Side3.Cube4.Corner3.x,ecx
;	mov		[edi].Side3.Cube5.Corner2.x,ecx
;	nop
;	ret

;	assume esi:nothing
;	assume edi:nothing
;CalcCubePoints endp

;old stuff below this line
;----------------------------------------------------------------------------
;
;CalcRubicsCube proc uses ebx esi edi lprcClient:LPVOID,lpCubeStruct:LPVOID
;	LOCAL	dwCubeVertStepY:DWORD
;	LOCAL	dwCubeStepY:DWORD
;	LOCAL	dwCubeStepX:DWORD
;	LOCAL	dwCubeQuartY:DWORD
;	LOCAL	dwCubeCenterY:DWORD
;	LOCAL	dwCubeCenterX:DWORD
;	LOCAL	dwCubeWidth:DWORD
;	LOCAL	dwCubeHeight:DWORD
;	LOCAL	dwBorderY:DWORD
;	LOCAL	dwBorderX:DWORD
;	LOCAL	rcCube:RECT
;
;	mov		esi,lpCubeStruct
;	mov		edi,lprcClient
;	;make sure that the entire memory for the structure is in L1 cache
;	push	esi
;		mov		ecx,sizeof RCC_CUBE/32
;		.repeat
;			mov		eax,[esi]
;			mov		edx,[esi+16]
;			lea		esi,[esi+32]
;			sub		ecx,1
;		.until ZERO?
;	pop		esi
;	;now we can fill the structure
;	assume esi:ptr RCC_CUBE
;	assume edi:ptr RECT
;	mov		ecx,[edi].left
;	mov		ebx,[edi].top
;	mov		eax,[edi].right
;	mov		edx,[edi].bottom
;	;dwClientWidth=Client.right-Client.left
;	;dwClientHeight=Client.bottom-Client.top
;	sub		eax,ecx	;[edi].left
;	sub		edx,ebx	;[edi].top
;	;dwBorderX=ClientWidth/16 
;	;dwBorderY=ClientHeight/16
;	divto1	eax,4
;	divto1	edx,4
;	mov		dwBorderX,eax
;	mov		dwBorderY,edx
;	;rcCube.left=Client.left+dwBorderX
;	;rcCube.top=Client.top+dwBorderY
;	add		ecx,eax
;	add		ebx,edx
;	mov		rcCube.left,ecx
;	mov		rcCube.top,ebx
;		;save x coord of most left corners and y coord of highest coords
;			mov		[esi].RccSide[1*sizeof RCC_SIDE].Sqr[2*sizeof RCC_SQR].ptVert[0*sizeof POINT].y,ebx
;			mov		[esi].RccSide[2*sizeof RCC_SIDE].Sqr[0*sizeof RCC_SQR].ptVert[0*sizeof POINT].y,ebx
;		mov		[esi].RccSide[3*sizeof RCC_SIDE].Sqr[0*sizeof RCC_SQR].ptVert[0*sizeof POINT].x,ecx
;		mov		[esi].RccSide[3*sizeof RCC_SIDE].Sqr[0*sizeof RCC_SQR].ptVert[3*sizeof POINT].x,ecx
;		mov		[esi].RccSide[3*sizeof RCC_SIDE].Sqr[6*sizeof RCC_SQR].ptVert[0*sizeof POINT].x,ecx
;		mov		[esi].RccSide[3*sizeof RCC_SIDE].Sqr[6*sizeof RCC_SQR].ptVert[3*sizeof POINT].x,ecx
;		mov		[esi].RccSide[3*sizeof RCC_SIDE].Sqr[7*sizeof RCC_SQR].ptVert[0*sizeof POINT].x,ecx
;		mov		[esi].RccSide[3*sizeof RCC_SIDE].Sqr[7*sizeof RCC_SQR].ptVert[3*sizeof POINT].x,ecx
;		mov		[esi].RccSide[4*sizeof RCC_SIDE].Sqr[0*sizeof RCC_SQR].ptVert[3*sizeof POINT].x,ecx
;			mov		[esi].RccSide[4*sizeof RCC_SIDE].Sqr[2*sizeof RCC_SQR].ptVert[0*sizeof POINT].y,ebx
;	;rcCube.right=Client.right-dwBorderX
;	;rcCube.bottom=Client.bottom-dwBorderY
;	mov		ecx,[edi].right
;	mov		ebx,[edi].bottom
;	sub		ecx,eax
;	sub		ebx,edx
;	mov		rcCube.right,ecx
;	mov		rcCube.bottom,ebx
;	lea		edi,[esi].RccSide
;	assume edi:ptr RCC_SIDE
;		;save x coord of most right corners and y coord of lowest corners
;			storeY 0,6,2,ebx
;		storeX 2,2,1,ecx
;		storeX 2,2,2,ecx
;		storeX 2,3,1,ecx
;		storeX 2,3,2,ecx
;		storeX 2,4,1,ecx
;		storeX 2,4,2,ecx
;			storeY 3,4,2,ebx
;			storeY 5,0,2,ebx
;		storeX 5,6,1,ecx
;	;dwCubeWidth=(rcCube.right-rcCube.left-dwBorderX)/2
;	;dwCubeHeight=rcCube.bottom-rcCube.top
;	sub		ecx,rcCube.left
;	divto1	edx,2
;	sub		ebx,rcCube.top
;	sub		ecx,eax
;	mov		dwCubeHeight,ebx
;	shr		ecx,1
;	mov		[esi].dwPenSize,edx
;	mov		dwCubeWidth,ecx
;	;dwCubeCenterX=dwCubeWidth/2
;	;dwCubeCenterY=dwCubeHeight/2
;	shr		ecx,1
;	mov		eax,3
;	shr		ebx,1
;	mov		dwCubeCenterX,ecx
;	mov		dwCubeCenterY,ebx
;	;dwCubeQuartY=dwCubeCenterY/2
;	;dwCubeStepX=dwCubeCenterX/3
;	;dwCubeStepY=dwCubeQuartY/3
;	;dwCubeVertStepY=dwCubeCenterY/3
;	shr		ebx,1
;	xchg	eax,ecx	;ECX=3 and EAX=dwCubeCenterX
;	movc	edx,0
;	div		ecx	;dwCubeCenterX/3
;	mov		dwCubeQuartY,ebx
;	mov		dwCubeStepX,eax
;	xchg	eax,ebx	;eax=dwCubeQuartY   ebx=dwCubeStepX
;	movc	edx,0
;	div		ecx
;	mov		dwCubeStepY,eax
;	xchg	ebx,eax		;ebx = dwCubeStepY	eax = dwCubeStepX
;	mov		eax,dwCubeCenterY
;	movc	edx,0
;	div		ecx
;	mov		dwCubeVertStepY,eax
;	mov		edx,rcCube.top
;	mov		eax,rcCube.bottom
;	add		edx,ebx	;rcCube.top + dwCubeStepY
;	sub		eax,ebx	;rcCube.bottom - dwCubeStepY
;		;down from top
;		storeY	1,1,0,edx
;		storeY	1,2,3,edx
;		storeY	2,0,1,edx
;		storeY	2,1,0,edx
;		storeY	4,1,0,edx
;		storeY	4,2,1,edx
;		storeY	4,2,3,edx
;		storeY	4,3,0,edx
;			;up from bottom
;			storeY	0,5,2,eax
;			storeY	0,6,1,eax
;			storeY	3,4,3,eax
;			storeY	3,5,2,eax
;			storeY	5,0,1,eax
;			storeY	5,0,3,eax
;			storeY	5,1,2,eax
;			storeY	5,7,2,eax
;	add		edx,ebx ;rcCube.top + dwCubeStepY + dwCubeStepY
;	sub		eax,ebx ;rcCube.bottom - dwCubeStepY - dwCubeStepY
;		;down from top
;		storeY	1,0,0,edx
;		storeY	1,1,3,edx
;		storeY	2,1,1,edx
;		storeY	2,2,0,edx
;		storeY	4,0,0,edx
;		storeY	4,1,3,edx
;		storeY	4,1,1,edx
;		storeY	4,2,2,edx
;		storeY	4,3,1,edx
;		storeY	4,3,3,edx
;		storeY	4,4,0,edx
;		mov		[edi+4*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].y,edx
;			;up from bottom
;			storeY	0,4,2,eax
;			storeY	0,5,1,eax
;			storeY	3,5,3,eax
;			storeY	3,6,2,eax
;			storeY	5,0,0,eax
;			storeY	5,1,1,eax
;			storeY	5,1,3,eax
;			storeY	5,2,2,eax
;			storeY	5,6,2,eax
;			storeY	5,7,1,eax
;			storeY	5,7,3,eax
;			mov		[edi+5*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].y,eax
;	mov		ecx,dwCubeQuartY
;	mov		edx,rcCube.top
;	mov		eax,rcCube.bottom
;	add		edx,ecx
;	sub		eax,ecx
;		;down from top
;		storeY	0,2,0,edx
;		storeY	1,0,3,edx
;		storeY	2,2,1,edx
;		storeY	3,0,0,edx
;		storeY	4,0,1,edx
;		storeY	4,0,3,edx
;		storeY	4,1,2,edx
;		storeY	4,3,2,edx
;		storeY	4,4,1,edx
;		storeY	4,4,3,edx
;		storeY	4,5,0,edx
;		storeY	4,7,0,edx
;		mov		[edi+4*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].y,edx
;		mov		[edi+4*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].y,edx
;			;up from bottom
;			storeY	0,4,1,eax
;			storeY	1,6,2,eax
;			storeY	2,4,2,eax
;			storeY	3,6,3,eax
;			storeY	5,1,0,eax
;			storeY	5,2,1,eax
;			storeY	5,2,3,eax
;			storeY	5,3,2,eax
;			storeY	5,5,2,eax
;			storeY	5,6,1,eax
;			storeY	5,6,3,eax
;			storeY	5,7,0,eax
;			mov		[edi+5*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].y,eax
;			mov		[edi+5*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].y,eax
;	add		edx,ebx	;edx=rcCube.top+dwCubeQuartY+dwCubeStepY
;	sub		eax,ebx	;eax=rcCube.bottom-dwCubeQuartY-dwCubeStepY
;		;down from top
;		storeY	0,1,0,edx
;		storeY	0,2,3,edx
;		storeY	3,0,1,edx
;		storeY	3,1,0,edx
;		storeY	4,0,2,edx
;		storeY	4,4,2,edx
;		storeY	4,5,3,edx
;		storeY	4,6,0,edx
;		storeY	4,7,1,edx
;		storeY	4,7,3,edx
;		storeY	4,5,1,edx
;		mov		[edi+4*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].y,edx
;			;up from bottom
;			storeY	1,5,2,eax
;			storeY	1,6,1,eax
;			storeY	2,4,3,eax
;			storeY	2,5,2,eax
;			storeY	5,2,0,eax
;			storeY	5,3,1,eax
;			storeY	5,3,3,eax
;			storeY	5,4,2,eax
;			storeY	5,5,1,eax
;			storeY	5,5,3,eax
;			storeY	5,6,0,eax
;			mov		[edi+5*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].y,eax
;	add		edx,ebx	;edx=rcCube.top+dwCubeQuartY+dwCubeStepY+dwCubeStepY
;	sub		eax,ebx	;eax=rcCube.bottom-dwCubeQuartY-dwCubeStepY-dwCubeStepY
;		;down from top
;		storeY	0,0,0,edx
;		storeY	0,1,3,edx
;		storeY	3,1,1,edx
;		storeY	3,2,0,edx
;		storeY	4,5,2,edx
;		storeY	4,6,3,edx
;		storeY	4,7,2,edx
;		storeY	4,6,1,edx
;			;up from bottom
;			storeY	1,4,2,eax
;			storeY	1,5,1,eax
;			storeY	2,5,3,eax
;			storeY	2,6,2,eax
;			storeY	5,3,0,eax
;			storeY	5,4,3,eax
;			storeY	5,4,1,eax
;			storeY	5,5,0,eax
;			
;	mov		eax,rcCube.top
;	add		eax,dwCubeCenterY	;here we get same value for centers in both cube's projections
;		;down from top
;			;up from bottom
;		storeY	0,0,3,eax	;edx
;			storeY	1,4,1,eax
;			storeY	2,6,3,eax
;		storeY	3,2,1,eax	;edx
;		storeY	4,6,2,eax	;edx
;			storeY	5,4,0,eax
;	mov		edx,eax
;	mov		ecx,dwCubeVertStepY
;	add		edx,ecx	;+dwCubeVertStepY
;	sub		eax,ecx	;-dwCubeVertStepY
;		;down from top
;		storeY	0,0,2,edx
;		storeY	0,7,3,edx
;		storeY	3,2,2,edx
;		storeY	3,3,1,edx
;			;up from bottom
;			storeY	1,3,1,eax
;			storeY	1,4,0,eax
;			storeY	2,6,0,eax
;			storeY	2,7,3,eax
;		sub		edx,ebx	;-dwCubeStepY
;		add		eax,ebx	;+dwCubeStepY
;			;down from top
;			storeY	0,0,1,edx
;			storeY	0,1,2,edx
;			storeY	0,7,0,edx
;			mov		[edi+0*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].y,edx
;			storeY	3,1,2,edx
;			storeY	3,2,3,edx
;			storeY	3,3,0,edx
;			mov		[edi+3*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].y,edx
;				;up from bottom
;				storeY	1,3,2,eax
;				storeY	1,4,3,eax
;				storeY	1,5,0,eax
;				mov		[edi+1*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].y,eax
;				storeY	2,5,0,eax
;				storeY	2,6,1,eax
;				storeY	2,7,2,eax
;				mov		[edi+2*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].y,eax
;			sub		edx,ebx	;-dwCubeStepY
;			add		eax,ebx	;+dwCubeStepY
;				;down from top
;				storeY	0,1,1,edx
;				storeY	0,2,2,edx
;				storeY	0,3,3,edx
;				mov		[edi+0*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].y,edx
;				storeY	3,0,2,edx
;				storeY	3,1,3,edx
;				storeY	3,7,1,edx
;				mov		[edi+3*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].y,edx
;					;up from bottom
;					storeY	1,5,3,eax
;					storeY	1,6,0,eax
;					storeY	1,7,1,eax
;					mov		[edi+1*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].y,eax
;					storeY	2,3,3,eax
;					storeY	2,4,0,eax
;					storeY	2,5,1,eax
;					mov		[edi+2*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].y,eax
;				sub		edx,ebx	;-dwCubeStepY
;				add		eax,ebx	;+dwCubeStepY
;					;down from top
;					storeY	0,2,1,edx
;					storeY	0,3,0,edx
;					storeY	3,0,3,edx
;					storeY	3,7,0,edx
;						;up from bottom
;						storeY	1,6,3,eax
;						storeY	1,7,2,eax
;						storeY	2,3,2,eax
;						storeY	2,4,1,eax
;	mov		edx,rcCube.bottom
;	mov		eax,rcCube.top
;	sub		edx,ecx	;-dwCubeVertStepY
;	add		eax,ecx	;+dwCubeVertStepY
;		;down from top
;		storeY	0,6,3,edx
;		storeY	0,7,2,edx
;		storeY	3,3,2,edx
;		storeY	3,4,1,edx
;			;up from bottom
;			storeY	1,2,1,eax
;			storeY	1,3,0,eax
;			storeY	2,0,3,eax
;			storeY	2,7,0,eax
;		sub		edx,ebx	;-dwCubeStepY
;		add		eax,ebx	;+dwCubeStepY
;			;down from top
;			storeY	0,5,3,edx
;			storeY	0,6,0,edx
;			storeY	0,7,1,edx
;			mov		[edi+0*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].y,edx
;			storeY	3,3,3,edx
;			storeY	3,4,0,edx
;			storeY	3,5,1,edx
;			mov		[edi+3*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].y,edx
;				;up from bottom
;				storeY	1,1,1,eax
;				storeY	1,2,2,eax
;				storeY	1,3,3,eax
;				mov		[edi+1*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].y,eax
;				storeY	2,0,2,eax
;				storeY	2,1,3,eax
;				storeY	2,7,1,eax
;				mov		[edi+2*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].y,eax
;			sub		edx,ebx	;-dwCubeStepY
;			add		eax,ebx	;+dwCubeStepY
;				;down from top
;				storeY	0,3,2,edx
;				storeY	0,4,3,edx
;				storeY	0,5,0,edx
;				mov		[edi+0*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].y,edx
;				storeY	3,5,0,edx
;				storeY	3,6,1,edx
;				storeY	3,7,2,edx
;				mov		[edi+3*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].y,edx
;					;up from bottom
;					storeY	1,0,1,eax
;					storeY	1,1,2,eax
;					storeY	1,7,0,eax
;					mov		[edi+1*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].y,eax
;					storeY	2,1,2,eax
;					storeY	2,2,3,eax
;					storeY	2,3,0,eax
;					mov		[edi+2*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].y,eax
;				sub		edx,ebx	;-dwCubeStepY
;				add		eax,ebx	;+dwCubeStepY
;					;down from top
;					storeY	0,3,1,edx
;					storeY	0,4,0,edx
;					storeY	3,6,0,edx
;					storeY	3,7,3,edx
;						;up from bottom
;						storeY	1,0,2,eax
;						storeY	1,7,3,eax
;						storeY	2,2,2,eax
;						storeY	2,3,1,eax
;	mov		ebx,dwCubeStepX
;	mov		eax,rcCube.left
;	mov		edx,rcCube.right
;	add		eax,ebx ;-dwCubeStepX
;	sub		edx,ebx ;+dwCubeStepX
;		;left
;		storeX	3,0,1,eax
;		storeX	3,0,2,eax
;		storeX	3,1,0,eax
;		storeX	3,1,3,eax
;		storeX	3,5,0,eax
;		storeX	3,5,3,eax
;		storeX	3,6,1,eax
;		storeX	3,6,2,eax
;		storeX	3,7,1,eax
;		storeX	3,7,2,eax
;		mov		[edi+3*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].x,eax
;		mov		[edi+3*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].x,eax
;		storeX	4,0,0,eax
;		storeX	4,0,2,eax
;		storeX	4,1,3,eax
;		storeX	4,7,3,eax
;			;right
;			storeX	2,1,1,edx
;			storeX	2,1,2,edx
;			storeX	2,2,0,edx
;			storeX	2,2,3,edx
;			storeX	2,3,0,edx
;			storeX	2,3,3,edx
;			storeX	2,4,0,edx
;			storeX	2,4,3,edx
;			storeX	2,5,1,edx
;			storeX	2,5,2,edx
;			mov		[edi+2*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].x,edx
;			mov		[edi+2*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].x,edx
;			storeX	5,5,1,edx
;			storeX	5,6,0,edx
;			storeX	5,6,2,edx
;			storeX	5,7,1,edx
;		add		eax,ebx ;-dwCubeStepX
;		sub		edx,ebx ;+dwCubeStepX
;			;left
;			storeX	3,1,1,eax
;			storeX	3,1,2,eax
;			storeX	3,2,0,eax
;			storeX	3,2,3,eax
;			storeX	3,3,0,eax
;			storeX	3,3,3,eax
;			storeX	3,4,0,eax
;			storeX	3,4,3,eax
;			storeX	3,5,1,eax
;			storeX	3,5,2,eax
;			mov		[edi+3*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].x,eax
;			mov		[edi+3*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].x,eax
;			storeX	4,0,1,eax
;			storeX	4,1,0,eax
;			storeX	4,1,2,eax
;			storeX	4,2,3,eax
;			storeX	4,6,3,eax
;			storeX	4,7,0,eax
;			storeX	4,7,2,eax
;			mov		[edi+4*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].x,eax
;				;right
;				storeX	2,0,1,edx
;				storeX	2,0,2,edx
;				storeX	2,1,0,edx
;				storeX	2,1,3,edx
;				storeX	2,5,0,edx
;				storeX	2,5,3,edx
;				storeX	2,6,1,edx
;				storeX	2,6,2,edx
;				storeX	2,7,1,edx
;				storeX	2,7,2,edx
;				mov		[edi+2*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].x,edx
;				mov		[edi+2*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].x,edx
;				storeX	5,0,1,edx
;				storeX	5,4,1,edx
;				storeX	5,5,0,edx
;				storeX	5,5,2,edx
;				storeX	5,6,3,edx
;				storeX	5,7,0,edx
;				storeX	5,7,2,edx
;				mov		[edi+5*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].x,edx
;	mov		ecx,dwCubeCenterX
;	mov		eax,rcCube.left
;	mov		edx,rcCube.right
;	add		eax,ecx	;+dwCubeCenterX
;	sub		edx,ecx	;-dwCubeCenterX
;		;left
;		storeX	0,0,2,eax
;		storeX	0,0,3,eax
;		storeX	0,6,2,eax
;		storeX	0,6,3,eax
;		storeX	0,7,2,eax
;		storeX	0,7,3,eax
;		storeX	3,2,1,eax
;		storeX	3,2,2,eax
;		storeX	3,3,1,eax
;		storeX	3,3,2,eax
;		storeX	3,4,1,eax
;		storeX	3,4,2,eax
;		storeX	4,1,1,eax
;		storeX	4,2,0,eax
;		storeX	4,2,2,eax
;		storeX	4,3,3,eax
;		storeX	4,5,3,eax
;		storeX	4,6,0,eax
;		storeX	4,6,2,eax
;		storeX	4,7,1,eax
;		mov		[edi+4*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].x,eax
;		mov		[edi+4*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].x,eax
;			;right
;			storeX	1,2,0,edx
;			storeX	1,2,1,edx
;			storeX	1,3,0,edx
;			storeX	1,3,1,edx
;			storeX	1,4,0,edx
;			storeX	1,4,1,edx
;			storeX	2,0,0,edx
;			storeX	2,0,3,edx
;			storeX	2,6,0,edx
;			storeX	2,6,3,edx
;			storeX	2,7,0,edx
;			storeX	2,7,3,edx
;			storeX	5,0,0,edx
;			storeX	5,0,2,edx
;			storeX	5,1,1,edx
;			storeX	5,3,1,edx
;			storeX	5,4,0,edx
;			storeX	5,4,2,edx
;			storeX	5,5,3,edx
;			storeX	5,7,3,edx
;			mov		[edi+5*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].x,edx
;			mov		[edi+5*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].x,edx
;		add		eax,ebx ;-dwCubeStepX
;		sub		edx,ebx ;+dwCubeStepX
;			;left
;			storeX	0,0,0,eax
;			storeX	0,0,1,eax
;			storeX	0,1,2,eax
;			storeX	0,1,3,eax
;			storeX	0,5,2,eax
;			storeX	0,5,3,eax
;			storeX	0,6,0,eax
;			storeX	0,6,1,eax
;			storeX	0,7,0,eax
;			storeX	0,7,1,eax
;			mov		[edi+0*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].x,eax
;			mov		[edi+0*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].x,eax
;			storeX	4,2,1,eax
;			storeX	4,3,0,eax
;			storeX	4,3,2,eax
;			storeX	4,4,3,eax
;			storeX	4,5,0,eax
;			storeX	4,5,2,eax
;			storeX	4,6,1,eax
;			mov		[edi+4*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].x,eax
;				;right
;				storeX	1,1,0,edx
;				storeX	1,1,1,edx
;				storeX	1,2,2,edx
;				storeX	1,2,3,edx
;				storeX	1,3,2,edx
;				storeX	1,3,3,edx
;				storeX	1,4,2,edx
;				storeX	1,4,3,edx
;				storeX	1,5,0,edx
;				storeX	1,5,1,edx
;				mov		[edi+1*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].x,edx
;				mov		[edi+1*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].x,edx
;				storeX	5,0,3,edx
;				storeX	5,1,0,edx
;				storeX	5,1,2,edx
;				storeX	5,2,1,edx
;				storeX	5,3,0,edx
;				storeX	5,3,2,edx
;				storeX	5,4,3,edx
;				mov		[edi+5*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].x,edx
;			add		eax,ebx ;-dwCubeStepX
;			sub		edx,ebx ;+dwCubeStepX
;				;left
;				storeX	0,1,0,eax
;				storeX	0,1,1,eax
;				storeX	0,2,2,eax
;				storeX	0,2,3,eax
;				storeX	0,3,2,eax
;				storeX	0,3,3,eax
;				storeX	0,4,2,eax
;				storeX	0,4,3,eax
;				storeX	0,5,0,eax
;				storeX	0,5,1,eax
;				mov		[edi+0*sizeof RCC_SIDE].MidSqr.ptVert[0*sizeof POINT].x,eax
;				mov		[edi+0*sizeof RCC_SIDE].MidSqr.ptVert[1*sizeof POINT].x,eax
;				storeX	4,3,1,eax
;				storeX	4,4,0,eax
;				storeX	4,4,2,eax
;				storeX	4,5,1,eax
;					;right
;					storeX	1,0,0,edx
;					storeX	1,0,1,edx
;					storeX	1,1,2,edx
;					storeX	1,1,3,edx
;					storeX	1,5,2,edx
;					storeX	1,5,3,edx
;					storeX	1,6,0,edx
;					storeX	1,6,1,edx
;					storeX	1,7,0,edx
;					storeX	1,7,1,edx
;					mov		[edi+1*sizeof RCC_SIDE].MidSqr.ptVert[2*sizeof POINT].x,edx
;					mov		[edi+1*sizeof RCC_SIDE].MidSqr.ptVert[3*sizeof POINT].x,edx
;					storeX	5,1,3,edx
;					storeX	5,2,0,edx
;					storeX	5,2,2,edx
;					storeX	5,3,3,edx
;	mov		ecx,dwCubeWidth
;	mov		eax,rcCube.left
;	mov		edx,rcCube.right
;	add		eax,ecx	;rcCube.left + dwCubeWidth
;	sub		edx,ecx	;rcCube.right - dwCubeWidth
;		;left
;		storeX	0,2,0,eax
;		storeX	0,2,1,eax
;		storeX	0,3,0,eax
;		storeX	0,3,1,eax
;		storeX	0,4,0,eax
;		storeX	0,4,1,eax
;		storeX	4,4,1,eax
;			;right
;			storeX	1,0,2,edx
;			storeX	1,0,3,edx
;			storeX	1,6,2,edx
;			storeX	1,6,3,edx
;			storeX	1,7,2,edx
;			storeX	1,7,3,edx
;			storeX	5,2,3,edx
;	;now we need to store types for all squares
;	nop
;	ret
;
;	assume esi:nothing
;	assume edi:nothing
;CalcRubicsCube endp
; 