;functions
assume ebx:nothing

;get file open name
GetOpenFile proc hWin:HWND,hInst:HINSTANCE,lpszFileName:LPVOID,cbFileName:DWORD,lpszTitle:LPVOID,\
					lpszFilter:LPVOID,lpszDefExt:LPVOID
	
	movc	ecx,NULL
	push	ecx					;lpTemplateName
	push	ecx					;lpfnHook
	push	ecx					;lCustData
	push	lpszDefExt			;lpstrDefExt	;offset DefSeqExt
								;nFileExtension:WORD
	push	ecx					;nFileOffset:WORD
	push	OFN_FILEMUSTEXIST or OFN_EXTENSIONDIFFERENT or OFN_PATHMUSTEXIST or OFN_HIDEREADONLY	;Flags
	push	lpszTitle			;lpstrTitle
	push	ecx					;lpstrInitialDir
	push	ecx					;nMaxFileTitle
	push	ecx					;lpstrFileTitle
	push	cbFileName			;nMaxFile
	push	lpszFileName		;lpstrFile
	push	1					;nFilterIndex
	push	ecx					;nMaxCustFilter
	push	ecx					;lpstrCustomFilter
	push	lpszFilter			;lpstrFilter	;offset SeqFilter
	push	hInst				;hInstance
	push	hWin				;hwndOwner
	push	sizeof OPENFILENAME	;lStructSize
	invoke	GetOpenFileName,esp
	add		esp,(OPENFILENAME ptr [esp]).lStructSize
	ret

GetOpenFile endp

;get file open name
GetSaveFile proc hWin:HWND,hInst:HINSTANCE,lpszFileName:LPVOID,cbFileName:DWORD,lpszTitle:LPVOID,\
					lpszFilter:LPVOID,lpszDefExt:LPVOID
	
	movc	ecx,NULL
	push	ecx					;lpTemplateName
	push	ecx					;lpfnHook
	push	ecx					;lCustData
	push	lpszDefExt			;lpstrDefExt	;offset DefSeqExt
								;nFileExtension:WORD
	push	ecx					;nFileOffset:WORD
	push	OFN_EXTENSIONDIFFERENT or OFN_PATHMUSTEXIST	or OFN_HIDEREADONLY or OFN_CREATEPROMPT or OFN_OVERWRITEPROMPT;Flags
	push	lpszTitle			;lpstrTitle
	push	ecx					;lpstrInitialDir
	push	ecx					;nMaxFileTitle
	push	ecx					;lpstrFileTitle
	push	cbFileName			;nMaxFile
	push	lpszFileName		;lpstrFile
	push	1					;nFilterIndex
	push	ecx					;nMaxCustFilter
	push	ecx					;lpstrCustomFilter
	push	lpszFilter			;lpstrFilter	;offset SeqFilter
	push	hInst				;hInstance
	push	hWin				;hwndOwner
	push	sizeof OPENFILENAME	;lStructSize
	invoke	GetSaveFileName,esp
	add		esp,(OPENFILENAME ptr [esp]).lStructSize
	ret

GetSaveFile endp

;load sequence file
LoadSeq proc uses ebx esi edi lpszFileName:LPVOID
	LOCAL	SeqHead:CSQ_HEAD
	LOCAL	lpSeq:LPVOID
	LOCAL	dwResult:DWORD
	LOCAL	cbRead:DWORD
	LOCAL	hFile:DWORD

	movc	edx,0
	mov		hFile,edx
	mov		dwResult,edx
	mov		lpSeq,edx
	invoke	CreateFile,lpszFileName,GENERIC_READ,NULL,NULL,OPEN_EXISTING,NULL,NULL
	.if eax!=INVALID_HANDLE_VALUE
		lea		ebx,cbRead
		mov		hFile,eax
		lea		esi,SeqHead
		assume esi:ptr CSQ_HEAD
		;read file header
		invoke	ReadFile,hFile,esi,sizeof CSQ_HEAD,ebx,NULL
		mov		ecx,[ebx]
		test	eax,eax
		jz		@FileErr
		cmp		ecx,sizeof CSQ_HEAD
		jne		@FileErr
		invoke	GetFileSize,hFile,NULL
		cmp		eax,INVALID_HANDLE_VALUE
		je		@FileErr
		;check file validity
		mov		edx,[esi].csqId
		mov		ecx,[esi].cbHead
		cmp		edx,SQF_ID
		jne		@FileErr
		cmp		eax,[esi].cbFile
		jne		@FileErr
		cmp		ecx,sizeof CSQ_HEAD
		jne		@FileErr
		mov		eax,[esi].ofsSeq
		mov		ecx,[esi].cbSeq
		lea		edx,[eax+ecx]
		cmp		edx,[esi].cbFile
		ja		@FileErr
		invoke	SetFilePointer,hFile,[esi].ofsSeq,NULL,FILE_BEGIN
		cmp		eax,INVALID_HANDLE_VALUE
		je		@FileErr
		mov		eax,[esi].cbSeq
		inc		eax
		alignValue	eax,sizeof DWORD
		invoke	GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,eax
		test	eax,eax
		jz		@FileErr
		xchg	eax,edi
		mov		lpSeq,edi
		invoke	ReadFile,hFile,edi,[esi].cbSeq,ebx,NULL
		mov		ecx,[esi].cbSeq
		test	eax,eax
		jz		@FileErr
		cmp		ecx,[ebx]
		jne		@FileErr
		;put the terminating -1 in the end of the sequence
		mov		byte ptr [edi+ecx],-1
		lea		edx,[ecx+1]
		invoke	SetSequence,edi,edx,ecx
		test	eax,eax
		jz		@FileErr
		mov		eax,[esi].ofsComment
		mov		ecx,[esi].cbComment
		.if eax && ecx
			invoke	SetFilePointer,hFile,eax,NULL,FILE_BEGIN
			.if eax!=INVALID_HANDLE_VALUE
				invoke	GlobalFree,edi
				movc	edx,0
				mov		ecx,[esi].cbComment
				mov		lpSeq,edx
				inc		ecx
				invoke	GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,ecx
				.if eax
					xchg	eax,edi
					mov		lpSeq,edi
					invoke	ReadFile,hFile,edi,[esi].cbComment,ebx,NULL
					mov		ecx,[esi].cbComment
					.if eax && ecx==[ebx]
						invoke	SetSeqComm,edi,ecx
					.endif
				.endif
			.endif
		.endif
		invoke	GlobalFree,lpSeq
		invoke	CloseHandle,hFile
		inc		dwResult
	.endif
@ret:
	return dwResult

@FileErr:
	;free sequence buffer if allocated
	mov		eax,lpSeq
	.if eax
		invoke	GlobalFree,eax
	.endif
	;free file handle if obtained
	mov		eax,hFile
	.if eax
		invoke	CloseHandle,eax
	.endif
	jmp		@ret

assume esi:nothing
LoadSeq endp

;saves current sequence to the specified file
SaveSeq proc uses ebx esi edi lpszFileName:LPVOID
	LOCAL	SeqHead:CSQ_HEAD
	LOCAL	dwResult:DWORD
	LOCAL	cbWritten:DWORD
	LOCAL	hFile:DWORD

	zeroLocals hFile
	mov		eax,SeqBuf.lpBuf
	.if eax
		lea		edi,SeqHead
		assume edi:ptr CSQ_HEAD
		xchg	esi,eax
		lea		ebx,cbWritten
		movc	ecx,0
		mov		hFile,eax
		invoke	CreateFile,lpszFileName,GENERIC_WRITE,ecx,ecx,CREATE_ALWAYS,ecx,ecx
		;.if eax!=INVALID_HANDLE_VALUE
		cmp		eax,INVALID_HANDLE_VALUE
		je		@FileErr
		mov		hFile,eax
		mov		ecx,cntMoves
		mov		eax,sizeof CSQ_HEAD
		lea		edx,[ecx+eax]
		mov		[edi].csqId,SQF_ID
		mov		[edi].cbFile,edx
		mov		[edi].cbHead,eax
		mov		[edi].ofsSeq,eax
		mov		[edi].cbSeq,ecx
		;set file pointer just after file header position
		invoke	SetFilePointer,hFile,eax,NULL,FILE_BEGIN
		cmp		eax,INVALID_HANDLE_VALUE
		je		@FileErr
		invoke	WriteFile,hFile,esi,cntMoves,ebx,NULL
		mov		ecx,[ebx]
		test	eax,eax
		jz		@FileErr
		cmp		ecx,cntMoves
		jne		@FileErr
		mov		eax,szComment.lpBuf
		mov		ecx,szComment.cbBuf
		.if eax && ecx
			mov		edx,[edi].ofsSeq
			add		edx,[edi].cbSeq
			alignValue	edx,16
			mov		[edi].cbComment,ecx
			mov		[edi].ofsComment,edx
			add		ecx,edx
			add		[edi].cbFile,ecx
			invoke	SetFilePointer,hFile,edx,NULL,FILE_BEGIN
			cmp		eax,INVALID_HANDLE_VALUE
			je		@FileErr
			invoke	WriteFile,hFile,szComment.lpBuf,[edi].cbComment,ebx,NULL
			mov		ecx,[ebx]
			test	eax,eax
			jz		@FileErr
			cmp		ecx,cntMoves
			jne		@FileErr
		.endif
		invoke	SetFilePointer,hFile,0,NULL,FILE_BEGIN
		cmp		eax,INVALID_HANDLE_VALUE
		je		@FileErr
		invoke	WriteFile,hFile,edi,sizeof CSQ_HEAD,ebx,NULL
		mov		ecx,[ebx]
		test	eax,eax
		jz		@FileErr
		cmp		ecx,sizeof CSQ_HEAD
		jne		@FileErr
		invoke	CloseHandle,hFile
		inc		dwResult
@ret:
		mov		eax,dwResult
	.endif
	ret

@FileErr:
	mov		eax,hFile
	.if eax
		invoke	CloseHandle,eax
	.endif
	invoke	DeleteFile,lpszFileName
	jmp		@ret

assume edi:nothing
SaveSeq endp


;PURPOSE
;get offset to file name with of without path

;IN
;lpszFile - ptr to sz file name
;cchFile - count of bytes in file name buffer

;RET
;offset in chars into the string to file name
;if error then return -1

;REMARKS
;

GetFileNameOfs proc uses ebx edi lpszFile:LPVOID,cchFile:DWORD
	
	movc	ebx,-1
	mov		edi,lpszFile
	mov		ecx,cchFile
	;EBX will be offset behind last encountered "\"
	movc	edx,0
	.if ecx
		inc		ebx	;ebx=-1+1=0
		align 16
		.while TRUE
			mov		al,[edi+edx]
			inc		edx
			.break.if al==0 || edx==ecx
			.continue.if al!="\"
			mov		ebx,edx
		.endw
		;if filename=="" then return error
		.if byte ptr [edi+ebx]==0
			movc	ebx,-1
		.endif
	.endif
	return ebx

GetFileNameOfs endp

;shows file name in caption
ShowFileName proc hWin:HWND,lpszFileName:LPVOID
	
	invoke	lstrlen,lpszFileName
	invoke	GetFileNameOfs,lpszFileName,eax
	.if eax!=-1
		add		eax,lpszFileName
		invoke	wsprintf,offset szCaption,offset sz2strings,offset AppName,eax
		invoke	SetWindowText,hWin,offset szCaption
	.endif
	ret

ShowFileName endp


;file functions for cube

LoadCubeState proc uses ebx esi edi lpszFileName:LPVOID,hWin:HWND;,bLoadColors:DWORD
	LOCAL	csfHead:CSF_HEAD
	LOCAL	dwRead:DWORD
	LOCAL	dwResult:DWORD
	LOCAL	hFile:DWORD

	movc	ecx,NULL
	mov		hFile,ecx
	mov		dwResult,ecx
	invoke	CreateFile,lpszFileName,GENERIC_READ,ecx,ecx,OPEN_EXISTING,ecx,ecx	;NULL,NULL,OPEN_EXISTING,NULL,NULL
	.if eax!=INVALID_HANDLE_VALUE
		lea		edi,csfHead
		assume edi:ptr CSF_HEAD
		mov		hFile,eax
		lea		ebx,dwRead
		invoke	ReadFile,hFile,edi,sizeof CSF_HEAD,ebx,NULL
		mov		edx,[ebx]
		test	eax,eax
		jz		@FileErr
		cmp		edx,sizeof CSF_HEAD
		jne		@FileErr
		cmp		edx,[edi].cbHead
		jne		@FileErr
		invoke	GetFileSize,hFile,NULL
		mov		edx,CSF_ID
		cmp		eax,INVALID_HANDLE_VALUE
		je		@FileErr
		cmp		edx,[edi].csfId
		jne		@FileErr
		cmp		eax,[edi].cbFile
		jne		@FileErr
		mov		edx,[edi].ofsColors
		mov		eax,hWin
		lea		ecx,[edx+sizeof arrSideColors]
		;if opening source cube then load colors
		;can load colors if:
		;	this is source cube
		;	.ofsColors in file is not NULL, i.e. is valid
		;	.cbFile >= (.ofsColors + size of all colors)
		.if eax==hSrcWnd && edx && ecx<=[edi].cbFile
			invoke	SetFilePointer,hFile,edx,NULL,FILE_BEGIN
			.if eax!=INVALID_HANDLE_VALUE
				invoke	ReadFile,hFile,offset arrSideColors,sizeof arrSideColors,ebx,NULL
				mov		ecx,[ebx]
				.if eax && ecx==sizeof arrSideColors
					invoke	SendMessage,hWin,RCM_SETCOLORS,FALSE,offset arrSideColors
				.endif
			.endif
		.endif
		;attempt to load cube state into SrcCube
		mov		eax,[edi].ofsCubeState
		lea		ecx,[eax+sizeof CUBE]
		test	eax,eax
		jz		@FileErr
		cmp		ecx,[edi].cbFile
		ja		@FileErr
		invoke	SetFilePointer,hFile,eax,NULL,FILE_BEGIN
		cmp		eax,INVALID_HANDLE_VALUE
		je		@FileErr
		invoke	ReadFile,hFile,offset SrcCube,sizeof CUBE,ebx,NULL
		mov		ecx,[ebx]
		test	eax,eax
		jz		@FileErr
		cmp		ecx,sizeof CUBE
		jne		@FileErr
		invoke	SendMessage,hWin,RCM_SETSTATE,FALSE,offset SrcCube
		mov		eax,[edi].ofsComment
		mov		ecx,[edi].cbComment
		mov		edx,hWin
		;attempt to load cube comment
		;if comment is present (.ofsComment is valid) and we are opening for source cube
		.if eax && edx==hSrcWnd
			invoke	SetFilePointer,hFile,eax,NULL,FILE_BEGIN
			.if eax!=INVALID_HANDLE_VALUE
				invoke	GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,[edi].cbComment
				.if eax
					xchg	esi,eax
					invoke	ReadFile,hFile,esi,[edi].cbComment,ebx,NULL
					mov		ecx,[ebx]
					.if eax && ecx==[edi].cbComment
						invoke	SetCubeComm,esi,ecx
					.endif
					invoke	GlobalFree,esi
				.endif
			.endif
		.endif
		invoke	InvalidateRect,hWin,NULL,TRUE
		invoke	UpdateWindow,hWin
		invoke	CloseHandle,hFile
		inc		dwResult
	.endif
@ret:
	return dwResult

@FileErr:
	mov		eax,hFile
	.if eax
		invoke	CloseHandle,eax
	.endif
	jmp		@ret

assume edi:nothing
LoadCubeState endp

SaveCubeState proc uses ebx esi edi lpszFileName:LPVOID,hWin:HWND
	LOCAL	csfHead:CSF_HEAD
	LOCAL	cbWritten:DWORD
	LOCAL	dwResult:DWORD
	LOCAL	hFile:DWORD

	zeroLocals hFile
	invoke	CreateFile,lpszFileName,GENERIC_WRITE,NULL,NULL,CREATE_ALWAYS,NULL,NULL
	.if eax!=INVALID_HANDLE_VALUE
		lea		esi,csfHead
		assume esi:ptr CSF_HEAD
		mov		hFile,eax
		invoke	GetWindowLong,hWin,GWL_LPCUBE
		xchg	edi,eax
		assume edi:ptr RCC_CUBE
		mov		ecx,sizeof CSF_HEAD
		lea		ebx,cbWritten
		mov		[esi].csfId,CSF_ID
		mov		[esi].cbFile,ecx
		mov		[esi].cbHead,ecx;sizeof CSF_HEAD
		invoke	SetFilePointer,hFile,ecx,NULL,FILE_BEGIN
		mov		edx,hWin
		cmp		eax,INVALID_HANDLE_VALUE
		je		@FileErr
		;if it is a source window then save colors
		.if edx==hSrcWnd
			mov		[esi].ofsColors,eax
			lea		ecx,[edi].rgbSide
			invoke	WriteFile,hFile,ecx,sizeof arrSideColors,ebx,NULL
			mov		ecx,[ebx]
			test	eax,eax
			jz		@FileErr
			cmp		ecx,sizeof arrSideColors
			jne		@FileErr
			add		ecx,[esi].ofsColors
			mov		[esi].cbFile,ecx
			invoke	SetFilePointer,hFile,ecx,NULL,FILE_BEGIN
			cmp		eax,INVALID_HANDLE_VALUE
			je		@FileErr
		.endif
		mov		[esi].ofsCubeState,eax
		invoke	SendMessage,hWin,RCM_GETSTATE,NULL,offset SrcCube
;		test	eax,eax
;		jz		@FileErr
		invoke	WriteFile,hFile,offset SrcCube,sizeof CUBE,ebx,NULL
		mov		ecx,[ebx]
		test	eax,eax
		jz		@FileErr
		cmp		ecx,sizeof CUBE
		jne		@FileErr
		add		ecx,[esi].ofsCubeState
		mov		eax,hWin
		mov		edx,szCubeComm.lpBuf
		mov		[esi].cbFile,ecx
		.if edx && eax==hSrcWnd
		;if (szCubeComm.lpBuf != 0) && (hWin != hSrcWnd)
			mov		edi,edx
			mov		[esi].ofsComment,ecx
			invoke	lstrlen,edi	;szCubeComm.lpBuf
			.if !eax
				mov		[esi].ofsComment,eax	;movc	[esi].ofsComment,0
			.else
				inc		eax
				mov		[esi].cbComment,eax
				invoke	SetFilePointer,hFile,[esi].ofsComment,NULL,FILE_BEGIN
				cmp		eax,INVALID_HANDLE_VALUE
				je		@FileErr
				invoke	WriteFile,hFile,edi,[esi].cbComment,ebx,NULL
				mov		ecx,[ebx]
				test	eax,eax
				jz		@FileErr
				cmp		ecx,[esi].cbComment
				jne		@FileErr
			.endif
		.endif
		invoke	SetFilePointer,hFile,0,NULL,FILE_BEGIN
		cmp		eax,INVALID_HANDLE_VALUE
		je		@FileErr
		invoke	WriteFile,hFile,esi,sizeof CSF_HEAD,ebx,NULL
		test	eax,eax
		jz		@FileErr
		cmp		dword ptr [ebx],sizeof CSF_HEAD
		jne		@FileErr
		invoke	CloseHandle,hFile
		inc		dwResult
	.endif
@ret:
	return dwResult

@FileErr:
	mov		eax,hFile
	.if eax
		invoke	CloseHandle,eax
	.endif
	invoke	DeleteFile,lpszFileName
	jmp		@ret

	assume esi:nothing
SaveCubeState endp


