;Rubik's cube Emulator
;by SolidCode.

;Assemble with this: 3,O,$B\ML.EXE /c /coff /Cp /nologo /I"$I",2
;Link with this: 5,O,$B\LINK.EXE /SUBSYSTEM:WINDOWS /RELEASE /FILEALIGN:512 /STUB:"stub.exe" /VERSION:4.0 /LIBPATH:"$L" /OUT:"$5",3,4

.686p
.MMX
.XMM
.model flat,stdcall
option casemap:none

include rubicube.inc

.code
;TIMES equ 100000;0

start proc

;	movaps	xmm0,oword ptr [dbSide]
;	movapd	xmm1,oword ptr [dbSide+16]
;	nop
;	xmm_movsd	xmm0,xmm1
;	nop
;;	shufpd	xmm0,xmm1,SIMD_XCHG
;	xmm_minus1	xmm0
;	xmm_zero	xmm1
;	pshufd	xmm0,xmm1,SIMD_XCHG
	invoke	IsFast
	invoke	GetProcessHeap
	mov		hProcHeap,eax
	invoke	GetModuleHandle,NULL
	mov		hInstance,eax
	invoke	InitCubeCtrl,eax
	;invoke InitCommonControls
	invoke	GetCommandLine
	mov		CommandLine,eax
	invoke	WinMain,hInstance,NULL,eax,SW_SHOWDEFAULT	;CommandLine,SW_SHOWDEFAULT
	invoke	ExitProcess,eax

start endp

;--------------------------------------------------------------------------------

WinMain proc uses ebx hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	msg:MSG

	invoke	RtlMoveMemory,offset arrSideColors,offset DefColors,sizeof arrSideColors
	mov		UndefSideColor,00C0C0C0h
	mov		Setts.dwMaxMoves,MAX_MOVES
	mov		Setts.dwCurrPrior,4
	invoke	LoadSettings
	.if !(bStats & fCANFAST)
		setfl	Setts.bSets,fNOFAST
	.endif
	invoke	LoadIcon,NULL,IDI_APPLICATION
	xchg	eax,ebx
	invoke	LoadCursor,NULL,IDC_ARROW
	RegClass CS_HREDRAW or CS_VREDRAW,offset WndProc,NULL,DLGWINDOWEXTRA,hInst,ebx,eax,\
			COLOR_BTNFACE+1,IDM_MENU,offset ClassName,ebx
	invoke	CreateDialogParam,hInst,IDD_MAIN,NULL,offset WndProc,NULL
	.if eax
		mov		hWnd,eax
		invoke	ShowWindow,hWnd,SW_SHOWNORMAL
		invoke	UpdateWindow,hWnd
		lea		ebx,msg
		.while TRUE
			invoke	GetMessage,ebx,NULL,0,0
			.break .if !eax
			invoke	TranslateMessage,ebx	;addr msg
			invoke	DispatchMessage,ebx	;addr msg
		.endw
	.endif
	mov		eax,SeqBuf.lpBuf
	.if eax
		invoke	HeapFree,hProcHeap,NULL,eax
		movc	SeqBuf.lpBuf,0
	.endif
	mov		eax,szComment.lpBuf
	.if eax
		invoke	HeapFree,hProcHeap,NULL,eax
		movc	szComment.lpBuf,0
	.endif
	mov		eax,szCubeComm.lpBuf
	.if eax
		invoke	HeapFree,hProcHeap,NULL,eax
		movc	szCubeComm.lpBuf,0
	.endif
	mov		eax,msg.wParam
	ret

WinMain endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_COMMAND
		mov		eax,wParam
		.if eax==IDM_DEFSEQ	;for menu commands hi word of wParam == NULL
			call	StopRec
			invoke	SetSequence,offset Side2Move,sizeof Side2Move+sizeof NoMove,sizeof Side2Move
			.if eax
@showseq:
				invoke	GetDlgItem,hWin,IDE_SEQ
				invoke	ShowSequence,eax,SeqBuf.lpBuf,cntMoves
			.endif
		.elseif eax==IDM_LOADSEQ
			call	StopRec
			invoke	GetOpenFile,hWin,hInstance,offset szSeqFileName,sizeof szSeqFileName-1,\
					offset SeqOpenTitle,offset SeqFilter,offset DefSeqExt
;			invoke	lstrcpy,offset szSeqFileName,offset szDefSeq
			.if eax
				invoke	LoadSeq,offset szSeqFileName
				.if eax
@showfilename:
					invoke	ShowFileName,hWin,offset szSeqFileName
					jmp		@showseq
				.endif
			.endif
		.elseif eax==IDM_SAVSEQ
			call	StopRec
;			invoke	lstrcpy,offset szSeqFileName,offset szDefSeq
			call	SeqSave
			test	eax,eax
			jnz		@showfilename
		.elseif eax==IDM_SAVSEQAS
			call	StopRec
			call	SeqSaveAs
			test	eax,eax
			jnz		@showfilename
		.elseif eax==IDM_CLEARSEQ
			call	StopRec
			call	@ClrSeq
		.elseif eax==IDM_RECSEQ
			.if !(bStats & fRECORDING)
				call	@ClrSeq
				mov		byte ptr [szSeqFileName],0	;szSeqFileName="";
				setfl	bStats,fRECORDING
			.endif
		.elseif eax==IDM_STOPREC
			call	StopRec
		.elseif eax==IDM_SRCASMCB	;assemble source cube
			call	StopRec
			invoke	SendMessage,hSrcWnd,RCM_SETSTATE,TRUE,offset AsmCube
		.elseif eax==IDM_SRCLOADCB
			call	StopRec
			invoke	GetOpenFile,hWin,hInstance,offset szSrcCubeFileName,sizeof szSrcCubeFileName-1,\
					offset StatOpenTitle,offset StatFilter,offset DefStatExt
;			invoke	lstrcpy,offset szSrcCubeFileName,offset szDefCube
			.if eax
				invoke	LoadCubeState,offset szSrcCubeFileName,hSrcWnd
				.if eax
@SrcWndName:
					invoke	GetFileNameOfs,offset szSrcCubeFileName,sizeof szSrcCubeFileName-1
					.if eax!=-1
						add		eax,offset szSrcCubeFileName
						invoke	wsprintf,offset szString,offset sz2strings,offset szSrcCb,eax
						invoke	SetDlgItemText,hWin,IDG_SRC,offset szString
					.endif
				.endif
			.endif
		.elseif eax==IDM_SRCSAVCB
			call	StopRec
			;invoke	lstrcpy,offset szSrcCubeFileName,offset szDefCube
			mov		al,szSrcCubeFileName
			test	al,al
			jz		@srcsavas
@srcsav:
			invoke	SaveCubeState,offset szSrcCubeFileName,hSrcWnd
			test	eax,eax
			jnz		@SrcWndName
		.elseif eax==IDM_SRCSAVCBAS
			call	StopRec
@srcsavas:
			invoke	GetSaveFile,hWin,hInstance,offset szSrcCubeFileName,sizeof szSrcCubeFileName-1,\
					offset StatSaveTitle,offset StatFilter,offset DefStatExt
;			invoke	lstrcpy,offset szSrcCubeFileName,offset szDefCube
			test	eax,eax
			jnz		@srcsav
		.elseif eax==IDM_SRCCOPY
			call	StopRec
@srccbcopy:
			invoke	SendMessage,hSrcWnd,RCM_GETSTATE,NULL,offset SrcCube
			invoke	SendMessage,hDestWnd,RCM_SETSTATE,TRUE,offset SrcCube
		.elseif eax==IDM_DSTASMCB
			call	StopRec
			invoke	SendMessage,hDestWnd,RCM_SETSTATE,TRUE,offset AsmCube
		.elseif eax==IDM_DSTLOADCB
			call	StopRec
;			invoke	lstrcpy,offset szDstCubeFileName,offset szDefCube
			invoke	GetOpenFile,hWin,hInstance,offset szDstCubeFileName,sizeof szDstCubeFileName-1,\
					offset StatOpenTitle,offset StatFilter,offset DefStatExt
			.if eax
				 invoke	LoadCubeState,offset szDstCubeFileName,hDestWnd
				.if eax
@DstWndName:
					invoke	GetFileNameOfs,offset szDstCubeFileName,sizeof szDstCubeFileName-1
					.if eax!=-1
						add		eax,offset szDstCubeFileName
						invoke	wsprintf,offset szString,offset sz2strings,offset szDstCb,eax
						invoke	SetDlgItemText,hWin,IDG_DEST,offset szString
					.endif
				.endif
			.endif
		.elseif eax==IDM_DSTSAVCB
			call	StopRec
;			invoke	lstrcpy,offset szDstCubeFileName,offset szDefCube
			mov		al,szDstCubeFileName
			test	al,al
			jz		@dstsavas
@dstsav:
			invoke	SaveCubeState,offset szDstCubeFileName,hDestWnd
			test	eax,eax
			jnz		@DstWndName
		.elseif eax==IDM_DSTSAVCBAS
			call	StopRec
@dstsavas:
;			invoke	lstrcpy,offset szDstCubeFileName,offset szDefCube
			invoke	GetSaveFile,hWin,hInstance,offset szDstCubeFileName,sizeof szDstCubeFileName-1,\
					offset StatSaveTitle,offset StatFilter,offset DefStatExt
			test	eax,eax
			jnz		@dstsav
		.elseif eax==IDM_DSTCOPY
			call	StopRec
			invoke	SendMessage,hDestWnd,RCM_GETSTATE,NULL,offset DestCube
			invoke	SendMessage,hSrcWnd,RCM_SETSTATE,TRUE,offset DestCube
		.elseif eax==IDM_FINDSEQ
			call	StopRec
			.if !(bStats & fSEARCHING)
				invoke	SendMessage,hSrcWnd,RCM_GETSTATE,NULL,offset SrcCube
				invoke	SendMessage,hDestWnd,RCM_GETSTATE,NULL,offset DestCube
				mov		dl,Setts.bSets
				.if dl & fNOTHREAD
					setfl	bStats,fSEARCHING
					invoke	EnableWindow,hWin,FALSE
					invoke	CreateDialogParam,hInstance,IDD_FINDSEQ,hWnd,offset FindSeqDlgProc,NULL
					mov		hFindSeqDlg,eax
					invoke	FindSeqThread,NULL
					invoke	EnableWindow,hWin,TRUE
				.else
					invoke	CreateThread,NULL,NULL,offset FindSeqThread,NULL,CREATE_SUSPENDED,offset FindSeqThreadID
					mov		hFindSeqThread,eax
					.if eax
						mov		edx,Setts.dwCurrPrior
						mov		ecx,offset dwPriority
						invoke	SetThreadPriority,eax,dword ptr [ecx+edx*sizeof DWORD]
						.if eax
							setfl	bStats,fSEARCHING
							invoke	CreateDialogParam,hInstance,IDD_FINDSEQ,hWnd,offset FindSeqDlgProc,NULL
							mov		hFindSeqDlg,eax
							invoke	ResumeThread,hFindSeqThread
						.endif
					.endif
				.endif
			.endif
		.elseif eax==IDM_EXESEQ || eax == makelong(IDB_EXESEQ,BN_CLICKED)
			call	StopRec
			invoke	GetDlgItemText,hWin,IDE_SEQ,offset szString,sizeof szString-1
			.if !eax
				invoke	GetLastError
				;if there was no error, just empty sequence
				;then copy source cube to the dest cube
				test	eax,eax	;if EAX == NO_ERROR then copy src cube to dest cube
				jz		@srccbcopy
			.else
				.if eax>=sizeof SeqBuffer-1
					call	@ClrSeq
				.else
					invoke	SendMessage,hSrcWnd,RCM_GETSTATE,NULL,offset SrcCube
					invoke	String2Seq,offset SeqBuffer,offset szString,sizeof SeqBuffer-1
					.if eax
						movc	edx,FALSE
						.if bStats & fCANFAST	;if SSE2 is supported
							test	Setts.bSets,fNOFAST	;if SSE2 is not forbidden by the user
							setz	dl			;then use SSE2 accelerated code
						.endif
						invoke	ExeSeq,offset SeqBuffer,eax,offset SrcCube,edx
						invoke	SendMessage,hDestWnd,RCM_SETSTATE,TRUE,offset SrcCube
					.endif
				.endif
			.endif
		.elseif eax==IDM_OPTSEQ
			call	StopRec
			invoke	GetDlgItemText,hWin,IDE_SEQ,offset szString,sizeof szString-1
			.if eax
				.if eax>=sizeof SeqBuffer-1
					call	@ClrSeq
				.else
					invoke	String2Seq,offset SeqBuffer,offset szString,sizeof SeqBuffer-1
					.if eax
						invoke	OptimizeSeq,offset SeqBuffer,eax
						invoke	Seq2String,offset SeqBuffer,offset szString,eax
						invoke	SetDlgItemText,hWin,IDE_SEQ,offset szString
					.endif
				.endif
			.endif
		.elseif eax==IDM_SWAPCBS
			call	StopRec
			invoke	SendMessage,hSrcWnd,RCM_GETSTATE,NULL,offset SrcCube
			invoke	SendMessage,hDestWnd,RCM_GETSTATE,NULL,offset DestCube
			invoke	SendMessage,hSrcWnd,RCM_SETSTATE,TRUE,offset DestCube
			invoke	SendMessage,hDestWnd,RCM_SETSTATE,TRUE,offset SrcCube
		.elseif eax==IDM_DEFCLR
			invoke	RtlMoveMemory,offset arrSideColors,offset DefColors,sizeof arrSideColors
			mov		UndefSideColor,00C0C0C0h
			invoke	SendMessage,hSrcWnd,RCM_SETCOLORS,FALSE,offset arrSideColors
			invoke	SendMessage,hDestWnd,RCM_SETCOLORS,FALSE,offset arrSideColors
			invoke	InvalidateRect,hWin,NULL,TRUE
			invoke	UpdateWindow,hWin
		.elseif eax==IDM_SIDECLR
			invoke	DialogBoxParam,hInstance,IDD_SIDECLR,hWin,offset SideClrProc,NULL
		.elseif eax==IDM_SEQCOMM
			invoke	EditComment,hWin,offset szComment
		.elseif eax==IDM_CBCOMM
			invoke	EditComment,hWin,offset szCubeComm
		.elseif eax==IDM_OPTS
			invoke	DialogBoxParam,hInstance,IDD_SETS,hWin,offset SetsDlgProc,NULL
		.elseif eax==IDM_SAVESETS
			invoke	SaveSettings
		.elseif eax==IDM_HELP
			invoke	CreateDialogParam,hInstance,IDD_HELP,hWin,offset HelpDlgProc,NULL
		.elseif eax==IDM_HELP_ABOUT
			invoke ShellAbout,hWin,offset AppName,offset AboutMsg,NULL
		.elseif eax==makelong(IDE_SEQ,EN_CHANGE)
			.if !(bStats&fRECMOVE)
				call	StopRec
			.endif
		.endif
	.elseif eax==WM_SETFOCUS
		invoke	GetDlgItem,hWin,IDE_SEQ
		invoke	SetFocus,eax
	.elseif eax==WM_CLOSE
@close:
		call	StopRec
		call	@DelBrush
		invoke DestroyWindow,hWin
	.elseif eax==WM_DESTROY
		call	StopRec
		invoke PostQuitMessage,NULL
	.else
		.if eax==WM_INITDIALOG
			mov		eax,hWin
			mov		hWnd,eax
			invoke	GetDlgItem,hWin,IDG_SRC
			invoke	GetClientRect,eax,offset SrcRect
			sub		SrcRect.right,10
			sub		SrcRect.bottom,10
			add		SrcRect.left,10
			add		SrcRect.top,20
			invoke	GetDlgItem,hWin,IDG_SRC
			invoke	CreateCubeCtrl,eax,hInstance,offset SrcRect
			mov		hSrcWnd,eax
			invoke	SendMessage,eax,RCM_SETCOLORS,FALSE,offset arrSideColors
			invoke	GetDlgItem,hWin,IDG_DEST
			invoke	GetClientRect,eax,offset DestRect
			sub		DestRect.right,10
			sub		DestRect.bottom,10
			add		DestRect.left,10
			add		DestRect.top,20
			invoke	GetDlgItem,hWin,IDG_DEST
			invoke	CreateCubeCtrl,eax,hInstance,offset DestRect
			mov		hDestWnd,eax
			invoke	SendMessage,eax,RCM_SETCOLORS,FALSE,offset arrSideColors
			invoke	SendDlgItemMessage,hWin,IDE_SEQ,EM_CANUNDO,NULL,NULL	;enable undo
			invoke	SendDlgItemMessage,hWin,IDE_SEQ,EM_CANREDO,NULL,NULL
			invoke	GetDlgItem,hWin,IDE_SEQ
			invoke	SetWindowLong,eax,GWL_WNDPROC,offset GetCrWndProc
			mov		lpfnOldEdit,eax
			invoke	LoadIcon,hInstance,IDI_MAIN
			mov		hIcon,eax
			push	eax
				invoke	SendMessage,hWin,WM_SETICON,ICON_BIG,eax
			push	ICON_SMALL
			push	WM_SETICON
			push	hWin
			call	SendMessage
			movc	eax,TRUE
			jmp		@ret
		.endif
		.if eax==WM_CTLCOLOREDIT && bStats&fRECORDING
			call	@DelBrush
			invoke	SetBkMode,wParam,TRANSPARENT
			invoke	CreateSolidBrush,00D0FFFFh
			mov		hEdBrush,eax
			jmp		@ret
		.endif
		mov		eax,dword ptr [DefWindowProc+2]
		mov		esp,ebp
		mov		eax,[eax]
		pop		ebp
		jmp		eax
		;invoke DefWindowProc,hWin,uMsg,wParam,lParam
		;ret
	.endif
@exit:
	movc   eax,NULL
@ret:
	ret

@DelBrush:
	mov		eax,hEdBrush
	.if eax
		invoke	DeleteObject,eax
	.endif
	retn

@ClrSeq:
	invoke	SetSequence,offset NoMove,sizeof NoMove,sizeof NoMove - 1
	invoke	SetDlgItemText,hWin,IDE_SEQ,offset szEmpty
	invoke	SetWindowText,hWin,offset AppName
	mov		byte ptr [szSeqFileName],0
	retn

WndProc endp

;PURPOSE
;save file into szSeqFileName
;RET
;return NULL if error or non-NULL otherwise
SeqSave proc
	
	.if byte ptr [szSeqFileName]==0
SeqSaveAs::
		invoke	GetSaveFile,hWnd,hInstance,offset szSeqFileName,sizeof szSeqFileName-1,\
				offset SeqSaveTitle,offset SeqFilter,offset DefSeqExt
;		invoke	lstrcpy,offset szSeqFileName,offset szDefSeq
		test	eax,eax
		jz		@ret
	.endif
	invoke	GetDlgItemText,hWnd,IDE_SEQ,offset szString,sizeof szString-1
	invoke	String2Seq,offset SeqBuffer,offset szString,sizeof szString-1
	invoke	SetSequence,offset SeqBuffer,sizeof SeqBuffer,eax
	.if eax
		invoke	SaveSeq,offset szSeqFileName
	.endif
@ret:
	ret

SeqSave endp

StopRec proc

	.if bStats & fRECORDING
		;if we were recording then stop it appropriately
		invoke	MessageBox,hWnd,offset szStopRec,offset AppName,MB_YESNOCANCEL
		cmp		eax,IDNO
		je		@F
		.if eax==IDYES
			call	SeqSave
@@:
			clrfl	bStats,fRECORDING
			invoke	GetDlgItem,hWnd,IDE_SEQ
			push	eax
				invoke	InvalidateRect,eax,NULL,TRUE
			call	UpdateWindow
		.endif
	.endif
	ret

StopRec endp

GetCrWndProc proc hWin:HWND,iMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
	mov		eax,iMsg
	mov		edx,wParam
	.if eax==WM_KEYDOWN && edx==VK_RETURN
		invoke	SendMessage,hWnd,WM_COMMAND,IDM_EXESEQ,NULL
	.endif
	mov		esp,ebp
	mov		ecx,lpfnOldEdit
	pop		ebp
	jmp		ecx
	
;	.if eax!=WM_KEYDOWN
;@DefProc:
;		mov		esp,ebp
;		mov		ecx,lpfnOldEdit
;		pop		ebp
;		movc	eax,NULL
;		jmp		ecx
;	.endif
;	.if edx==VK_RETURN
;		invoke	SendMessage,hWnd,WM_COMMAND,IDM_EXESEQ,NULL
;	.elseif edx>=VK_PRIOR
;		cmp		edx,VK_DOWN
;		jbe		@DefProc
;		cmp		edx,VK_DELETE
;		je		@DefProc
;		cmp		edx,VK_TAB
;		je		@DefProc
;	.endif
;@ret:
	return NULL

GetCrWndProc endp

SideClrProc proc uses ebx esi edi hWin:HWND,iMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
	mov		eax,iMsg
	.if eax==WM_COMMAND
		mov		eax,wParam
		cmp		eax,makelong(IDB_CANCEL,BN_CLICKED)
		je		@close
		.if eax==makelong(IDB_OK,BN_CLICKED)
			call	@ApplyColors
			jmp		@close
		.endif
		.if eax==makelong(IDB_APPLY,BN_CLICKED)
			call	@ApplyColors
		;if one of the static controls was clicked
		;then find out which one and get a color for it
		.elseif (eax >= makelong(IDS_SC0,STN_CLICKED)) && (eax <= makelong(IDS_SC6,STN_CLICKED))
			sub		eax,makelong(IDS_SC0,STN_CLICKED) 
			lea		esi,[eax*sizeof SIDECOLOR+offset arrTempColors]
			invoke	GetColorDlg,hWin,esi
			.if eax
				invoke	InvalidateRect,lParam,NULL,TRUE
				invoke	UpdateWindow,lParam
			.endif
		.endif
	.elseif eax==WM_CLOSE
@close:
		;when closing release all the currently used brushes
		mov		esi,offset arrTempColors
		mov		ebx,(offset arrTempColors + sizeof SIDECOLOR*7)
		assume esi:ptr SIDECOLOR
		.repeat
			invoke	DeleteObject,[esi].hBrush
			movc	HBRUSH ptr [esi].hBrush,NULL
			add		esi,sizeof SIDECOLOR
		.until esi>=ebx
		invoke	EndDialog,hWin,NULL
	.elseif eax==WM_INITDIALOG
		;Paint cube sides
		invoke	SendMessage,hSrcWnd,RCM_GETCOLORS,NULL,offset arrSideColors
		mov		ebx,NULL
		mov		esi,offset arrSideColors
		mov		edi,offset arrTempColors
		assume esi:RGBQUAD
		assume edi:ptr SIDECOLOR
		.repeat
			mov		eax,[esi+ebx*sizeof DWORD]
			mov		[edi+ebx*sizeof SIDECOLOR].rgbColor,eax
			inc		ebx
		.until ebx>6
		invoke	SendMessage,hWin,WM_SETICON,ICON_SMALL,hIcon
	.else
		.if eax==WM_CTLCOLORSTATIC
			;get ID of this control
			invoke	GetWindowLong,lParam,GWL_ID
			sub		eax,IDS_SC0
			.if !SIGN? && eax<=6
				xchg	eax,edi
				mov		esi,offset arrTempColors
				assume esi:ptr SIDECOLOR
				invoke SetBkMode,wParam,TRANSPARENT
				mov		ebx,[esi+edi*sizeof SIDECOLOR].rgbColor
				mov		edx,[esi+edi*sizeof SIDECOLOR].hBrush
				.if edx
					invoke	DeleteObject,edx
				.endif
				and		ebx,00FFFFFFh
				invoke	CreateSolidBrush,ebx
				mov		[esi+edi*sizeof SIDECOLOR].hBrush,eax
				ret
			.endif
		.endif
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

@ApplyColors:
	mov		esi,offset arrTempColors
	mov		edi,offset arrSideColors
	assume esi:ptr SIDECOLOR
	assume edi:ptr RGBQUAD
	movc	ebx,0
	.repeat
		mov		eax,[esi+ebx*sizeof SIDECOLOR].rgbColor
		mov		dword ptr [edi+ebx*sizeof RGBQUAD],eax
		inc		ebx
	.until ebx>6
	invoke	SendMessage,hSrcWnd,RCM_SETCOLORS,FALSE,offset arrSideColors
	invoke	SendMessage,hDestWnd,RCM_SETCOLORS,FALSE,offset arrSideColors
	invoke	GetWindowLong,hWin,GWL_HWNDPARENT
	.if eax
		push	eax
			invoke	InvalidateRect,eax,NULL,TRUE
		call	UpdateWindow
		;invoke	UpdateWindow,eax
	.endif
	retn

	assume esi:nothing
	assume edi:nothing
SideClrProc endp

GetColorDlg proc hWin:HWND,lpClr:LPVOID
	
	movc	ecx,NULL
	mov		edx,lpClr
	;create CHOOSECOLOR structure in stack
	push	ecx;NULL	;lpTemplateName
	push	ecx;NULL	;lpfnHook
	push	ecx;NULL	;lCustData
	push	CC_FULLOPEN or CC_RGBINIT	;Flags
	push	offset arrCustColor	;lpCustColors
	push	dword ptr [edx]		;rgbResult
	push	ecx;NULL	;hInstance
	push	hWin		;hwndOwner
	push	sizeof CHOOSECOLOR	;lStructSize
		invoke	ChooseColor,esp
		.if eax
			mov		edx,(CHOOSECOLOR ptr [esp]).rgbResult
			mov		ecx,lpClr
			mov		[ecx],edx
		.endif
	;release the CHOOSECOLOR structure from stack
	add		esp,(CHOOSECOLOR ptr [esp]).lStructSize	;add	esp,sizeof CHOOSECOLOR
	ret

GetColorDlg endp

SetsDlgProc proc uses ebx esi edi hWin:HWND,iMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	hWinParent:DWORD

	mov		eax,iMsg
	.if eax==WM_COMMAND
		mov		eax,wParam
		cmp		eax,makelong(IDB_SCANC,BN_CLICKED)
		je		@exit
		.if eax==makelong(IDB_SOK,BN_CLICKED)
			call	@ReadSets
			jmp		@exit
		.endif
		.if eax==makelong(IDB_SAVESETS,BN_CLICKED)
			call	@ReadSets
			invoke	SaveSettings
		.elseif eax==makelong(IDCB_PRIOR,CBN_SELCHANGE)
			movc	edi,NULL
			mov		ebx,CB_GETCURSEL
			movc	edx,NULL
			call	@ComboMsg
			.if eax<2
				invoke	MessageBox,hWin,offset szHighPrior,offset AppName,MB_OK or MB_ICONEXCLAMATION
			.endif
		.elseif eax==makelong(IDC_NOFINDTHREAD,BN_CLICKED)
			call	@EnableThread
		.endif
	.elseif eax==WM_HSCROLL
		mov		eax,wParam
		mov		edx,eax
		shr		edx,16
		and		eax,0000FFFFh
		.if eax==TB_THUMBTRACK || eax==TB_THUMBPOSITION || eax==TB_BOTTOM || eax==TB_ENDTRACK || eax==TB_LINEDOWN || eax==TB_LINEUP || eax==TB_PAGEDOWN || eax==TB_PAGEUP || eax==TB_TOP
			call	@SetFreq
		.endif
	.elseif eax==WM_CLOSE
@exit:
		invoke	EndDialog,hWin,NULL
	.elseif eax==WM_INITDIALOG
		mov		bl,Setts.bSets
		mov		edi,offset @SetCheck
		.if bStats & fCANFAST
			invoke	GetDlgItem,hWin,IDC_NOSSE2
			invoke	EnableWindow,eax,TRUE
			mov		cl,fNOFAST
			mov		edx,IDC_NOSSE2
			call	edi	;@SetCheck
		.endif
		mov		edx,IDC_SQRNUMS
		mov		cl,fSHOWNUM
		call	edi	;@SetCheck
		mov		edx,IDC_NOFINDTHREAD
		mov		cl,fNOTHREAD
		call	edi	;@SetCheck
		mov		edx,IDC_SAVESIDECLR
		mov		cl,fSIDECLR
		call	edi	;@SetCheck
		invoke	SendMessage,hWin,WM_SETICON,ICON_SMALL,hIcon
		invoke	SetDlgItemInt,hWin,IDE_MAXMOVE,Setts.dwMaxMoves,FALSE
		invoke	SendDlgItemMessage,hWin,IDE_MAXMOVE,EM_LIMITTEXT,3,NULL
		movc	edi,NULL
		mov		ebx,CB_RESETCONTENT
		movc	edx,NULL
		call	@ComboMsg
		mov		edi,offset szPriority
		mov		ebx,CB_ADDSTRING
		mov		esi,5
		.repeat
			movc	edx,NULL
			call	@ComboMsg
			cld
			movc	eax,0
			movc	ecx,-1
			repne	scasb
			dec		esi
		.until ZERO?
		mov		ebx,CB_SETCURSEL
		mov		edx,Setts.dwCurrPrior
		movc	edi,NULL
		call	@ComboMsg
		call	@EnableThread
		invoke	GetDlgItem,hWin,IDTB_UPDATE
		xchg	eax,esi
		invoke	SendMessage,esi,TBM_SETRANGE,TRUE,makelong(0,10)
		mov		eax,Setts.dwUpdateFreq
		shr		eax,5	;eax/32
		bsr		eax,eax
		invoke	SendMessage,esi,TBM_SETPOS,TRUE,eax
		call	@SetFreq
	.else
		movc	eax,NULL
@ret:
		ret
	.endif
	movc	eax,TRUE
	jmp		@ret

;sets checkbox to the respective flag
;BL - const
;EDX - checkbox ID
;CL - flag to check
@SetCheck:
	movzx	eax,bl
	test	al,cl;fNOFAST
	setnz	al
	invoke	SendDlgItemMessage,hWin,edx,BM_SETCHECK,eax,NULL
	retn

;ESI - ptr to byte var that receives the flags
;EDX - checkbox ID
;CL - flag to retrieve
@GetCheck:
	push	ecx
		invoke	SendDlgItemMessage,hWin,edx,BM_GETCHECK,NULL,NULL
		neg		al	;if BST_UNCHECKED then eax=0 else if eax==BST_CHECKED then eax==-1
	pop		ecx
	and		al,cl	;if eax==-1 then eax= fNOFAST else eax=0
	not		cl
	and		byte ptr [esi],cl
	or		byte ptr [esi],al;if eax
	retn

;EBX - combo command
;EDX - wParam
;EDI - lParam
@ComboMsg:
	pop		eax
	push	edi
	push	edx
	push	ebx
	push	IDCB_PRIOR
	mov		edx,dword ptr [SendDlgItemMessage+2]
	push	hWin
	mov		edx,[edx]
	push	eax
	jmp		edx
	;invoke	SendDlgItemMessage,hWin,IDCB_PRIOR,ebx,edx,edi
	;retn

@EnableThread:
	invoke	SendDlgItemMessage,hWin,IDC_NOFINDTHREAD,BM_GETCHECK,NULL,NULL
	notfl	eax,01
	push	eax
		push	eax
			invoke	GetDlgItem,hWin,IDCB_PRIOR
		push	eax
		call	EnableWindow
		invoke	GetDlgItem,hWin,IDTB_UPDATE
	push	eax
	call	EnableWindow
	;invoke	EnableWindow,eax,ebx
	retn

@GetFreq:
	invoke	SendDlgItemMessage,hWin,IDTB_UPDATE,TBM_GETPOS,NULL,NULL
	movc	ecx,0
	add		eax,5
	inc		ecx
	xchg	eax,ecx
	shl		eax,cl
	retn

;EDX - position of slider in track bar
@SetFreq:
	call	@GetFreq
	movc	edx,0
	mov		ecx,1000
	div		ecx
	invoke	wsprintf,offset szString,offset szSecs,eax,edx
	invoke	SetDlgItemText,hWin,IDS_SECS,offset szString
	retn

@ReadSets:
	mov		esi,offset Setts.bSets
	mov		ebx,offset @GetCheck
	.if bStats & fCANFAST
		mov		edx,IDC_NOSSE2
		mov		cl,fNOFAST
		call	ebx	;@GetCheck
	.endif
	mov		edx,IDC_SQRNUMS
	mov		cl,fSHOWNUM
	call	ebx	;@GetCheck
	mov		edx,IDC_NOFINDTHREAD
	mov		cl,fNOTHREAD
	call	ebx	;@GetCheck
	mov		edx,IDC_SAVESIDECLR
	mov		cl,fSIDECLR
	call	ebx	;@GetCheck
	;get update frequency
	call	@GetFreq
	mov		Setts.dwUpdateFreq,eax
	;get priority
	movc	edx,NULL
	mov		ebx,CB_GETCURSEL
	mov		edi,edx
	call	@ComboMsg
	mov		Setts.dwCurrPrior,eax
	;get amount of max moves
	push	FALSE	;make a temp var in stack
		mov		eax,esp
		invoke	GetDlgItemInt,hWin,IDE_MAXMOVE,eax,FALSE
	pop		edx
	;if error then eax=MAX_MOVES
	;if too big value then eax=MAX_MOVES
	.if !edx || eax>MAX_MOVES
		mov		eax,MAX_MOVES
	.endif
	mov		Setts.dwMaxMoves,eax
	invoke	GetWindowLong,hWin,GWL_HWNDPARENT
	push	eax
		invoke	InvalidateRect,eax,NULL,TRUE
	call	UpdateWindow
	;invoke	UpdateWindow,hWinParent
	retn

SetsDlgProc endp

HelpDlgProc proc hWin:HWND,iMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
	mov		eax,iMsg
	.if eax==WM_CLOSE
		invoke	EndDialog,hWin,NULL
	.else
		.if eax==WM_INITDIALOG
		;we process INITDIALOG here so that we can set control focus
		;and selection range ourselves without DefDlgProc interfering
			invoke	GetDlgItem,hWin,IDE_HELP
			invoke	SetFocus,eax
			invoke	SendMessage,hWin,WM_SETICON,ICON_SMALL,hIcon
			invoke	SetDlgItemText,hWin,IDE_HELP,offset szHelp
			invoke	SendDlgItemMessage,hWin,IDE_HELP,EM_SETSEL,NULL,NULL
		.endif
		movc	eax,NULL
@ret:
		ret
	.endif
	movc	eax,TRUE
	jmp		@ret

HelpDlgProc endp

FindSeqDlgProc proc hWin:HWND,iMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
	mov		eax,iMsg
	.if eax==WM_COMMAND
		mov		eax,wParam
		cmp		eax,makelong(IDB_ABORT,BN_CLICKED)
		je		@exit
		.if eax==makelong(IDB_PAUSE,BN_CLICKED)
			.if bStats&fPAUSED
				invoke	GetTickCount
				sub		eax,dwStillTime
				mov		dwStartTime,eax
				call	@StartTimers
				invoke	ResumeThread,hFindSeqThread
				mov		eax,offset szPause
				clrfl	bStats,fPAUSED
			.else
				invoke	GetTickCount
				sub		eax,dwStartTime
				mov		dwStillTime,eax
				call	@KillTimers
				invoke	SuspendThread,hFindSeqThread
				mov		eax,offset szRestart
				setfl	bStats,fPAUSED
			.endif
			invoke	SetDlgItemText,hWin,IDB_PAUSE,eax
		.endif
	.elseif eax==WM_TIMER
		mov		al,bStats
		mov		edx,wParam
		.if (al & fSEARCHING)&& !(al & fUPDATING)
		;fSEARCHING is set while the searching process is running
		;	while searching is running, update the dialog
		;fUPDATING is set while the dialog box is being updated
		;	this is to prevent several updatings at the same time
			.if edx==IDT_FINDSEQ
				setfl	bStats,fUPDATING
				invoke	UpdateFindSeqDlg,hWin
				clrfl	bStats,fUPDATING
			.elseif edx==IDT_PFINDSEQ
				invoke	SendDlgItemMessage,hWin,IDP_PGS,PBM_STEPIT,NULL,NULL
				invoke	SendDlgItemMessage,hWin,IDP_PGS,PBM_GETPOS,NULL,NULL
				.if eax>=100
					invoke	SendDlgItemMessage,hWin,IDP_PGS,PBM_SETPOS,0,NULL
				.endif
			.endif
		.endif
	.elseif eax==WM_CLOSE	;if dialog is just closed then don't save the comment
@exit:
		call	@KillTimers
		invoke	EndDialog,hWin,NULL
		movc	hFindSeqDlg,NULL
		clrfl	bStats,fSEARCHING
		;movc	dwStartTime,NULL
	.elseif eax==WM_INITDIALOG
		invoke	SendDlgItemMessage,hWin,IDP_PGS,PBM_SETRANGE,NULL,makelong(0,100)
		invoke	SendDlgItemMessage,hWin,IDP_PGS,PBM_SETPOS,0,NULL
		invoke	SendDlgItemMessage,hWin,IDP_PGS,PBM_SETSTEP,1,NULL
		invoke	SendMessage,hWin,WM_SETICON,ICON_SMALL,hIcon
		call	@StartTimers
		invoke	UpdateFindSeqDlg,hWin
	.else
		movc	eax,NULL
@ret:
		ret
	.endif
	movc	eax,TRUE
	jmp		@ret

@KillTimers:
	invoke	KillTimer,hWin,IDT_PFINDSEQ
	invoke	KillTimer,hWin,IDT_FINDSEQ
	retn

@StartTimers:
	invoke	SetTimer,hWin,IDT_FINDSEQ,Setts.dwUpdateFreq,NULL
	mov		hTimer,eax
	invoke	SetTimer,hWin,IDT_PFINDSEQ,250,NULL
	mov		hProgTimer,eax
	retn

FindSeqDlgProc endp

UpdateFindSeqDlg proc hWin:HWND
	LOCAL	dwEsp:DWORD
	LOCAL	dwCurrMoves:DWORD

	mov		eax,nCurrMoves
	mov		dwCurrMoves,eax
	.if eax && eax<1*1024*1024
		;display currently processed sequence
		mov		ecx,2048
		lea		eax,[eax+eax*2+4]
		mov		dwEsp,esp
			.while eax>ecx	;while eax>2048
				sub		esp,ecx
				sub		eax,ecx
				mov		edx,[esp]
			.endw
			sub		esp,eax
			and		esp,-16	;align memory to 16 bytes
			mov		eax,esp
			invoke	Seq2String,offset FindSequence.SeqBuffer,eax,dwCurrMoves
			invoke	SetDlgItemText,hWin,IDE_CURRSEQ,esp
		mov		esp,dwEsp
		mov		eax,dwStartTime
		.if eax
			invoke	GetTickCount
			sub		eax,dwStartTime
			.if SIGN?
				movc	edx,0FFFFFFFFh
				xchg	eax,edx
				add		eax,edx
			.endif
		.endif
	.else
		invoke	SetDlgItemText,hWin,IDE_CURRSEQ,offset szEmpty
		movc	eax,NULL
	.endif
	invoke	Msec2Time,eax,offset szString
	invoke	SetDlgItemText,hWin,IDE_TIME,offset szString
	invoke	SetDlgItemInt,hWin,IDE_LENGTH,dwCurrMoves,FALSE
	ret

UpdateFindSeqDlg endp

CommDlgProc proc hWin:HWND,iMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,iMsg
	.if eax==WM_COMMAND
		mov		eax,wParam
		cmp		eax,makelong(IDB_CANC,BN_CLICKED)
		je		@exit
		.if eax==makelong(IDB_OKC,BN_CLICKED)
			invoke	GetDlgItemText,hWin,IDE_COMM,offset szString,sizeof szString
			.if !eax
				invoke	GetLastError
				test	eax,eax	;if GetLastError then goto @exit
				jnz		@exit
			.endif
			invoke	EndDialog,hWin,TRUE
		.endif
	.elseif eax==WM_CLOSE	;if dialog is just closed then don't save the comment
@exit:
		invoke	EndDialog,hWin,NULL
	.elseif eax==WM_INITDIALOG
		mov		edx,lParam
		.if edx==offset szComment
			invoke	SetDlgItemText,hWin,IDE_COMM,(BUFF ptr [edx]).lpBuf
			mov		edx,offset szSeqCom
			test	eax,eax
			jz		@exit
		.else
			;.if edx==offset szCubeComm
			;make sure that lParam is either &szComment or &szCubeComm
			cmp		edx,offset szCubeComm
			jne		@exit
			invoke	SetDlgItemText,hWin,IDE_COMM,(BUFF ptr [edx]).lpBuf
			mov		edx,offset szCubeCom
			test	eax,eax
			jz		@exit
		.endif
		invoke	SetWindowText,hWin,edx
		invoke	SendDlgItemMessage,hWin,IDE_COMM,EM_SETLIMITTEXT,sizeof szString-sizeof DWORD,NULL
		invoke	SendDlgItemMessage,hWin,IDE_COMM,EM_SETSEL,0,0
		invoke	SendMessage,hWin,WM_SETICON,ICON_SMALL,hIcon
		mov		byte ptr [szString],0	;szString=""
	.else
		movc	eax,NULL
@ret:
		ret
	.endif
	movc	eax,TRUE
	jmp		@ret

CommDlgProc endp

;lpComm is ptr to BUFF struct with comment as a sz

;RET
;if comment was edited then return TRUE else return FALSE

EditComment proc uses ebx esi hWin:HWND,lpComm:LPVOID

	mov		ebx,lpComm
	assume ebx:ptr BUFF
	mov		esi,offset szString
	;first we must make sure that there is some buffer in lpComm BUFF struct
	;if it is empty then fill it with a buffer with empty string
	mov		eax,[ebx].lpBuf
	.if !eax
		mov		edx,offset szEmpty
		movc	ecx,sizeof szEmpty
		.if ebx==offset szComment
			invoke	SetSeqComm,edx,ecx
		.else
			cmp		ebx,offset szCubeComm
			jne		@ret
			invoke	SetCubeComm,edx,ecx
		.endif
		test	eax,eax
		jz		@ret
	.endif
	;now use comment dialog box to show and edit comment
	;first of all make sure that szString==""
	mov		byte ptr [esi],0	;szString=""
	invoke	DialogBoxParam,hInstance,IDD_COMM,hWin,offset CommDlgProc,ebx	;lpComm
	.if eax
		.if eax==-1
			inc		eax
		.else
			invoke	lstrlen,esi
			inc		eax
			.if ebx==offset szComment
				invoke	SetSeqComm,esi,eax
			.else
				invoke	SetCubeComm,esi,eax
			.endif
		.endif
	.endif
@ret:
	ret

	assume ebx:nothing
EditComment endp

FindSeqThread proc uses ebx esi edi lpVal:LPVOID
	LOCAL	dwESP:DWORD
	LOCAL	numMoves:DWORD
	LOCAL	dwElapsedTime:DWORD

	movc	eax,ERROR_SUCCESS
	mov		dl,Setts.bSets
	.if bStats & fSEARCHING
		;eax already == 0 because of "movc	eax,ERROR_SUCCESS"
		.if bStats & fCANFAST	;if SSE2 is supported
			test	dl,fNOFAST	;if SSE2 is not forbidden by the user
			setz	al			;then use SSE2 accelerated code
		.endif
		mov		ecx,Setts.dwMaxMoves
		invoke	FindSeq,offset DestCube,offset SrcCube,offset SeqBuffer,ecx,eax
		;make sure you remove fSEARCHING flag from bStats before exiting
		clrfl	bStats,fSEARCHING
		mov		numMoves,eax
		invoke	GetTickCount
		mov		edx,dwStartTime
		.if edx
			sub		eax,edx
		.else
			xchg	eax,edx
		.endif
		mov		dwElapsedTime,eax
		movc	dwStartTime,NULL
		invoke	EndDialog,hFindSeqDlg,NULL
		.if !numMoves
			mov		dwESP,esp
			sub		esp,(sizeof szTime * 2) and -16
			and		esp,-16
			mov		ebx,esp	;align stack address to 16 bytes
			invoke	Msec2Time,dwElapsedTime,esp
			invoke	wsprintf,offset szString,offset szNotFound,Setts.dwMaxMoves,ebx
			mov		esp,dwESP
			invoke	MessageBox,hWnd,offset szString,offset AppName,MB_OK or MB_ICONEXCLAMATION
;			invoke	SendMessage,hWnd,WM_COMMAND,IDM_CLEARSEQ,NULL
		.else
			mov		eax,numMoves
			mov		dwESP,esp
			.if eax>120
				mov		eax,120
			.endif
			mov		ecx,eax
			lea		eax,[eax+eax*2+4]
			sub		esp,eax
				and		esp,-16	;align stack address to 16 bytes
				mov		edi,esp
				invoke	Seq2String,offset SeqBuffer,edi,ecx
				sub		esp,(sizeof szTime * 2) and -16
				mov		ebx,esp
				invoke	Msec2Time,dwElapsedTime,esp
				sub		esp,1024
				mov		esi,esp
				invoke	wsprintf,esi,offset szFoundSeq,ebx,numMoves,edi
				invoke	MessageBox,hWnd,esi,offset AppName,MB_OKCANCEL or MB_ICONEXCLAMATION
			mov		esp,dwESP
			.if eax==IDOK
				invoke	SetSequence,offset SeqBuffer,sizeof SeqBuffer,numMoves
				invoke	GetDlgItem,hWnd,IDE_SEQ
				invoke	ShowSequence,eax,SeqBuf.lpBuf,cntMoves
			.endif
		.endif
		mov		eax,hFindSeqDlg
		.if eax
			invoke	EndDialog,eax,NULL
			movc	hFindSeqDlg,NULL
		.endif
		movc	nCurrMoves,NULL
	.endif
	ret

FindSeqThread endp

SetHeapBuffer proc uses ebx lpComm:LPVOID,cbComm:DWORD,lpBuffStr:LPVOID
	LOCAL	cbComm0:DWORD
	LOCAL	cchComm:DWORD

	invoke	lstrlen,lpComm
	mov		ecx,cbComm
	lea		edx,[eax+1]
	mov		ebx,lpBuffStr
	assume ebx:ptr BUFF
	movc	eax,NULL
	.if ecx
	;if cbSeq>=cntMovs
		.if ecx>edx
			mov		ecx,edx
		.endif
		mov		cchComm,ecx
		alignValue	ecx,4
		mov		cbComm0,ecx
		;get param of the current sequence buffer
		mov		edx,[ebx].lpBuf
		mov		eax,[ebx].cbBuf
		.if !edx
		;if the buffer does not exist then create it
		;and make sure that EAX and ECX contain proper data upon exiting the IF statement
			invoke	HeapAlloc,hProcHeap,HEAP_ZERO_MEMORY,cbComm0
			test	eax,eax	;if null returned then error
			jz		@ret
			mov		ecx,cbComm0
			mov		[ebx].lpBuf,eax
			mov		[ebx].cbBuf,ecx
		.else
			lea		edx,[ecx*2]
			.if edx<eax || eax<ecx
			;if (cbComm0*2)<cbszComment or cbszComment<cbComm0
			;if newly required buffer is less than half of available memory
				;then shrink the buffer
			;if newly required buffer is any bigger than the available memory
				;then enlarge the buffer
				invoke	HeapReAlloc,hProcHeap,HEAP_ZERO_MEMORY,[ebx].lpBuf,ecx
				test	eax,eax
				jz		@ret
				mov		ecx,cbComm0
				mov		[ebx].lpBuf,eax
				mov		[ebx].cbBuf,ecx
			.endif
		.endif
		;invoke	RtlMoveMemory,[ebx].lpBuf,lpComm,cchComm
		invoke	lstrcpyn,[ebx].lpBuf,lpComm,cchComm
		mov		eax,cbComm
	.endif
@ret:
	ret

	assume ebx:nothing
SetHeapBuffer endp

;sets comment for current sequence
;return NULL if error or non-NULL otherwise
SetCubeComm proc lpComm:LPVOID,cbComm:DWORD

	invoke	SetHeapBuffer,lpComm,cbComm,offset szCubeComm
	ret

SetCubeComm endp

;sets comment for current sequence
;return NULL if error or non-NULL otherwise
SetSeqComm proc lpComm:LPVOID,cbComm:DWORD

	invoke	SetHeapBuffer,lpComm,cbComm,offset szComment
	ret

SetSeqComm endp

;sets current sequence of the program to be the given sequence
;return NULL if error or non-NULL otherwise
SetSequence proc uses ebx esi edi lpSeq:LPVOID,cbSeq,cntMovs:DWORD
	LOCAL	cbSeq0:DWORD

	mov		edx,cbSeq
	mov		ecx,cntMovs
	mov		ebx,offset SeqBuf
	assume ebx:ptr BUFF
	movc	eax,NULL
	.if edx>=ecx && ecx<MAX_MOVES
	;if cbSeq>=cntMovs && cntMovs<MAX_MOVES
		inc		ecx
		mov		cbSeq0,ecx
		;get param of the current sequence buffer
		mov		edx,[ebx].lpBuf
		mov		eax,[ebx].cbBuf
		.if !edx
		;if the buffer does not exist then create it
		;and make sure that EAX and ECX contain proper data upon exiting the IF statement
			invoke	HeapAlloc,hProcHeap,HEAP_ZERO_MEMORY,cbSeq0
			test	eax,eax	;if null returned then error
			jz		@ret
			mov		ecx,cbSeq0
			mov		[ebx].lpBuf,eax
			mov		[ebx].cbBuf,ecx
		.else
			;lea		edx,[ecx*2]
			mov		edx,ecx
			add		edx,edx
			.if eax<ecx || edx<eax
			;if (cbSeq0*2)<cbSeqBuf or cbSeqBuf<cbSeq0
			;if newly required buffer is less than half of available memory
				;then shrink the buffer
			;if newly required buffer is any bigger than the available memory
				;then enlarge the buffer
				invoke	HeapReAlloc,hProcHeap,HEAP_ZERO_MEMORY,[ebx].lpBuf,ecx
				test	eax,eax
				jz		@ret
				mov		ecx,cbSeq0
				mov		[ebx].lpBuf,eax
				mov		[ebx].cbBuf,ecx
			.endif
		.endif
		invoke	RtlMoveMemory,[ebx].lpBuf,lpSeq,cntMovs
		;make sure there is a -1 in the end of the sequence
		mov		eax,cntMovs
		mov		edx,[ebx].lpBuf
		mov		byte ptr [edx+eax],-1
		mov		cntMoves,eax
	.endif
@ret:
	ret

	assume ebx:nothing
SetSequence endp

;RET
;return the new amount of moves in the sequence
;this number cannot be higher than cntMovs
align 8
OptimizeSeq proc uses ebx esi edi lpSeq:LPVOID,cntMovs:DWORD
	
	mov		eax,cntMovs
	mov		esi,lpSeq
	.if eax!=0
		mov		ebx,eax
		mov		edi,esi
		mov		ecx,eax
align 16
		.while TRUE
			.repeat
@nextmove:
				mov		al,[esi]
				.if ecx>1
					mov		dl,[esi+1]
					xor		dl,al
					jz		@0eq1
					cmp		dl,1
					je		@contra
				.endif
@savemov:
				mov		[edi],al
				inc		esi
				lea		edi,[edi+1]
				dec		ecx
			.until ZERO?
			jmp		@endloop
align 8
@contra:
					sub		ecx,2
					lea		esi,[esi+2]
					jnz		@nextmove
					jmp		@endloop
align 8
@0eq1:
					cmp		ecx,2
					jbe		@savemov
					cmp		al,[esi+2]
					jne		@savemov
					sub		ecx,2
					lea		esi,[esi+2]
					xor		al,01	;invert lowest bit in al
					jmp		@savemov
	
@endloop:
;at this point ECX must always be ZERO?
			mov		eax,edi
			mov		byte ptr [edi],-1
			sub		eax,lpSeq
			.break .if ZERO? || eax>=ebx
			sub		edi,eax
			mov		ebx,eax
			mov		esi,edi
			add		ecx,eax	;here ecx must always be 0
		.endw
	.endif
	ret

OptimizeSeq endp

ShowSequence proc uses edi hWin:HWND,lpSeq:LPVOID,cntMovs:DWORD
	LOCAL	dwESP:DWORD

	mov		eax,cntMovs
	mov		dwESP,esp
	;eax = eax * 3 + 4
	lea		eax,[eax+eax*2+4]
	sub		esp,eax
	and		esp,-16	;align stack address to 16 bytes
	mov		edi,esp
	invoke	Seq2String,lpSeq,edi,cntMovs
	invoke	SetWindowText,hWin,edi
	invoke	SetFocus,hWin
	mov		esp,dwESP
	ret

ShowSequence endp

Msec2Time proc dwTime:DWORD,lpStr:LPVOID
	LOCAL	dwMsecs:DWORD
	LOCAL	dwSecs:DWORD

	mov		eax,dwTime
	mov		ecx,1000
	movc	edx,0
	div		ecx
	mov		dwMsecs,edx
	mov		ecx,60
	movc	edx,0
	div		ecx
	mov		dwSecs,edx
	movc	edx,0
	div		ecx
	invoke	wsprintf,lpStr,offset szTime,eax,edx,dwSecs,dwMsecs
	ret

Msec2Time endp

LoadSettings proc uses esi
	LOCAL	hKey:DWORD
	LOCAL	cb:DWORD
	LOCAL	dwType:DWORD
	LOCAL	dwResult:DWORD

	movc	eax,NULL
	lea		esi,cb
	mov		dwResult,eax
	mov		dword ptr [esi],eax
	invoke	RegOpenKeyEx,HKEY_CURRENT_USER,offset szRegPath,NULL,KEY_ALL_ACCESS,addr hKey
	.if eax==ERROR_SUCCESS
		mov		dword ptr [esi],sizeof Setts
		invoke	RegQueryValueEx,hKey,offset szRegSets,NULL,addr dwType,offset Setts,esi
		.if eax==ERROR_SUCCESS && dwType==REG_BINARY && dword ptr [esi]==sizeof Setts
			inc		eax
			mov		dwResult,eax
		.endif
		.if Setts.bSets & fSIDECLR
			mov		dword ptr [esi],sizeof arrSideColors + sizeof UndefSideColor
			invoke	RegQueryValueEx,hKey,offset szRegClrs,NULL,addr dwType,offset arrSideColors,esi
		.endif
		invoke	RegCloseKey,hKey
	.endif
	return	dwResult

LoadSettings endp

SaveSettings proc uses esi
	LOCAL	hKey:DWORD
	LOCAL	cb:DWORD
	LOCAL	dwResult:DWORD

	movc	eax,NULL
	lea		esi,cb
	mov		dwResult,eax
	mov		dword ptr [esi],eax
	invoke	RegCreateKeyEx,HKEY_CURRENT_USER,offset szRegPath,NULL,offset szRegSz,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,addr hKey,esi
	.if eax==ERROR_SUCCESS
		.if Setts.bSets & fSIDECLR
			invoke	RegSetValueEx,hKey,offset szRegClrs,NULL,REG_BINARY,offset arrSideColors,sizeof arrSideColors + sizeof UndefSideColor
		.endif
		invoke	RegSetValueEx,hKey,offset szRegSets,NULL,REG_BINARY,offset Setts,sizeof Setts
		.if eax==ERROR_SUCCESS
			inc		eax
			mov		dwResult,eax
		.endif
		invoke	RegCloseKey,hKey
	.endif
	return	dwResult

SaveSettings endp

;returns offset to RCC_SQR structure that represents the region under the point
;return -1 if no region was found under the point
;the coordinates must be in pixels of the corresponding cube control
CubeletFromPoint proc uses ebx esi edi lpCube:LPVOID,xCoor,yCoor:DWORD

	mov		edi,lpCube
	mov		esi,dword ptr [PtInRegion+2]
	movc	ebx,0
	mov		esi,[esi]
	lea		edi,(RCC_CUBE ptr [edi]).RccSide
	.repeat
		push	yCoor
		push	xCoor
		push	(RCC_SQR ptr [edi+ebx]).hRgn
		call	esi
		;invoke	PtInRegion,(RCC_SQR ptr [edi+ebx]).hRgn,xCoor,yCoor
		test	eax,eax
		jnz		@found
		add		ebx,sizeof RCC_SQR
	.until ebx>=6*sizeof RCC_SIDE
	movc	ebx,-1
	jmp		@ret
@found:
	xchg	eax,ebx
@ret:
	ret

CubeletFromPoint endp

;PURPOSE
;checks CPU abilities

;RET
;-1 if not 586, so we can'n even continue
;FALSE if MMX,SSE,SSE2 are not supported
;TRUE if they are supported

;REMARKS
;

IsFast proc
	
	pushfd
	pop		eax
	or		eax,00200000h	;set bit 21
	push	eax
		popfd
		pushfd
	pop		edx
	.if eax!=edx
		invoke  MessageBox,NULL,offset Need586,offset AppName,MB_ICONSTOP or MB_TASKMODAL
		movc	eax,-1
	.else
		movc	eax,1
		cpuid
		not		edx
		movc	eax,0
		and		edx,fMMX or fSSE or fSSE2
		setz	al
		push	eax
			;now we will check if OS supports all up to SSE2
			try offset @safe,offset doSeh
				xor		eax,eax
				movdqa	xmm0,xmm0	;for SSE2
				inc		eax	;eax = TRUE
@safe:
			endtry
		pop		edx
		and		eax,edx	;we return TRUE only if both EAX and EDX == TRUE
		.if !ZERO?
			setfl	bStats,fCANFAST
		.endif
	.endif
	ret

doSeh::
	except FALSE

IsFast endp

;convert move bytes sequence to sz
Seq2String proc uses ebx esi edi lpSeq:LPVOID,lpString:LPVOID,cntMovs:DWORD

	mov		esi,lpSeq
	mov		edi,lpString
	mov		ecx,cntMovs
	movc	eax,0
	mov		ebx,offset cMoveChars
	mov		[edi],al
	.if ecx
		.while TRUE
			;if al==[esi+1] then append '"' and ","
			;elseif (al mod 2) then append "'" and ","
			;else append ","
			mov		al,[esi]
			.if al!=[esi+1]
				movc	ecx,0
				shr		eax,1
				adc		ecx,ecx
				shl		ecx,3
				mov		edx,",'"
				shl		edx,cl
				inc		esi
				mov		dl,[ebx+eax]
				shr		ecx,3
				mov		[edi],edx
				;move to skip the next char
				dec		cntMovs
				lea		edi,[edi+ecx+2]
				.continue.if !ZERO?
				.break
			.endif
			;if two same chars following each other
			;then append '",' and skip next char
			shr		eax,1
			mov		edx,',"' shl 8
			mov		dl,[ebx+eax]
			lea		esi,[esi+2]
			mov		[edi],edx
			sub		cntMovs,2
			lea		edi,[edi+3]
			jbe		@break
		.endw
@break:
		mov		byte ptr [edi-1],0	;store
	.endif
	ret

Seq2String endp

;convert sz to move bites sequence
;cntMaxMoves must be at least 1 byte less than the size of the lpSeq buffer
;so that it would hold -1 in the end to show the end of the sequence

;RET
;amount of moves in the output buffer
String2Seq proc uses ebx esi edi lpSeq:LPVOID,lpString:LPVOID,cntMaxMoves:DWORD
	
	movc	eax,NULL
	mov		ebx,lpSeq
	mov		esi,lpString
	mov		ecx,cntMaxMoves
	mov		edx,eax	;edx=0
	.if ecx
		cld
		movc	ecx,0
align 8
		.while TRUE
			mov		al,[esi]
			inc		esi
			.continue .if al==" " || al==","
			mov		cl,6
			mov		edi,offset cMoveChars
			repne	scasb
			.break .if !ZERO?	;break if char was not found
			mov		al,6-1
			sub		al,cl
			mov		dl,[esi]
			add		al,al
			.if dl!='"'
				.if dl=="'"
					or		al,1
					inc		esi
				.endif
				mov		[ebx],al
				;inc		esi
				inc		ebx
				dec		cntMaxMoves
				.continue .if !ZERO?	;make sure you do not go beyond cbSeq limit
				.break 
			.endif
			mov		ah,al
			inc		esi
			mov		[ebx],ax
			add		ebx,2
			movc	eax,0
			sub		cntMaxMoves,2
			jbe		@break
		.endw
@break:
		mov		byte ptr [ebx],-1
		xchg	eax,ebx
		sub		eax,lpSeq
	.endif
	ret

String2Seq endp

;this function attempts to rotate the given cubelet
;if ccDirection!=FALSE then rotate clockwise
;return true if rotated or false otherwise
RotateCubelet proc uses ebx esi edi lpCube:LPVOID,ofsCube,ccDirection:DWORD
	LOCAL	ofsCube2:DWORD
	LOCAL	ofsCube1:DWORD
	LOCAL	ofsCube0:DWORD

	mov		eax,ofsCube
	mov		esi,lpCube
	mov		edi,offset SqrInfo
	movc	edx,0
	mov		ecx,sizeof RCC_SQR
	lea		esi,[esi+offset RCC_CUBE.RccSide]	;lpCube+ofsCube
	assume esi:ptr RCC_SQR
	assume edi:ptr RCC_SQRINF
	div		ecx
	mov		ecx,sizeof RCC_SQRINF
	mul		ecx
	add		edi,eax
	mov		dl,[edi].bSqrType
	mov		cl,[edi].currSqr
	.if dl==SQT_CORNER		;[edi].bSqrType==SQT_CORNER
		.if cl==0		;[edi].currSqr==0
			mov		eax,ofsCube
			mov		edx,[edi].ofsSqr0
			mov		ecx,[edi].ofsSqr1
		.elseif cl==1	;[edi].currSqr==1
			mov		edx,ofsCube
			mov		eax,[edi].ofsSqr0
			mov		ecx,[edi].ofsSqr1
		.else
			mov		ecx,ofsCube
			mov		eax,[edi].ofsSqr0
			mov		edx,[edi].ofsSqr1
		.endif
		mov		ofsCube0,eax
		mov		ofsCube1,edx
		mov		ofsCube2,ecx
		;get colors of the squares
		mov		eax,[esi+eax].rgbSqr
		mov		edx,[esi+edx].rgbSqr
		mov		ecx,[esi+ecx].rgbSqr
		;rotate 3 colors
		push	@retcol
		cmp		ccDirection,FALSE
		jne		rolColors
		jmp		rorColors
;		.if ccDirection	;clockwise
;			push	ecx
;				mov		ecx,edx
;				mov		edx,eax
;			pop		eax
;		.else	;counter clockwise
;			push	eax
;				mov		eax,edx
;				mov		edx,ecx
;			pop		ecx
;		.endif
@retcol:
		mov		ebx,ofsCube0
		mov		[esi+ebx].rgbSqr,eax
		mov		ebx,ofsCube1
		mov		eax,ofsCube2
		mov		[esi+ebx].rgbSqr,edx
		mov		[esi+eax].rgbSqr,ecx
		movc	eax,TRUE
	.elseif dl==SQT_EDGE	;[edi].bSqrType==SQT_EDGE
		;prepare square offsets
		mov		ebx,ofsCube
		mov		ecx,[edi].ofsSqr0
		;get colors of the squares
		mov		edx,[esi+ebx].rgbSqr
		mov		eax,[esi+ecx].rgbSqr
		;exchange and store the colors
		mov		[esi+ebx].rgbSqr,eax
		mov		[esi+ecx].rgbSqr,edx
		movc	eax,TRUE
	.else
@retnul:
		movc	eax,FALSE
	.endif
	ret

	assume esi:nothing
	assume edi:nothing
RotateCubelet endp

align 8
rolColors proc
	
	push	ecx
		mov		ecx,edx
		mov		edx,eax
	pop		eax
	ret

rolColors endp

align 8
rorColors proc
	
	push	eax
		mov		eax,edx
		mov		edx,ecx
	pop		ecx
	ret

rorColors endp
align 8

;return TRUE if move successful or FALSE otherwise
MoveCubelet proc uses ebx esi edi lpCube:LPVOID,ofsSrcCube,ofsDestCube:DWORD
	LOCAL	ofsCube2:DWORD
	LOCAL	ofsCube1:DWORD
	LOCAL	ofsCube0:DWORD
	LOCAL	rotDir:DWORD	;0 if no rotation, 1 if CW, -1 if CCW
	LOCAL	dwResult:DWORD

	movc	edx,0
	mov		ebx,sizeof RCC_SQRINF
	mov		rotDir,edx	;rotDir=0
	mov		eax,ofsSrcCube
	mov		ecx,sizeof RCC_SQR
	mov		dwResult,edx	;0
	div		ecx
	mul		ebx
	;mov		ofsSqrInfSrc,eax
	push	eax
		movc	edx,0
		mov		eax,ofsDestCube
		div		ecx
		mul		ebx
		mov		edx,offset SqrInfo
	pop		esi
;	mov		ofsSqrInfDest,eax
	lea		edi,[eax+edx]
	;add		esi,ofsSqrInfSrc
	add		esi,edx
	assume edi:ptr RCC_SQRINF
	assume esi:ptr RCC_SQRINF
	mov		ebx,lpCube
	mov		al,[esi].bSqrType
	add		ebx,offset RCC_CUBE.RccSide
	assume	ebx:ptr RCC_SQR
	;can only move a cubelet if dest and src cubelet types are same
	.if al==byte ptr [edi].bSqrType
		.if al==SQT_CORNER
			;get rotation direction
			mov		al,[edi].currSqr
			sub		al,[esi].currSqr
			.if !ZERO?	;if .currSqr are equal then no need for colors rotation
				.if SIGN?	;if sign flag or 2 then
@CCW:
					cmp		al,-2
					je		@CW
					dec		rotDir	;rotDir=-1
				.else
@CW:
					cmp		al,2
					je		@CCW
					inc		rotDir	;rotDir=1
				.endif
			.endif
			;get offsets of dest cubelet
			xchg	esi,edi
			mov		edx,ofsDestCube
			call	@GetOffsets
			xchg	esi,edi
			;save them in proper order for future use
			mov		ofsCube0,eax
			mov		ofsCube1,edx
			mov		ofsCube2,ecx
			;get colors of the squares and save them in stack
			push	[ebx+ecx].rgbSqr
			push	[ebx+edx].rgbSqr
			push	[ebx+eax].rgbSqr
				;get offsets of src cubelets
				mov		edx,ofsSrcCube
				call	@GetOffsets
				push	[ebx+ecx].rgbSqr
				push	[ebx+edx].rgbSqr
				push	[ebx+eax].rgbSqr
			;get colors of src cubelet
					xchg	eax,ofsCube0
					xchg	edx,ofsCube1
					xchg	ecx,ofsCube2
			;put them to proper order for saving in dest cubelet
					call	@RotColors
			;save dest colors to src cubelet
				pop		[ebx+eax].rgbSqr
				pop		[ebx+edx].rgbSqr
				pop		[ebx+ecx].rgbSqr
				mov		eax,ofsCube0
				mov		edx,ofsCube1
				mov		ecx,ofsCube2
				neg		rotDir	;change sign thus changing rotation direction
				call	@RotColors
			;save src colors to dest cubelet
			pop		[ebx+eax].rgbSqr
			pop		[ebx+edx].rgbSqr
			pop		[ebx+ecx].rgbSqr
			inc		dwResult
		.elseif al==SQT_EDGE
			;get offsets for dest cublet
			mov		ecx,ofsDestCube
			mov		edi,[edi].ofsSqr0
			;get offsets to src squares
			mov		eax,ofsSrcCube
			mov		edx,[esi].ofsSqr0
			;store colors of dest cubelet in the stack
			push	dword ptr (RCC_SQR ptr [ebx+edi]).rgbSqr
			push	dword ptr (RCC_SQR ptr [ebx+ecx]).rgbSqr
				;store src offsets
				push	edx
				push	eax
					;get colors of src squares
					mov		eax,(RCC_SQR ptr [ebx+eax]).rgbSqr
					mov		edx,(RCC_SQR ptr [ebx+edx]).rgbSqr
					;get offsets to dest squares
					mov		dword ptr (RCC_SQR ptr [ebx+ecx]).rgbSqr,eax
					mov		dword ptr (RCC_SQR ptr [ebx+edi]).rgbSqr,edx
				pop		eax
				pop		edx
			pop		dword ptr (RCC_SQR ptr [ebx+eax]).rgbSqr
			pop		dword ptr (RCC_SQR ptr [ebx+edx]).rgbSqr
			inc		dwResult
		.endif
	.endif
	return dwResult

;esi - ptr to RCC_SQRINF
;EDX - offset of current cube
;returns offsets in EAX,EDX,ECX
@GetOffsets:
	mov		al,[esi].currSqr	;currSqr in Src square
	.if al==0
		xchg	eax,edx	;ofsSrcCube
		mov		edx,[esi].ofsSqr0
		mov		ecx,[esi].ofsSqr1
	.elseif al==1
		;mov		edx,ofsSrcCube
		mov		eax,[esi].ofsSqr0
		mov		ecx,[esi].ofsSqr1
	.else
		mov		ecx,edx	;ofsSrcCube
		mov		eax,[esi].ofsSqr0
		mov		edx,[esi].ofsSqr1
	.endif
	retn

@RotColors:
	cmp		rotDir,-1
	je		rolColors
	cmp		rotDir,1
	je		rorColors
	retn
;	.if rotDir==-1
;		call	rolColors
;	.elseif rotDir==1
;		call	
;	.endif
;	retn

	assume esi:nothing
	assume edi:nothing
MoveCubelet endp

;return FALSE if error or TRUE if side was rotated successfully
RotateSide proc uses ebx esi edi lpCube:LPVOID,ofsSrc,ofsDest:DWORD
	LOCAL	CubeState:CUBE	;we will keep the cube state here while rotating it
	LOCAL	rotDir:DWORD	;rotation direction is here: 0 for CW and 1 for CCW
	LOCAL	bOneMove:DWORD	;bool: FALSE if double move and non-NULL if one move
	LOCAL	nMove:DWORD		;final move number
	LOCAL	numSrc:DWORD	;local number of src square within one side
	LOCAL	lofsDest:DWORD	;local offset within one side
	LOCAL	lofsSrc:DWORD	;local offset within one side
	LOCAL	dwSide:DWORD	;number of the side to be rotated
	LOCAL	dwResult:DWORD

	movc	edx,0
	mov		eax,ofsSrc
	mov		dwResult,edx	;dwResult=NULL
	mov		ecx,sizeof RCC_SIDE
	mov		rotDir,edx		;rotDir=NULL
	div		ecx
	mov		lofsSrc,edx
	mov		dwSide,eax
	movc	edx,0
	mov		eax,ofsDest
	div		ecx
	mov		lofsDest,edx
	mov		ecx,ofsSrc
	;in EDX get offset of MidSqr within one side
	mov		edx,offset RCC_SIDE.MidSqr
	;the squares must be on the same side
	;they must be different squares though
	;the source and dest squares must not be .MidSqr
	.if eax==dwSide && ecx!=ofsDest && edx!=lofsSrc && edx!=lofsDest
		lea		esi,CubeState
		invoke	GetCubeState,lpCube,esi;addr CubeState
		mov		ecx,sizeof RCC_SQR
		mov		eax,lofsSrc
		movc	edx,0
		div		ecx
		mov		numSrc,eax
		movc	edx,0
		mov		eax,lofsDest
		div		ecx
		sub		eax,numSrc
		mov		ebx,offset Side2Move
		and		eax,07h
		mov		ecx,offset @rotate
		push	offset @ret
		sub		eax,4
		mov		bOneMove,eax
		js		@rotate
		.if !ZERO?
			inc		rotDir
			jmp		ecx	;@rotate
		.endif
		;if it is not a square to the left or to the right
		;then it is the opposite square
		;so rotate the side for 180 degrees which is twice normal rotation
		push	ecx
		jmp		ecx
@ret:
		invoke	SetCubeState,lpCube,esi	;addr CubeState
		;this code records current move
		.if bStats&fRECORDING
			invoke	GetWindowLong,hDestWnd,GWL_LPCUBE
			.if eax==lpCube
				invoke	GetDlgItemText,hWnd,IDE_SEQ,offset szString,sizeof szString-3-1
				.if eax
@recseq:
					setfl	bStats,fRECMOVE
					push	eax
						mov		ecx,offset cSideChars
						mov		eax,dwSide
						mov		al,[eax+ecx]
						.if rotDir!=FALSE
							mov		ah,"'"
						.endif
						.if bOneMove==FALSE
							mov		ah,'"'
						.endif
					pop		ecx
					.if ecx
						shl		eax,8
						add		eax,","
					.endif
					mov		dword ptr [ecx+offset szString],eax
					invoke	String2Seq,offset SeqBuffer,offset szString,sizeof SeqBuffer-1
					invoke	SetSequence,offset SeqBuffer,sizeof SeqBuffer,eax
					invoke	GetDlgItem,hWnd,IDE_SEQ
					invoke	ShowSequence,eax,SeqBuf.lpBuf,cntMoves
					clrfl	bStats,fRECMOVE
				.else
					push	eax
						invoke	GetLastError
						test	eax,eax
					pop		eax
					jz		@recseq
					call	StopRec
				.endif
			.endif
		.endif
		inc		dwResult
	.endif
	return	dwResult

@rotate:
	;Side2Move
	;offset FuncAddr
	mov		eax,dwSide
	mov		edx,offset FuncAddr
	xlat	;al=[Side2Move+al]
	add		eax,rotDir	;set direction CW or CCW
	mov		nMove,eax
	jmp		dword ptr [edx+eax*sizeof LPVOID]
	;call	dword ptr [edx+eax*sizeof LPVOID]
	;retn


;some old stuff
;		
;		mov		cl,3	;meaning that we will check 3 squares
;		mov		eax,numSrc
;		mov		edx,numDest
;		mov		ebx,offset Side2Move
;		push	@ret
;		.repeat
;			inc		eax
;			and		eax,07h	;make sure we stay within [0..7]
;			;.if eax==edx	;numDest
;			cmp		eax,edx
;			je		@rotate
;			dec		cl
;		.until ZERO?
;		mov		cl,3	;check 3 squares counter clockwise
;		inc		rotDir	;change direction to counter clockwise
;		mov		eax,numSrc
;		.repeat
;			dec		eax
;			and		eax,07h
;			cmp		eax,edx
;			je		@rotate
;			dec		cl
;		.until ZERO?
;		;if it is not a square to the left or to the right
;		;then it is the opposite square
;		;so rotate the side for 180 degrees which is twice normal rotation
;		mov		eax,offset @rotate
;		push	eax
;		jmp		eax

RotateSide endp

;--------------------------------------------------------------------------------

include fileops.asm

;--------------------------------------------------------------------------------

include cubectrl.asm

;--------------------------------------------------------------------------------

;Performs specified moves on the given cube.

;lpSeq - ptr to buffer with moves
;cntMovs - amount of moves to perform from the given moves buffer
;lpCube - ptr to CUBE structure that holds source cube and will receive the modified cube
;boolFast - bool: if TRUE then use SSE2 acceleration

;return TRUE if moves were applied
;or FALSE if there was an error:
;invalid move bytes found in the sequence buffer

ExeSeq proc uses ebx esi edi lpSeq:LPVOID,cntMovs:DWORD,lpCube:LPVOID,boolFast:DWORD

	mov		edx,MAX_MOVES
	mov		ebx,offset FindSequence
	.if edx<cntMovs
	;make sure that nMaxMoves is not bigger than length of moves array
		mov		cntMovs,edx
	.endif
	lea		esi,(FINDSEQ ptr [ebx]).CurrCube
	assume esi:ptr CUBE
	lea		edi,(FINDSEQ ptr [ebx]).SeqBuffer
	;prepare the buffer
	invoke	RtlMoveMemory,esi,lpCube,sizeof CUBE;addr [ebx].SrcCube,lpSrcCube,sizeof CUBE
	;now copy sequence into the internal buffer
	;make sure all bytes are less than or equal to CM_BACKX (11)
	push	esi
	;invoke	RtlMoveMemory,edi,lpSeq,cntMovs
		mov		ecx,cntMovs
		movc	edx,0
		mov		esi,lpSeq
		.if ecx
			.while edx<ecx
				mov		al,[esi+edx]
				.break .if al>CM_BACKX
				mov		[edi+edx],al
				inc		edx
			.endw
		.endif
		movc	byte ptr [edi+edx],-1
	pop		esi
;	nop
;	nop
;	invoke	RtlMoveMemory,esi,offset dbSide,sizeof CUBE
;	nop
;	nop
	.if edx >= ecx	;if the seequence was intact do the move else return NULL
		;if SSE2 supported then prepare constants in XMM6, XMM7
		.if boolFast
			xmm_setconst
			call	CubeMoveXmm
			;save data to memory
			mov		esi,lpCube
			movdqa	[esi].CubeSide0,xmm0
			movdqa	[esi].CubeSide2,xmm1
			movdqa	[esi].CubeSide4,xmm2
		.else
			call	CubeMove
			invoke	RtlMoveMemory,lpCube,esi,sizeof CUBE
		.endif
		movc	eax,TRUE
	.else
		movc	eax,FALSE
	.endif
	ret

	assume esi:nothing
ExeSeq endp

;--------------------------------------------------------------------------------------

;this is to be a big function
;it will search for a sequence of moves that will change lpSrcCube into lpDestCube
;use the given buffer (lpBufs) as a structure for search

;RET
;NULL if not found or destination cube is equal to source cube
;return amount of moves to reach dest cube, the required sequence or moves
;will be stored in FINDSEQ.SeqBufferOpt array

;REMARKS
;found sequence will be returned in FINDSEQ.SeqBufferOpt array
;length of the array will be returned with the function

;	mov		nResult,100000000
;	.repeat
;		call	LeftXmm
;		dec		nResult
;	.until ZERO?
;	jmp		@exit
	;LeftXmm	828ms
	;LeftXmmX	828ms
	;RightXmm	1.000-1.031ms
	;RightXmmX	953ms
	;TopXmm		1.047ms
	;TopXmmX	1.047ms
	;BottomXmm	1.047ms
	;BottomXmmX	1.047ms
	;FrontXmm	1.344ms
	;FrontXmmX	1.344ms
	;BackXmm	1.328-1.344ms
	;BackXmmX	1.344ms


align 16
FindSeq proc uses ebx esi edi lpDestCube:LPVOID,lpSrcCube:LPVOID,lpSeq:LPVOID,nMaxMoves:DWORD,boolFast:DWORD
	LOCAL	lpCubeMove:LPVOID
	LOCAL	nResult:DWORD

	movc	nResult,FALSE
	invoke	GetTickCount
	mov		dwStartTime,eax
	mov		edx,MAX_MOVES	;this is the max amount of moves that can be contained in the buffer
	mov		eax,nMaxMoves
	cld
	.if eax	;if nMaxMoves>0 then start search
		.if edx<eax		;edx<nMaxMoves
		;make sure that nMaxMoves is not bigger than the length of moves array
			mov		nMaxMoves,edx
		.endif
		mov		ebx,offset FindSequence
		;FindSequence is a special structure (FINDSEQ) that contains
		;source cube state, dest. cube state, processed sequence
		assume ebx:ptr FINDSEQ
		;prepare the buffer
		;copy source cube from lpSrcCube to FindSequence.SrcCube
		mov		esi,lpSrcCube
		mov		ecx,sizeof CUBE / sizeof DWORD
		lea		edi,[ebx].SrcCube
		push	ecx
			rep		movsd
		pop		ecx			;invoke	RtlMoveMemory,addr [ebx].SrcCube,lpSrcCube,sizeof CUBE
		;copy dest cube from lpDestCube to FindSequence.DestCube
		mov		esi,lpDestCube
		lea		edi,[ebx].DestCube
		rep		movsd		;invoke	RtlMoveMemory,addr [ebx].DestCube,lpDestCube,sizeof CUBE
		;if SSE2 is supported then prepare constants in XMM6, XMM7 registers
		;below we also store ptr to the respective CmpCube function
		;@CmpCube takes the source cube, performs specified moves on it and compares it to the dest cube.
		;@CmpCubeXmm performs specified moves on the source cube and compares it ot the dest cube.
		;In latter one all these things are done using XMM registers and SSE,SSE2 insturctions.
		.if boolFast
			xmm_setconst	;macro that prepares constants in XMM registers
			mov		esi,offset @CmpCubeXmm
		.else
			mov		esi,offset @CmpCube
		.endif
		mov		edi,offset OneMoves	;array of one-move sequences
		mov		lpCubeMove,esi		;store ptr to the proper functions into lpCubeMove
		;first of all we will go through all of the 1-move sequences.
		;we will use OneMoves array to go through the sequences.
		;however this loop is not very critical.
		.repeat
			mov		ecx,1
			;EDI is always ready and it is pointing to the array of sequences
			;EBX - ptr to FINDSEQ struct aligned by 16 bytes boundary
			;ECX - count of moves to perform
			call	esi		;invoke	CubeMove,ebx,edi,1
			;upon return from @CmpCube the CARRY flag is set if the sequence is found
			jc		@found1	;.break .if CARRY?	;one-move sequence was found
			add		edi,1	;inc ptr to point at the next sequence
			mov		esi,lpCubeMove	;ESI = ptr to @CmpCube or @CmpCubeXmm
		.until edi>=offset OneMoves+sizeof OneMoves	;until end of sequence array found
		;.if !CARRY?;!eax
			cmp		nMaxMoves,2	;max sequence is 1 then exit
			jb		@exit
			;now we need to go through all 2-move sequences
			;we will use TwoMoves array for this purpose
			mov		edi,offset TwoMoves
			;this loop is not very critical either
			.repeat
				mov		ecx,2
				call	esi	;invoke	CubeMove,ebx,edi,2
				jc		@found2;.break.if CARRY?	;eax
				add		edi,2
				mov		esi,lpCubeMove
			.until edi>=offset TwoMoves + CNT_TWO_MOVES * 2
			;.if !CARRY?;!eax
				cmp		nMaxMoves,3	;if max limit is 2 then exit (1 was checked before)
				jb		@exit
				;fill FindSequence.SeqBuffer with -1
				;this code also ensures that entire .SeqBuffer is in cache
				lea		edi,[ebx].SeqBuffer
				movc	eax,-1
				mov		ecx,(sizeof FINDSEQ.SeqBuffer + sizeof FINDSEQ.dwPad) / sizeof DWORD
				push	edi	;preserve ptr to .SeqBuffer for later use
					rep		stosd
				pop		edi
				;invoke	RtlFillMemory,edi,sizeof FINDSEQ.SeqBuffer + sizeof FINDSEQ.dwPad,-1
				mov		nCurrMoves,3	;we will start with 3-move sequences
				;Now we need to begin search starting with 3-move sequences. The first possible sequence is
				;CM_LEFT,CM_LEFT,CM_LEFT; but it can be optimized into CM_LEFTX which is a 1-move
				;sequence and we have prevoiusly tried all 1-move sequences. Next is
				;CM_LEFTX,CM_LEFT,CM_LEFT; but CM_LEFTX and CM_LEFT are opposite moves so they will
				;be eliminated by optimizer and we will have 1 CM_LEFT move left. We have tried all
				;1-move sequences. Next is
				;CM_RIGHT,CM_LEFT,CM_LEFT. This one will not be changed by optimizer. So we can use
				;it as a starting sequence.
				;However NextSeq() makes one step ahead, so if we want to start
				;with CM_RIGHT,CM_LEFT,CM_LEFT then we need to put CM_LEFTX,CM_LEFT,CM_LEFT into
				;sequence buffer, NextSeq() will step it to CM_RIGHT,CM_LEFT,CM_LEFT and we will
				;actually start with this initial sequence.
				mov		dword ptr [edi],CM_LEFTX + (CM_LEFT shl 8) + (CM_LEFT shl 16) + (-1 shl 24)
				;In the following loop we need to do this:
				;1. Advance move sequence in .SeqBuffer to next sequence. This used to
				;	be NextSeq() function.
				;2. Check if any portion of current sequence can be eliminated or changed to make a smaller sequence.
				;	If current sequence can be shrinked even by one move then it becomes one of the sequences that
				;	we have tried already, so we do not need to try it again, we skip it and go to advance
				;	to the next sequence. Then do checking again until an unshrinkable sequence is found.
				;	When final unshrinkable sequence is obtained, then execute the sequence and check
				;	if it can do the desired transition. So compare the result with the dest cube state
				;must enter the loop with EAX==0,ECX==nCurrMoves,EDX==nMaxMoves
				mov		ecx,nCurrMoves
				mov		esi,lpCubeMove
				movc	eax,0
align 16
				.repeat
				;here EAX must always be 0
					inc		eax		;eax=1	;mov		eax,1
					movc	edx,0	;movc	esi,0	;esi=0
@nextseq:
					add		eax,[edi+edx]	;next move = 1 + prev move
					mov		edx,edx	;filler to avoid stall
					cmp		al,CM_BACKX	;.if al<=CM_BACKX
					;if curr move is bigger than max possibel move (CM_BACKX) then advance to next move within seq
					ja		@nextmove
					mov		[edi+edx],eax	;save successfully incremented move to update the sequence
					;now check if this sequence can be shrinked
					;here we check for two cases:
					;1. opposite moves next to each other
					;2. at least 3 same moves in a row
align 16
					.repeat
						mov		eax,[edi+edx]	;get four closest chars from sequence
						lea		edx,[edx]		;filler for code alignment and stall prevention
						xor		al,ah		;xor move0 and move1
						jz		@0eq1	;if ZERO then 1st two chars are equal
										;so go to check the third char to be equal
						cmp		al,1	;if ONE then these were opposite moves
						je		@contra	;go to skip this sequence and advance to the next possible sequence
@retloop:
						dec		edx
					.until SIGN?
					;this test allows us to stop the search by changing the flag in glogal valiable
					test	bStats,fSEARCHING
					jz		@out	;jump to jmp @exit ;if go straight to @exit then we get a long version of jump (6 bytes)
					;we need to restore nCurrMoves here since it is changed in CubeMove but not in CubeMoveXmm
					call	esi;lpCubeMove	;call	CubeMove,ebx,edi,ecx
				.until CARRY?;eax
				;go to @found if current sequence can do the desired transition
				jmp		@found
align 8
;now we know that move0 == move1; so here we check if move1 == move2
@0eq1:	;.if ah==byte ptr [edi+esi+2];if 3 same moves in a row
						shr		eax,8	;shift EAX right to put move1 and move2 into AL and AH
						cmp		al,ah	;cmp		ah,byte ptr [edi+esi+2]
						jne		@retloop;if move1 not equal to move2 then return to inner loop
						;else EAX=1 and go to find next sequance
align 8
;now move0 was opposite of move1; so put 1 in EAX and go to check the next loop
@contra:
						mov		eax,1	;if opposite moves were found then go to check the next sequence
						jmp		@nextseq
align 8
@nextmove:
					;we get here if there was an "overflow" with moves increment
					;so put CM_LEFT (null) into current move and go to inc the next move
					movc	byte ptr [edx+edi],CM_LEFT
					inc		edx
					mov		eax,1
					;if incrementing we have not reached the highest num yet
					;then just continue without incrementing current length of moves in sequence buffer
					;.continue .if esi<ecx
					cmp		edx,ecx		;cmp	esi,nCurrMoves
					jb		@nextseq
					;---------below this line we have randomly executed code 
					;we get here only when extending current sequence search length
					;at this point EAX must be 1 always
					add		ecx,eax	;ecx+1
					inc		nCurrMoves
					cmp		ecx,nMaxMoves	;if curr pos in moves buffer reaches buffer end then exit
					jbe		@nextseq
@out:	;we use this extra jump to make the loop smaller (reduce jump size after test bStats,fSEARCHING)
					jmp		@exit
;				;if it has never been found then leave 0 in nResult and exit
@found:
				mov		ecx,nCurrMoves
				push	ecx
					mov		esi,lpSeq
					invoke	RtlMoveMemory,esi,edi,ecx
				pop		ecx
				movc	byte ptr [esi+ecx],-1
				jmp		@result
			;.endif
@found2:
			movc	eax,-1
			mov		edx,lpSeq
			mov		ax,word ptr [edi]
			movc	ecx,0
			mov		dword ptr [edx],eax
			mov		cl,2
			jmp		@result
		;.else
@found1:
			movc	eax,-1
			mov		edx,lpSeq
			mov		al,byte ptr [edi]
			movc	ecx,1
			mov		dword ptr [edx],eax
		;.endif
@result:
		mov		nResult,ecx
@exit:
	.endif
	return nResult

;EBX - ptr FINDSEQ struct
;ESI - ptr to this function
;EDI - ptr to sequence buffer
;ECX - amount of moves to execute from the buffer
align 16
@CmpCubeXmm:
	movdqa	xmm0,[ebx].SrcCube.CubeSide0
	movdqa	xmm1,[ebx].SrcCube.CubeSide2
	movdqa	xmm2,[ebx].SrcCube.CubeSide4
	movc	eax,0
	sub		edx,edx	;use EDX as offset into lpMoves in EDI
align 16
	.repeat
		mov		al,[edi+edx]
		xchg	ecx,ecx	;filler to avoid stall and to align code
		mov		eax,[eax*sizeof DWORD + offset XmmFuncAddr]
		add		edx,1;inc		edx
		call	eax
		movc	eax,0
	.until edx>=ecx
	;we don't use call to CubeMoveXmm to speed up execution
	;instead we inserted that same code in here
	;now compare cubes with SSE2 too
		;the following system (with pxor instead of pcmpeqb) runs faster
	pxor	xmm0,[ebx].DestCube.CubeSide0
	pxor	xmm1,[ebx].DestCube.CubeSide2
	pxor	xmm2,[ebx].DestCube.CubeSide4
	por		xmm0,xmm1
	por		xmm0,xmm2
	packsswb	xmm0,xmm0
	packsswb	xmm0,xmm0
	movd		edx,xmm0
	movc	eax,0
	sub		edx,1
	retn
	
;	pcmpeqb	xmm0,[ebx].DestCube.CubeSide0
;	pcmpeqb	xmm1,[ebx].DestCube.CubeSide2
;	pcmpeqb	xmm2,[ebx].DestCube.CubeSide4
;	pand	xmm0,xmm1
;	pand	xmm0,xmm2
;	;if ax==-1 then cubes match so return TRUE
;	;else cubes don't match so return FALSE
;	pmovmskb	edx,xmm0
;	;movc	eax,0
;	add		dx,1
;	;adc		eax,eax
;	retn

;EBX - ptr FINDSEQ struct
;ESI - ptr to this function
;EDI - ptr to sequence buffer
;ECX - amount of moves to execute from the buffer
;ECX must be preserved!
align 16
@CmpCube:
	push	ecx
	push	esi
	push	edi
		mov		edx,ecx
			xchg	eax,edi
				lea		esi,[ebx].SrcCube
				lea		edi,[ebx].CurrCube
				mov		ecx,sizeof CUBE / sizeof DWORD
				push	edi
					rep		movsd
				pop		esi
			xchg	eax,edi
		mov		ecx,edx
		call	CubeMove
		lea		edi,[ebx].DestCube
		;now ESI is still pointing to CurrCube where we have the result of moves
		;and EDI is pointing to DestCube with which we will compare resulting cube in CurrCube
		mov		ecx,sizeof CUBE / sizeof DWORD
		movc	eax,0
		repe	cmpsd
		setne	al
	pop		edi
	pop		esi
	pop		ecx
	sub		eax,1
	mov		eax,0	;make sure we output NULL in EAX
	retn

;	;mov		esi,offset dbSide;lpCube	;offset dbSide;
;	;mov		edi,lpMoves
;	;mov		ecx,cbMoves
;	assume ebx:ptr FINDSEQ
;	lea		edx,[ebx].DestCube
;	;from now on EDX may not be changed
;		mov		esi,ebx	;lea		esi,[ebx].SrcCube
;		assume esi:ptr CUBE
;		;ESI is always lpCube
;		;EDI is lpMoves
;		movdqa	xmm0,[esi].CubeSide0
;		movc	eax,0
;		xmm_mov	xmm1,[esi].CubeSide2
;		lea		ebx,[edi+ecx]	;calc lpEnd for the latter loop
;		xmm_mov	xmm2,[esi].CubeSide4
;		;assume is done for the functions themselves
;align 16
;		.repeat
;			mov		al,[edi]
;			mov		eax,[eax*sizeof DWORD + offset XmmFuncAddr]
;			add		edi,1
;			call	eax
;			movc	eax,0
;		.until edi>=ebx
;		;save data to memory
;;		movdqa	[esi].CubeSide0,xmm0
;;		movdqa	[esi].CubeSide2,xmm1
;;		movdqa	[esi].CubeSide4,xmm2
;	mov		edi,edx
;	assume edi:ptr CUBE
;	;compare cubes with SSE2 too
;	pcmpeqb	xmm0,[edi].CubeSide0
;	pcmpeqb	xmm1,[edi].CubeSide2
;	pcmpeqb	xmm2,[edi].CubeSide4
;	pand	xmm0,xmm1
;	movc	eax,FALSE
;	pand	xmm0,xmm2
;	;if ax==-1 then cubes match so return TRUE
;	;else cubes don't match so return FALSE
;	pmovmskb	edx,xmm0
;	add		dx,1
;	adc		eax,eax
;	ret


;optimization loop
;							.repeat
;								mov		al,[edi+esi]
;								mov		ah,[edi+esi+1]	;next char
;								xor		al,ah
;								.if !ZERO?
;									;.if al==1
;									cmp		al,1
;									jne		@nxch
;									mov		ah,0
;									jmp		@nextseq
;								.endif
;								.if ah==byte ptr [edi+esi+2];if 3 same moves
;									mov		eax,1
;									jmp		@nextseq
;								.endif
;@nxch:
;								sub		esi,1
;							.until SIGN?
;							.break

assume ebx:nothing

FindSeq endp

;--------------------------------------------------------------------------------

include xmmcode.asm

;--------------------------------------------------------------------------------

include bytecode.asm

;--------------------------------------------------------------------------------

end start

;align 16
;FindSeq proc uses ebx esi edi lpDestCube:LPVOID,lpSrcCube:LPVOID,lpSeq:LPVOID,nMaxMoves:DWORD,boolFast:DWORD
;	LOCAL	lpCubeMove:LPVOID
;	LOCAL	nResult:DWORD
;
;	movc	nResult,FALSE
;	invoke	GetTickCount
;	mov		dwStartTime,eax
;	cld
;	.if nMaxMoves	;if nMaxMoves>0 then start search
;		mov		edx,MAX_MOVES
;		.if edx<nMaxMoves
;		;make sure that nMaxMoves is not bigger than length of moves array
;
;			mov		nMaxMoves,edx
;		.endif
;		mov		ebx,offset FindSequence
;		assume ebx:ptr FINDSEQ
;		;prepare the buffer
;		;copy source cube
;		mov		esi,lpSrcCube
;		mov		ecx,sizeof CUBE / sizeof DWORD
;		lea		edi,[ebx].SrcCube
;		push	ecx
;			rep		movsd
;		pop		ecx			;invoke	RtlMoveMemory,addr [ebx].SrcCube,lpSrcCube,sizeof CUBE
;		;copy dest cube
;		mov		esi,lpDestCube
;		lea		edi,[ebx].DestCube
;		rep		movsd		;invoke	RtlMoveMemory,addr [ebx].DestCube,lpDestCube,sizeof CUBE
;		;if SSE2 supported then prepare constants in XMM6, XMM7
;		.if boolFast
;			xmm_setconst
;			mov		esi,offset @CallCmpCubeXmm
;		.else
;			mov		esi,offset @CallCmpCube
;		.endif
;		mov		edi,offset OneMoves
;		mov		lpCubeMove,esi
;		;first of all we will go through all the 1-move sequences.
;		;we will use array at lpFuncArr to go through 1-move
;;align 4
;		.repeat
;			mov		ecx,1
;			;EDI is always ready
;			;EBX - ptr to FINDSEQ struct in stack aligned to 32 bytes
;			;ECX - count of moves to try
;			call	esi		;invoke	CubeMove,ebx,edi,1
;			.break .if eax
;			add		edi,1
;			mov		esi,lpCubeMove
;		.until edi>=offset OneMoves+sizeof OneMoves
;		.if !eax
;			cmp		nMaxMoves,2
;			jb		@exit
;			;now we need to go through all 2-move sequences
;			;we will use TwoMoves array for this purpose
;			mov		edi,offset TwoMoves
;			;mov		lpEnd,offset TwoMoves + CNT_TWO_MOVES * 2
;			.repeat
;				mov		ecx,2
;				call	esi	;invoke	CubeMove,ebx,edi,2
;				.break.if eax
;				add		edi,2
;				mov		esi,lpCubeMove
;			.until edi>=offset TwoMoves + CNT_TWO_MOVES * 2	;lpEnd
;			.if !eax
;				cmp		nMaxMoves,3
;				jb		@exit
;				lea		edi,[ebx].SeqBuffer
;				mov		ecx,(sizeof FINDSEQ.SeqBuffer + sizeof FINDSEQ.dwPad) / sizeof DWORD
;				movc	eax,-1
;				push	edi
;					rep		stosd
;				pop		edi
;				;invoke	RtlFillMemory,edi,sizeof FINDSEQ.SeqBuffer + sizeof FINDSEQ.dwPad,-1
;				mov		nCurrMoves,3
;				;Now we need to start searching starting with 3-move sequences. The first sequence is
;				;CM_LEFT,CM_LEFT,CM_LEFT; but it will be optimized into CM_LEFTX which is a 1-move
;				;sequence and we have prevoiusly tried all 1-move sequences. Next is
;				;CM_LEFTX,CM_LEFT,CM_LEFT; but CM_LEFTX and CM_LEFT are opposite moves so they will
;				;be eliminated by optimizer and we will have 1 CM_LEFT move left. We have tried all
;				;1-move sequences. Next is
;				;CM_RIGHT,CM_LEFT,CM_LEFT. This one will not be changed by optimizer. So we can use
;				;it as a starting sequence. But NextSeq() makes one step ahead, so if we want to start
;				;with CM_RIGHT,CM_LEFT,CM_LEFT then we need to put CM_LEFTX,CM_LEFT,CM_LEFT into
;				;sequence buffer, NextSeq() will step it to CM_RIGHT,CM_LEFT,CM_LEFT and we will
;				;actually start with this initial value.
;				mov		dword ptr [edi],CM_LEFTX + (CM_LEFT shl 8) + (CM_LEFT shl 16) + (-1 shl 24)
;				;In the following loop we need to do this:
;				;1. Advance move sequence in .SeqBuffer to next sequence
;				;2. Check if any portion of current sequence can be eliminated or changed to smaller sequence.
;				;	If current sequence can be shrinked even by one move then it becomes one of the sequences that
;				;	we have tried already, so we do not need to try it again and we go to advance
;
;				;	to the next sequence and following checking again until an unshrinkable sequence is found.
;					;inc 1st move
;					;if it is 11 then zero it and inc the next move and so on
;					;if moves at last inc position can be shrinked then inc it again until unshrinkable
;					;then step one move back and check for shrinking again.
;					;when final unshrinkable sequence is obtained, then convert the sequence to
;					;a sequence of function addresses in .arrMoveAddr
;					;and call lpCubeMove for the sequence
;					;push	ebx
;				mov		ecx,nCurrMoves
;				mov		edx,nMaxMoves
;				movc	eax,0
;				;must enter the loop with EAX==0,ECX==nCurrMoves,EDX==nMaxMoves
;				;here EAX is always 0 as checked in the end of the loop
;align 16
;				.repeat
;;@nextmove:
;					inc		eax		;eax=1
;					movc	esi,0
;@nextseq:
;					add		eax,[edi+esi]
;					mov		edx,edx	;filler to avoid stall
;					;.if al<=CM_BACKX
;					cmp		al,CM_BACKX
;					ja		@incmove

;					mov		[edi+esi],eax
;					;now check if this sequence can be shrinked
;					;here we check for two cases:
;					;1. opposite moves next to each other
;					;2. at least 3 same moves are in a row
;;					xchg	edx,edx
;;					xor		al,ah
;;					jz		@0eq1	;if 1st two chars are equal
;;					cmp		al,1
;;					je		@nextseq;@contra	;if 1st two chars are opposite moves
;align 16
;					.repeat
;						mov		eax,[edi+esi]	;get next four chars
;						xchg	edx,edx	;filler for code alignment and stall prevention
;						xor		al,ah
;						jz		@0eq1	;if 1st two chars are equal
;						cmp		al,1
;						je		@contra	;if 1st two chars are opposite moves
;@retloop:
;						dec		esi
;					.until SIGN?
;@domove:
;					;the following 2 instructions allow function address to be loaded
;					;before it is used and to improve pairing
;					mov		al,bStats
;					mov		ecx,nCurrMoves
;					test	al,fSEARCHING
;					jz		@exit
;					;we need to restore nCurrMoves here since it is changed in CubeMove but not in CubeMoveXmm
;					call	lpCubeMove	;call	CubeMove,ebx,edi,ecx
;				.until eax
;				nop
;;				;if it has never been found then leave 0 in nResult and exit
;				jmp		@found
;
;align 8
;@0eq1:	;.if ah==byte ptr [edi+esi+2];if 3 same moves in a row
;						shr		eax,8
;						cmp		al,ah
;						;cmp		ah,byte ptr [edi+esi+2]
;						jne		@retloop
;align 8
;@contra:
;						mov		eax,1
;						jmp		@nextseq
;align 8
;@incmove:
;					mov		eax,1	;mov		al,1
;					movc	byte ptr [esi+edi],0
;					mov		edx,nMaxMoves
;					inc		esi	;add		esi,1
;					mov		ecx,nCurrMoves
;					cmp		esi,edx	;if curr pos in moves buffer reaches buffer end then exit
;					jae		@exit
;					;if incrementing we have not reached the highest num yet
;					;then just continue without incrementing current length of moves in sequence buffer
;					;.continue .if esi<ecx
;					cmp		esi,ecx
;					jb		@nextseq
;					add		ecx,1
;					inc		nCurrMoves
;					jmp		@nextseq
;
;;align 16
;;@optloop:
;;					.repeat
;;						mov		eax,[edi+esi]	;get next four chars
;;						xchg	edx,edx	;filler for code alignment and stall prevention
;;						xor		al,ah
;;						jz		@0eq1	;if 1st two chars are equal
;;						cmp		al,1
;;						je		@contra	;if 1st two chars are opposite moves
;;@retloop:
;;						dec		esi
;;					.until SIGN?
;;
;;
;
;@found:
;				mov		ecx,nCurrMoves
;				push	ecx
;					mov		esi,lpSeq
;					invoke	RtlMoveMemory,esi,edi,ecx
;				pop		ecx
;				movc	byte ptr [esi+ecx],-1
;				jmp		@result
;			.endif
;			movc	eax,-1
;			mov		edx,lpSeq
;			mov		ax,word ptr [edi]
;			movc	ecx,2
;			mov		dword ptr [edx],eax
;		.else
;			movc	eax,-1
;			mov		edx,lpSeq
;			mov		al,byte ptr [edi]
;			movc	ecx,1
;			mov		dword ptr [edx],eax
;		.endif
;@result:
;		mov		nResult,ecx
;@exit:
;	.endif
;	return nResult
;
;;EBX - ptr FINDSEQ struct
;;ESI - ptr to this function
;;EDI - ptr to sequence buffer
;;ECX - amount of moves to execute from the buffer
;align 16
;@CallCmpCubeXmm:
;	movdqa	xmm0,[ebx].SrcCube.CubeSide0
;	movdqa	xmm1,[ebx].SrcCube.CubeSide2
;	movdqa	xmm2,[ebx].SrcCube.CubeSide4
;	movc	eax,0
;	sub		edx,edx	;use EDX as offset into lpMoves in EDI
;align 16
;	.repeat
;		mov		al,[edi+edx]
;		xchg	ecx,ecx	;filler to avoid stall and to align code
;		mov		eax,[eax*sizeof DWORD + offset XmmFuncAddr]
;		add		edx,1;inc		edx
;		call	eax
;		movc	eax,0
;	.until edx>=ecx
;	;we don't use call to CubeMoveXmm to speed up execution
;;	lea		esi,[ebx].SrcCube
;;	call	CubeMoveXmm
;	;now compare cubes with SSE2 too
;	pcmpeqb	xmm0,[ebx].DestCube.CubeSide0
;	pcmpeqb	xmm1,[ebx].DestCube.CubeSide2
;	pcmpeqb	xmm2,[ebx].DestCube.CubeSide4
;	pand	xmm0,xmm1
;	pand	xmm0,xmm2
;	;if ax==-1 then cubes match so return TRUE
;	;else cubes don't match so return FALSE
;	pmovmskb	edx,xmm0
;	movc	eax,0
;	add		dx,1
;	adc		eax,eax
;	retn
;
;;EBX - ptr FINDSEQ struct
;;ESI - ptr to this function
;;EDI - ptr to sequence buffer
;;ECX - amount of moves to execute from the buffer
;align 16
;@CallCmpCube:
;	push	edi
;		mov		edx,ecx
;			xchg	eax,edi
;				lea		esi,[ebx].SrcCube
;				lea		edi,[ebx].CurrCube
;				mov		ecx,sizeof CUBE / sizeof DWORD
;				push	edi
;					rep		movsd
;				pop		esi
;			xchg	eax,edi
;		mov		ecx,edx
;		call	CubeMove
;		lea		edi,[ebx].DestCube
;		;now ESI is still pointing to CurrCube where we have the result of moves
;		;and EDI is pointing to DestCube with which we will compare resulting cube in CurrCube
;		mov		ecx,sizeof CUBE / sizeof DWORD
;		movc	eax,0
;		repe	cmpsd
;		sete	al
;	pop		edi
;	retn
;
;;	;mov		esi,offset dbSide;lpCube	;offset dbSide;
;;	;mov		edi,lpMoves
;;	;mov		ecx,cbMoves
;;	assume ebx:ptr FINDSEQ
;;	lea		edx,[ebx].DestCube
;;	;from now on EDX may not be changed
;;		mov		esi,ebx	;lea		esi,[ebx].SrcCube
;;		assume esi:ptr CUBE
;;		;ESI is always lpCube
;;		;EDI is lpMoves
;;		movdqa	xmm0,[esi].CubeSide0
;;		movc	eax,0
;;		xmm_mov	xmm1,[esi].CubeSide2
;;		lea		ebx,[edi+ecx]	;calc lpEnd for the latter loop
;;		xmm_mov	xmm2,[esi].CubeSide4
;;		;assume is done for the functions themselves
;;align 16
;;		.repeat
;;			mov		al,[edi]
;;			mov		eax,[eax*sizeof DWORD + offset XmmFuncAddr]
;;			add		edi,1
;;			call	eax
;;			movc	eax,0
;;		.until edi>=ebx
;;		;save data to memory
;;;		movdqa	[esi].CubeSide0,xmm0
;;;		movdqa	[esi].CubeSide2,xmm1
;;;		movdqa	[esi].CubeSide4,xmm2
;;	mov		edi,edx
;;	assume edi:ptr CUBE
;;	;compare cubes with SSE2 too
;;	pcmpeqb	xmm0,[edi].CubeSide0
;;	pcmpeqb	xmm1,[edi].CubeSide2
;;	pcmpeqb	xmm2,[edi].CubeSide4
;;	pand	xmm0,xmm1
;;	movc	eax,FALSE
;;	pand	xmm0,xmm2
;;	;if ax==-1 then cubes match so return TRUE
;;	;else cubes don't match so return FALSE
;;	pmovmskb	edx,xmm0
;;	add		dx,1
;;	adc		eax,eax
;;	ret
;
;
;;optimization loop
;;							.repeat
;;								mov		al,[edi+esi]
;;								mov		ah,[edi+esi+1]	;next char
;;								xor		al,ah
;;								.if !ZERO?
;;									;.if al==1
;;									cmp		al,1
;;									jne		@nxch
;;									mov		ah,0
;;									jmp		@nextseq
;;								.endif
;;								.if ah==byte ptr [edi+esi+2];if 3 same moves
;;									mov		eax,1
;;									jmp		@nextseq
;;								.endif
;;@nxch:
;;								sub		esi,1
;;							.until SIGN?
;;							.break
;
;assume ebx:nothing
;
;FindSeq endp



;old stuff after this line


;;This function takes a CUBE structure and searches for a shortest sequence of moves
;;that are required to get the given CUBE pattern out of a fully assembled Rubik's cube.
;;This allows to find a way to assemble virtually any pattern on the cube.
;;In dwMaxMoves you can set the maximum amount of moves that can be used to assmeble the cube,
;;kind of like a limit of possible moves. If dwMaxMoves==NULL then the amount of moves is
;;limited by free memory of the computer or 4294967295, i.e. the maximum amount of in 32 bits.
;;IN
;;lpCube - ptr to CUBE structure that contains cube status that we want to reach
;;IN,OUT
;;lpMoveSeq - ptr to byte array that will contain the resulting sequence of moves
;;			required to reach the requested cube state
;;cbMoveSeq - ULONG var. It is maximum amount of basic cube moves that can be saved into the array
;;RETURN
;;return amount of moves that have been saved to the given array
;;if there was an error or the required cube was just an assembled cube then return 0
;FindSeq proc uses ebx esi edi lpCube:DWORD,lpMoveSeq:DWORD,cbMoveSeq:DWORD
;	LOCAL	cbCurrLength:DWORD
;	LOCAL	dwESP:DWORD		;keep original ESP value here
;	LOCAL	boolResult:DWORD
;	LOCAL	cbSeqBuffer:DWORD
;	LOCAL	lpSeqBuffer:LPVOID
;	LOCAL	lpAsmdCube:LPVOID
;	LOCAL	lpDestCube:LPVOID
;	LOCAL	lpCurrCube:LPVOID
;
;	xor		eax,eax
;	mov		dwESP,esp
;	mov		cbCurrLength,eax	;cbCurrLength=0;
;	;make sure the buffers in stack memory will be alighned to 16
;	and		esp,-16
;	;boolResult=FALSE;
;	mov		boolResult,eax
;	;Allocate room for the sequence buffer. It first is filled with 0's. Then we start incre-
;	;menting the each byte until it reaches 12. If 12 then set current move to CM_LEFT==NULL
;	;and increment the next byte in array.
;	;If the buffer is less than one kilobyte we can allocate a buffer for it in the stack
;	;which would hopefully speed up the process.
;	;Else use the buffer itself regardless of its current location
;	mov		ecx,cbMoveSeq
;	.if ecx!=NULL
;		.if ecx>SEQBUFFER_SIZE
;			mov		eax,lpMoveSeq
;		.else
;			mov		edx,ecx
;			alignValueMin edx,16
;			sub		esp,edx
;			mov		eax,esp
;		.endif
;		mov		cbSeqBuffer,ecx
;		mov		lpSeqBuffer,eax
;		;zero out the buffer
;		invoke	RtlFillMemory,eax,ecx,-1;lpSeqBuffer,cbSeqBuffer,0
;		;make buffer for assembled cube structure
;		;this buffer will be used to initialize CurrCube before each attempt to find a sequence
;		;because each search must start with an assembled cube so we will need to fill
;		;current cube with assembled cube data before each search and we want to do it fast 
;		add		esp,-sizeof CUBE
;		mov		eax,esp
;		mov		lpAsmdCube,eax
;		invoke	RtlMoveMemory,eax,offset AsmCube,sizeof CUBE
;		;here we will keep the CUBE structure with the destination state of the cube
;		;this is the CUBE that we will be looking for and it is the one that is passed to
;		;this function in lpCube
;		;in the end of each attempt to find a sequence we will compare the resulting CUBE
;		;with this particular CUBE structure and we also want to have the data at hand
;		;so that we do the compare quickly
;		add		esp,-sizeof CUBE
;		mov		eax,esp
;		mov		lpDestCube,eax
;		invoke	RtlMoveMemory,eax,lpCube,sizeof CUBE
;		;now here we will check if the requested cube is an assembled cube
;		;if so then don't do anything, just exit with 0
;		;invoke	CmpCubes,lpDestCube,lpAsmdCube
;		nop
;		xor		eax,eax
;		nop
;		.if !eax
;			;Allocate room for the current cube. This is the CUBE structure that will be accessed
;			;the most. And we want all of our data to be at hand
;			add		esp,-sizeof CUBE
;			mov		lpCurrCube,esp
;			;now try all possible sequences until you find one or can't search any more
;			.repeat
;				
;			.until eax
;;			 .repeat
;			.while TRUE
;@notstep:
;				invoke	NextSeq,lpSeqBuffer,cbSeqBuffer,1
;				.break.if eax==-1
;				.if !eax
;					inc		cbCurrLength	;start with encreasing current amount of moves
;					mov		ecx,cbSeqBuffer
;					;if !(cbCurrLength++ == ) then exit loop with eax==NULL from the previous call
;					.break.if ecx < cbCurrLength
;				.endif
;				invoke	RtlMoveMemory,lpCurrCube,lpAsmdCube,sizeof CUBE
;				invoke	CubeMove,lpCurrCube,lpSeqBuffer,cbCurrLength
;				;invoke	CmpCubes,lpDestCube,lpCurrCube
;				.if eax!=FALSE
;				;if cubes are equal then exit loop with eax==TRUE
;					inc		boolResult
;					.break
;				.endif
;				;if the desired sequence was not found then set it to the next sequence and try again
;			.endw
;;			 .until edx==0
;			mov		edx,lpSeqBuffer
;			.if boolResult!=FALSE && edx!=lpMoveSeq
;			;if we have found a sequence successfully
;			;and we were not working off the buffer itself
;			;then copy data in the sequence buffer into the given one in parameters
;				invoke	RtlMoveMemory,lpMoveSeq,lpSeqBuffer,cbSeqBuffer
;			.endif
;		.endif
;	.endif
;	;now we are exiting
;	mov		eax,cbCurrLength
;	;restore original ESP value
;	mov		esp,dwESP
;	ret
;
;FindSeq endp
;
;PURPOSE
;this function takes the given array of moves and sets its byte(s) to the next available number
;up to 12

;IN
;lpSeqBuf - ptr to sequnce array
;cbSeqBuf - size of the array

;RET
;return a positive integer that indicates the current amount of moves
;or
;return -1 if there is no more room in the buffer as indicated by cbSeqBuf

;align 16
;NextSeq proc uses ebx esi lpSeqBuf:DWORD,cbSeqBuf:DWORD,cntMoves:DWORD
;	
;	movc	ebx,0
;	mov		esi,lpSeqBuf
;	mov		ecx,cbSeqBuf
;	mov		edx,cntMoves
;	lea		eax,[ebx+1]
;	.if ecx!=NULL
;align 8
;		.while TRUE;repeat						;AL=1
;			add		al,[esi+ebx]	;AL=1+[ebx]
;			.if al<12
;				mov		[esi+ebx],al
;				return edx	;cntMoves
;				align 16
;			.endif
;			mov		byte ptr [esi+ebx],ah;0
;			sub		al,11	;AL = 1
;			add		ebx,1
;			.break.if ebx>=ecx
;			.continue.if ebx<edx
;			lea		edx,[ebx+1]
;		.endw	;until ebx>=ecx;ZERO?
;	.endif
;	lea		eax,[ecx-1]
;	ret
;align 16
;NextSeq endp

;--------------------------------------------------------------------------------

;PURPOSE
;analyse given sequence of moves and optimize moves
;if there are two opposite moves next to each other (LEFT,LEFT' or TOP,TOP')
	;then eliminate this sequence completely
;if there are 4 same moves in a row (RIGHT,RIGHT,RIGHT,RIGHT)
	;then eliminate this sequence completely
;if there are 3 same moves in a row (FRONT,FRONT,FRONT)
	;then replace it with one opposite move (FRONT')

;IN
;lpMoves - ptr to buffer with source sequence
;cbMoves - amount of moves in the source sequence
;lpOptMoves - ptr to buffer for dest sequence
;cntLevels - count of max levels of optimisation (optimisation iterations) allowed
	;zero in cntLevels means no limit: iterations will stop when there is nothing more
	;to optimize

;RET
;amount of moves in optimized sequence

;REMARKS
;the buffer in (MOVES ptr [esi]).lpMoves must be at least 4 bytes longer than (MOVES ptr [esi]).cbMoves value
;This is a highly optimized function. It was primarily optimized for fast execution.
;Inner loop in particular.
;In the end after the function's code you can find the code of the inner loop as it
;was originally. It was not as fast though. Most possible sequences had to do series of
;jumps that could be eliminated.

;align 16
;OptimizeMoves proc uses ebx esi edi lpMoves:LPVOID,cbMoves:DWORD,lpOptMoves:LPVOID,cntLevels:DWORD
;
;	mov		esi,lpMoves
;	mov		eax,cbMoves
;	mov		edi,lpOptMoves
;	.if eax!=0
;		.repeat
;			push	eax	;mov		cntPrevMoves,eax
;			push	edi
;				mov		ecx,eax
;				lea		ebx,[esi+eax]
;				neg		ecx
;align 16
;				.repeat
;@LoopStart:
;					mov		eax,[ebx+ecx]
;					movc	edx,0
;					;later will need to change the function to save ptrs to functions
;					;into the given dest array
;					;movzx	edx,al
;					;mov		edx,[edx+sizeof DWORD+offset XmmFuncAddr]
;					;mov		[edi],edx
;					mov		[edi],al
;					.if ecx<=-2
;						cmp		al,ah
;						je		@bytesEq
;						;.if al!=ah
;@IsOpposite:
;						;shr		al,1
;						;adc		dl,dh	;0
;						;shr		ah,1
;						;adc		dl,dh	;0
;						;and		dl,1	;leave 0th bit intact
;						xor		al,ah
;						;we use XOR here for comparing al and ah
;						;we need the lowest bit to be different
;						;and the rest of the bits to be equal
;						;then we know we have two opposite moves
;						;we XOR AL,AH. If lowest bits were different then result
;						;in lowest bit will be 1. If the rest of the bits in each
;						;register are equal then they all will be set to 0.
;						;this is why we compare the resutl with 01h
;						cmp		al,01h
;						je		@oppositeMoves
;@normal:
;					.endif
;					lea		edi,[edi+1]	;this does not affect EFLAGS
;					add		ecx,1
;				.until ZERO?
;				jmp		@ExitLoop
;@bytesEq:
;align 16
;				;if al==ah
;					shr		eax,8
;					.if al!=ah
;						;.if ecx<=-3
;						cmp		ecx,-3
;						jg		@normal
;							lea		edi,[edi+1]
;							add		ecx,1
;							mov		[edi],al
;							jmp		@IsOpposite
;						;.endif
;					.endif
;					;now if first 3 moves are equal
;					;check the 4th move
;					shr		eax,8
;					.if al==ah	; && ecx<=-4
;					;here we have all 4 moves the same so skip them all if we have room
;						add		ecx,4
;						js		@LoopStart
;						je		@ExitLoop
;						add		ecx,-4
;align 8
;					.endif
;					;.if ecx<=-3
;					;try to convert 3 moves into one opposite
;						notfl	al,01	;invert the move
;						add		ecx,3
;						;.if SIGN?
;						jg		@F
;							mov		[edi],al;save inverted move
;							lea		edi,[edi+1]
;							js		@LoopStart
;							jmp		@ExitLoop	;je		@ExitLoop
;						;.endif
;@@:
;						add		ecx,-3
;						jmp		@normal
;;						.continue
;					;.endif
;align 16
;@oppositeMoves:
;				;.if al==01h
;				;if lowest bits in al and ah were different
;				;and the rest of bits were equal
;				;then we have opposite moves next to each other
;				;so remove them completely
;					add		ecx,2
;					js		@LoopStart	;jne		@LoopStart
;;					jmp		@ExitLoop
;					;.continue
;				;.endif
;@ExitLoop:
;			pop		eax
;			pop		edx	;mov		edx,cntPrevMoves
;			xchg	eax,edi
;			sub		eax,edi
;			mov		esi,edi
;			.break.if eax<=1 || edx<=eax

;			;if sequence is 0 or 1 then exit loop: in this case there can't be anything to optimize
;			;if optimized sequence length == source sequence length then exit loop
;			;because last attempt to optimize gave no optimization
;			dec		cntLevels
;		.until ZERO?
;		
;	.endif
;	ret
;
;original inner loop
;align 16
;				.repeat
;					mov		eax,[ebx+ecx]
;					movc	edx,0
;					mov		[edi],al
;					.if ecx<=-2
;						.if al!=ah
;@IsOpposite:
;							;shr		al,1
;							;adc		dl,dh	;0
;							;shr		ah,1
;							;adc		dl,dh	;0
;							;and		dl,1	;leave 0th bit intact
;							xor		al,ah
;							;we use XOR here for comparing al and ah
;							;we need the lowest bit to be different
;							;and the rest of the bits to be equal
;							;then we know we have two opposite moves
;							;we XOR AL,AH. If lowest bits were different then result
;							;in lowest bit will be 1. If the rest of the bits in each
;							;register are equal then they all will be set to 0.
;							;this is why we compare the resutl with 01h
;							.if al==01h
;							;if lowest bits in al and ah were different
;							;and the rest of bits were equal
;							;then we have opposite moves next to each other
;							;so remove them completely
;								add		ecx,2
;								.continue
;							.endif
;align 8
;						.else ;if al==ah
;							shr		eax,8
;							.if al==ah
;							;now if first 3 moves are equal
;							;check the 4th move
;								shr		eax,8
;								.if al==ah
;								;here we have all 4 moves the same so skip them all if we have room
;									.if ecx<=-4
;										add		ecx,4
;										.continue
;									.endif
;								.endif
;								.if ecx<=-3
;								;try to convert 3 moves into one opposite
;									notfl	al,01	;invert the move
;									add		ecx,3
;									mov		[edi],al;save inverted move
;									lea		edi,[edi+1]
;									.continue
;								.endif
;align 4
;							.else
;								.if ecx<=-3
;									add		edi,1
;									add		ecx,1
;									mov		[edi],al
;									jmp		@IsOpposite
;align 8
;								.endif
;							.endif
;						.endif
;					.endif
;					lea		edi,[edi+1]	;this does not affect EFLAGS
;					add		ecx,1
;align 8
;				.until ZERO?
;

;OptimizeMoves endp

;--------------------------------------------------------------------------------

;PURPOSE
;compare to memory blocks

;IN
;lpMem0 - ptr to memory0
;lpMem1 - ptr to memory1
;cb - size of buffer to be compared

;RET
;FALSE if not equal
;TRUE if equal

;REMARKS
;cb must be divisible by 4 without a remainder: then it will be fast

;CmpMem proc uses esi edi lpMem0:LPVOID,lpMem1:LPVOID,cb:DWORD
;	
;	cld
;	mov		esi,lpMem0
;	mov		edi,lpMem1
;	mov		ecx,cb
;	mov		edx,ecx
;	shr		ecx,2
;	and		edx,3
;	.if ZERO?
;		repe	cmpsd
;		sete	al
;		ret
;	.endif
;	mov		ecx,cb
;	add		esi,ecx
;	add		edi,ecx
;	neg		ecx
;	.while !ZERO?
;align 8
;		mov		al,[esi+ecx]
;		cmp		al,[edi+ecx]
;		jne		@NE
;		add		ecx,1
;	.endw
;	lea		eax,[ecx+1]
;@ret:
;	ret
;@NE:
;	xor		eax,eax
;	jmp		@ret
;;	 .if ZERO?
;;		 inc	 eax
;;	 .endif
;
;CmpMem endp

;--------------------------------------------------------------------------------

;return BOOL
;if cube structures are equal then return TRUE else return FALSE
;CmpCubes proc uses esi edi lpCube0:LPVOID,lpCube1:LPVOID
;	
;	xor		eax,eax
;	mov		esi,lpCube0
;	xor		ecx,ecx
;	mov		edi,lpCube1
;	mov		cl,sizeof CUBE / sizeof DWORD
;	cld
;	repe	cmpsd
;	sete	al
;;	 .if ZERO?
;;		 inc	 eax
;;	 .endif
;	ret
;
;CmpCubes endp

;lpCubeSides points to an array of SIDE structures representing sides of the cube
;so all together they make up a CUBE structure

;CheckCube proc uses ebx esi edi lpCubeSides:LPVOID
;	LOCAL	xCube:CUBE
;	;LOCAL	 CurrCube:CORNER_CUBE
;	LOCAL	dwGetLowByte:DWORD	;will contain 000000FFh for use in clearing all but lowest byte
;;	 LOCAL	 ofs1stSqr:DWORD
;;	 LOCAL	 ofs2ndSqr:DWORD
;;	 LOCAL	 ofs3rdSqr:DWORD
;
;	cld
;	mov		esi,lpCubeSides
;	mov		dwGetLowByte,000000FFh
;	;fill xCube with -1
;	;so that later we can detect if all the 
;	lea		edi,xCube
;	mov		ecx,sizeof CUBE / sizeof DWORD
;	or		eax,-1
;	mov		ebx,offset FullCube0
;	;fill xSides with -1
;	rep		stosd
;	xor		edi,edi
;	.while edi<sizeof CUBE
;		.if byte ptr [xCube+edi]==-1
;		;if this square was not dealt with yet then work with it
;			mov		al,[esi+edi]
;			xor		ecx,ecx
;			mov		edx,[ebx+edi*sizeof CORNER_CUBE]
;			mov		cl,dh
;			and		edx,dwGetLowByte
;			lea		edx,[ecx+edx*sizeof SIDE]
;			mov		ah,[esi+edx]
;			xor		ecx,ecx
;			mov		edx,[ebx+edi*sizeof CORNER_CUBE+2]
;			mov		cl,dh
;			and		edx,dwGetLowByte
;			lea		edx,[ecx+edx*sizeof SIDE]
;			mov		dl,[esi+edx]
;			and		edx,dwGetLowByte
;			shr		edx,16
;			add		eax,edx
;			nop
;			nop
;			mov		[xCube+edi],al
;			
;			push	edi
;				xor		ecx,ecx
;				;EDI = (nthSide * sizeof SIDE) + CurrSquare
;				mov		edx,[ebx+edi*sizeof CORNER_CUBE]	;now get coords from FullCube
;				xor		eax,eax
;				;save the value for later use
;				mov		dword ptr [CurrCube],edx
;				;mov	 ofs1stSqr,edi
;				mov		al,[esi+edi]
;				;.if edx & 80000000h
;				cmp		edx,0	;to find out the sign
;				jns		@edge
;					;if it is a corner cube then treat it this way
;					;now we need to put the second color into AH
;					mov		cl,dh
;					shr		edx,12	;(HiHalfbyte(DH) = DL)
;					and		ecx,07h
;					and		edx,07h
;					lea		edx,[ecx+edx*sizeof SIDE]
;					mov		ah,[esi+edx]
;					;mov	 dl,CurrCube.Side2
;					mov		cl,dl
;					shr		cl,4
;					and		edx,07h
;					;and now we will put the last color of the corner cube into 3rd byte in EDX
;					;and add AX 
;					lea		edx,[edx+ecx*sizeof SIDE]
;					mov		dl,[esi+edx]
;					shl		edx,16
;					add		edx,eax ;in EDX we will keep the gotten set of colors
;					and		edx,0007FFFFh
;					shl		edx,4
;					;now we got all the colors for the cube and we know that it is a
;					;corner cube so look up where this cube must be
;					xor		ecx,ecx
;					.while ecx<sizeof CUBE
;						mov		eax,[ebx+ecx*sizeof CORNER_CUBE]
;						;if it's not a corner cube then skip it
;						cmp		eax,0
;						jns		@F
;							and		eax,00707070h
;							.if eax==edx
;							;if finally found the cube then paint it in local cube 
;								nop
;								.break
;							.endif
;@@:
;						inc		ecx
;					.endw
;				jmp		@eoc
;	@edge:
;				;.else
;					;else it is an edge cube
;					nop
;	@eoc:
;				;.endif
;				nop
;			pop		edi
;			inc		edi
;		.endif
;	.endw
;	;now search xCube for -1 in any byte
;	;if found then there was an error in incoming cube
;	nop
;	ret
;
;CheckCube endp
;
;--------------------------------------------------------------------------------




;		mov		lpCubeMove,eax
;;		.if !eax
;;			mov		eax,offset CubeMove
;;		.else
;;			mov		eax,offset CubeMoveXmm
;;		.endif
;;		mov		lpCubeMove,eax
;;		invoke	RtlFillMemory,offset SeqBuffer,sizeof SeqBuffer,-1
;		movc	ebx,1

;		;in 1st loop do all 1-move sequences
;		;in 2nd loop do all 2-move sequences
;		;in 3rd loop do all the others
;		.while TRUE
;			;EBX will hold the real amount of moves
;			;EDI will hold the optimized amount of moves
;;			invoke	RtlMoveMemory,offset CurrCube,offset AsmCube,sizeof CUBE
;			;SeqBuffer must be previously filled with -1 before being used in current loop
;			;make the following call an inline function!
;;			invoke	NextSeq,offset SeqBuffer,MAX_MOVES,ebx
;			.break.if eax==-1
;			xchg	eax,ebx
;;			invoke	OptimizeMoves,offset SeqBuffer,ebx,offset SeqBufferOpt,0
;			.continue.if eax==0
;			mov		nOptMoves,eax
;			.if ebx>2; && eax>1
;				;if original moves length is more than 2 and optimized size is 2 or less
;				;then this sequence has already been tried before so go to next sequence
;				.continue.if eax<=2
;				.if eax==nPrevMoves
;;					invoke	CmpMem,offset SeqBufferPrev,offset SeqBufferOpt,eax
;					.continue.if eax
;				.endif
;				nop
;				mov		eax,nOptMoves
;			.endif
;			mov		nPrevMoves,eax
;;			invoke	RtlMoveMemory,offset SeqBufferPrev,offset SeqBufferOpt,eax
;			
;;				mov		esi,offset Consts
;;				;assume is done for the functions themselves
;;				mov		edx,sizeof Consts / sizeof OWORD
;;				;put Consts array into cache
;;				.repeat
;;					mov		eax,dword ptr [esi]
;;					add		esi,sizeof OWORD
;;					sub		edx,1
;;				.until ZERO?
;;				;restore ESI to ptr Consts
;;				add		esi,-sizeof Consts
;				xmm_setconst
;				mov		ecx,1
;;				mov		edi,offset Moves2
;;				mov		esi,offset CurrCube
;			invoke	CubeMove;,offset CurrCube,offset Moves2,1;X_MOVES
;							mov		ecx,1

;;				mov		edi,offset Moves2
;;				mov		esi,offset CurrCube
;			invoke	CubeMoveXmm;,offset CurrCube,offset Moves2,1;X_MOVES
;			rdtsc
;			nop
;			time_begin
;;				mov		ecx,X_MOVES
;;				mov		edi,offset Moves2
;;				mov		esi,offset CurrCube
;			invoke	CubeMove;,offset CurrCube,offset Moves2,X_MOVES
;			time_end
;			push	edx
;			push	eax
;				nop
;				rdtsc
;				nop
;				time_begin; ebx,edi
;;				mov		ecx,X_MOVES
;;				mov		edi,offset Moves2
;;				mov		esi,offset CurrCube
;				invoke	CubeMoveXmm;,offset CurrCube,offset Moves2,X_MOVES
;				time_end; ebx,edi
;				mov		hInstance,eax
;				nop
;			pop		[hInstance+4];ebx
;			pop		edi
;			invoke	wsprintf,offset szOut,offset szFrmt,[hInstance+4],hInstance
;			invoke	MessageBox,0,offset szOut,offset AppName,MB_OK
;			invoke	ExitProcess,0
;			;invoke	CubeMoveMmx,offset CurrCube,offset SeqBufferOpt,nOptMoves
;			;invoke	CubeMove,offset CurrCube,offset SeqBufferOpt,nOptMoves
;			.break.if !eax

;;			invoke	CmpMem,offset XCube,offset CurrCube,sizeof CUBE
;			.break.if eax
;		.endw
;	invoke ExitProcess,eax
;
;
;	;invoke	FindSeq,offset XCube,offset SeqBuffer,sizeof SeqBuffer
;;	 invoke  CubeMove,offset CurrCube,offset CycleMove1,sizeof CycleMove1;X_MOVES
;;	 invoke  CubeMove,offset CurrCube,offset CycleMove1,sizeof CycleMove1;X_MOVES
;	;invoke	CubeMoveXmm,offset CurrCube,offset Moves0,X_MOVES
;;	 invoke  CubeMove,offset CurrCube,offset Moves1,X_MOVES
;;	 invoke  CubeMove,offset CurrCube,offset Moves2,X_MOVES
;;	 invoke  CubeMove,offset CurrCube,offset Moves3,X_MOVES
;;	 invoke  CubeMove,offset CurrCube,offset Moves4,X_MOVES
;;	 invoke  CubeMove,offset CurrCube,offset Moves5,X_MOVES
;;	 invoke  CubeMove,offset CurrCube,offset Moves6,X_MOVES
;;	 invoke  CubeMove,offset CurrCube,offset Moves7,X_MOVES
;;	 invoke  CubeMove,offset CurrCube,offset Moves8,X_MOVES
;;	 invoke  CubeMove,offset CurrCube,offset Moves9,X_MOVES
;;	 invoke  CubeMove,offset CurrCube,offset Moves10,X_MOVES
;;	 invoke  CubeMove,offset CurrCube,offset Moves11,X_MOVES
;;	 mov	 edi,TIMES
;;	 cpuid
;;	 cpuid
;;	 rdtsc
;;	 push	 eax
;;	 push	 edx
;;		 .repeat
;;			 invoke  CubeMove,offset CurrCube,offset Moves0,X_MOVES
;;			 dec	 edi
;;		 .until ZERO?
;;		 rdtsc
;;		 sub	 eax,[esp+4]
;;		 sbb	 edx,[esp]
;;		 mov	 hInstance,eax
;;		 mov	 CommandLine,edx
;;		 rdtsc
;;		 mov	 edi,TIMES
;;		 push	 eax
;;		 push	 edx
;;			 .repeat
;;				 invoke  CubeMove,offset CurrCube,offset Moves1,X_MOVES
;;				 dec	 edi
;;			 .until ZERO?
;;			 rdtsc
;;			 sub	 eax,[esp+4]
;;			 sbb	 edx,[esp]
;;			 mov	 hWnd,eax
;;			 mov	 dwHiDW,edx
;;		 pop	 eax
;;		 pop	 edx
;;	 pop	 eax
;;	 pop	 edx
;;	 invoke  wsprintf,offset szOut,offset szFrmt,hInstance,hWnd
;;	 invoke  MessageBox,0,offset szOut,offset AppName,MB_OK
;;	 invoke  ExitProcess,0
;;	 
;;	invoke	CheckCube,offset AsmCube
;	nop
;;	 invoke GetModuleHandle,NULL
;;	 mov	hInstance,eax
;;	 invoke GetCommandLine
;;	 invoke InitCommonControls
;;	 mov	 CommandLine,eax
;;	 invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
;	invoke ExitProcess,eax
;

